/*!
 * 
 * Planck.js v0.3.29
 * @license The MIT license
 * @copyright Copyright (c) 2021 Erin Catto, Ali Shakiba
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 */
!function(t,i){"object"==typeof exports&&"object"==typeof module?module.exports=i():"function"==typeof define&&define.amd?define([],i):"object"==typeof exports?exports.planck=i():t.planck=i()}(window,(function(){return function(t){var i={};function e(s){if(i[s])return i[s].exports;var o=i[s]={i:s,l:!1,exports:{}};return t[s].call(o.exports,o,o.exports,e),o.l=!0,o.exports}return e.m=t,e.c=i,e.d=function(t,i,s){e.o(t,i)||Object.defineProperty(t,i,{enumerable:!0,get:s})},e.r=function(t){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},e.t=function(t,i){if(1&i&&(t=e(t)),8&i)return t;if(4&i&&"object"==typeof t&&t&&t.__esModule)return t;var s=Object.create(null);if(e.r(s),Object.defineProperty(s,"default",{enumerable:!0,value:t}),2&i&&"string"!=typeof t)for(var o in t)e.d(s,o,function(i){return t[i]}.bind(null,o));return s},e.n=function(t){var i=t&&t.__esModule?function(){return t.default}:function(){return t};return e.d(i,"a",i),i},e.o=function(t,i){return Object.prototype.hasOwnProperty.call(t,i)},e.p="",e(e.s=38)}([function(t,i,e){t.exports=o;e(2);var s=e(1);function o(t,i){if(!(this instanceof o))return new o(t,i);void 0===t?(this.x=0,this.y=0):"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i)}o.prototype._serialize=function(){return{x:this.x,y:this.y}},o._deserialize=function(t){var i=Object.create(o.prototype);return i.x=t.x,i.y=t.y,i},o.zero=function(){var t=Object.create(o.prototype);return t.x=0,t.y=0,t},o.neo=function(t,i){var e=Object.create(o.prototype);return e.x=t,e.y=i,e},o.clone=function(t){return o.neo(t.x,t.y)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&s.isFinite(t.x)&&s.isFinite(t.y)},o.assert=function(t){},o.prototype.clone=function(){return o.clone(this)},o.prototype.setZero=function(){return this.x=0,this.y=0,this},o.prototype.set=function(t,i){return"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i),this},o.prototype.wSet=function(t,i,e,s){return void 0!==e||void 0!==s?this.setCombine(t,i,e,s):this.setMul(t,i)},o.prototype.setCombine=function(t,i,e,s){var o=t*i.x+e*s.x,n=t*i.y+e*s.y;return this.x=o,this.y=n,this},o.prototype.setMul=function(t,i){var e=t*i.x,s=t*i.y;return this.x=e,this.y=s,this},o.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this},o.prototype.wAdd=function(t,i,e,s){return void 0!==e||void 0!==s?this.addCombine(t,i,e,s):this.addMul(t,i)},o.prototype.addCombine=function(t,i,e,s){var o=t*i.x+e*s.x,n=t*i.y+e*s.y;return this.x+=o,this.y+=n,this},o.prototype.addMul=function(t,i){var e=t*i.x,s=t*i.y;return this.x+=e,this.y+=s,this},o.prototype.wSub=function(t,i,e,s){return void 0!==e||void 0!==s?this.subCombine(t,i,e,s):this.subMul(t,i)},o.prototype.subCombine=function(t,i,e,s){var o=t*i.x+e*s.x,n=t*i.y+e*s.y;return this.x-=o,this.y-=n,this},o.prototype.subMul=function(t,i){var e=t*i.x,s=t*i.y;return this.x-=e,this.y-=s,this},o.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this},o.prototype.mul=function(t){return this.x*=t,this.y*=t,this},o.prototype.length=function(){return o.lengthOf(this)},o.prototype.lengthSquared=function(){return o.lengthSquared(this)},o.prototype.normalize=function(){var t=this.length();if(t<s.EPSILON)return 0;var i=1/t;return this.x*=i,this.y*=i,t},o.lengthOf=function(t){return s.sqrt(t.x*t.x+t.y*t.y)},o.lengthSquared=function(t){return t.x*t.x+t.y*t.y},o.distance=function(t,i){var e=t.x-i.x,o=t.y-i.y;return s.sqrt(e*e+o*o)},o.distanceSquared=function(t,i){var e=t.x-i.x,s=t.y-i.y;return e*e+s*s},o.areEqual=function(t,i){return t==i||"object"==typeof i&&null!==i&&t.x===i.x&&t.y===i.y},o.skew=function(t){return o.neo(-t.y,t.x)},o.dot=function(t,i){return t.x*i.x+t.y*i.y},o.cross=function(t,i){return"number"==typeof i?o.neo(i*t.y,-i*t.x):"number"==typeof t?o.neo(-t*i.y,t*i.x):t.x*i.y-t.y*i.x},o.addCross=function(t,i,e){return"number"==typeof e?o.neo(e*i.y+t.x,-e*i.x+t.y):"number"==typeof i?o.neo(-i*e.y+t.x,i*e.x+t.y):void 0},o.add=function(t,i){return o.neo(t.x+i.x,t.y+i.y)},o.wAdd=function(t,i,e,s){return void 0!==e||void 0!==s?o.combine(t,i,e,s):o.mul(t,i)},o.combine=function(t,i,e,s){return o.zero().setCombine(t,i,e,s)},o.sub=function(t,i){return o.neo(t.x-i.x,t.y-i.y)},o.mul=function(t,i){return"object"==typeof t?o.neo(t.x*i,t.y*i):"object"==typeof i?o.neo(t*i.x,t*i.y):void 0},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},o.neg=function(t){return o.neo(-t.x,-t.y)},o.abs=function(t){return o.neo(s.abs(t.x),s.abs(t.y))},o.mid=function(t,i){return o.neo(.5*(t.x+i.x),.5*(t.y+i.y))},o.upper=function(t,i){return o.neo(s.max(t.x,i.x),s.max(t.y,i.y))},o.lower=function(t,i){return o.neo(s.min(t.x,i.x),s.min(t.y,i.y))},o.prototype.clamp=function(t){var i=this.x*this.x+this.y*this.y;if(i>t*t){var e=s.invSqrt(i);this.x*=e*t,this.y*=e*t}return this},o.clamp=function(t,i){return(t=o.neo(t.x,t.y)).clamp(i),t},o.scaleFn=function(t,i){return function(e){return o.neo(e.x*t,e.y*i)}},o.translateFn=function(t,i){return function(e){return o.neo(e.x+t,e.y+i)}}},function(t,i,e){e(2);var s=Math,o=t.exports=Object.create(s);o.EPSILON=1e-9,o.isFinite=function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},o.assert=function(t){},o.invSqrt=function(t){return 1/s.sqrt(t)},o.nextPowerOfTwo=function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},o.isPowerOfTwo=function(t){return t>0&&0==(t&t-1)},o.mod=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},o.clamp=function(t,i,e){return t<i?i:t>e?e:t},o.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:s.random()*(i-t)+t}},function(t,i,e){i.debug=function(){},i.assert=function(t,i,e){}},function(t,i,e){t.exports=n;e(2);var s=e(0),o=e(1);function n(t){if(!(this instanceof n))return new n(t);"number"==typeof t?this.setAngle(t):"object"==typeof t?this.set(t):this.setIdentity()}n.neo=function(t){var i=Object.create(n.prototype);return i.setAngle(t),i},n.clone=function(t){var i=Object.create(n.prototype);return i.s=t.s,i.c=t.c,i},n.identity=function(){var t=Object.create(n.prototype);return t.s=0,t.c=1,t},n.isValid=function(t){return t&&o.isFinite(t.s)&&o.isFinite(t.c)},n.assert=function(t){},n.prototype.setIdentity=function(){this.s=0,this.c=1},n.prototype.set=function(t){"object"==typeof t?(this.s=t.s,this.c=t.c):(this.s=o.sin(t),this.c=o.cos(t))},n.prototype.setAngle=function(t){this.s=o.sin(t),this.c=o.cos(t)},n.prototype.getAngle=function(){return o.atan2(this.s,this.c)},n.prototype.getXAxis=function(){return s.neo(this.c,this.s)},n.prototype.getYAxis=function(){return s.neo(-this.s,this.c)},n.mul=function(t,i){if("c"in i&&"s"in i){var e=n.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e}if("x"in i&&"y"in i)return s.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},n.mulRot=function(t,i){var e=n.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e},n.mulVec2=function(t,i){return s.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},n.mulSub=function(t,i,e){var o=t.c*(i.x-e.x)-t.s*(i.y-e.y),n=t.s*(i.x-e.x)+t.c*(i.y-e.y);return s.neo(o,n)},n.mulT=function(t,i){if("c"in i&&"s"in i){var e=n.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e}if("x"in i&&"y"in i)return s.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)},n.mulTRot=function(t,i){var e=n.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e},n.mulTVec2=function(t,i){return s.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)}},function(t,i,e){var s=i;s.maxManifoldPoints=2,s.maxPolygonVertices=12,s.aabbExtension=.1,s.aabbMultiplier=2,s.linearSlop=.005,s.linearSlopSquared=s.linearSlop*s.linearSlop,s.angularSlop=2/180*Math.PI,s.polygonRadius=2*s.linearSlop,s.maxSubSteps=8,s.maxTOIContacts=32,s.maxTOIIterations=20,s.maxDistnceIterations=20,s.velocityThreshold=1,s.maxLinearCorrection=.2,s.maxAngularCorrection=8/180*Math.PI,s.maxTranslation=2,s.maxTranslationSquared=s.maxTranslation*s.maxTranslation,s.maxRotation=.5*Math.PI,s.maxRotationSquared=s.maxRotation*s.maxRotation,s.baumgarte=.2,s.toiBaugarte=.75,s.timeToSleep=.5,s.linearSleepTolerance=.01,s.linearSleepToleranceSqr=Math.pow(s.linearSleepTolerance,2),s.angularSleepTolerance=2/180*Math.PI,s.angularSleepToleranceSqr=Math.pow(s.angularSleepTolerance,2)},function(t,i,e){t.exports=n;e(2);var s=e(0),o=e(3);function n(t,i){if(!(this instanceof n))return new n(t,i);this.p=s.zero(),this.q=o.identity(),void 0!==t&&this.p.set(t),void 0!==i&&this.q.set(i)}n.clone=function(t){var i=Object.create(n.prototype);return i.p=s.clone(t.p),i.q=o.clone(t.q),i},n.neo=function(t,i){var e=Object.create(n.prototype);return e.p=s.clone(t),e.q=o.clone(i),e},n.identity=function(){var t=Object.create(n.prototype);return t.p=s.zero(),t.q=o.identity(),t},n.prototype.setIdentity=function(){this.p.setZero(),this.q.setIdentity()},n.prototype.set=function(t,i){void 0===i?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(i))},n.isValid=function(t){return t&&s.isValid(t.p)&&o.isValid(t.q)},n.assert=function(t){},n.mul=function(t,i){if(Array.isArray(i)){for(var e=[],r=0;r<i.length;r++)e[r]=n.mul(t,i[r]);return e}if("x"in i&&"y"in i){var m=t.q.c*i.x-t.q.s*i.y+t.p.x,a=t.q.s*i.x+t.q.c*i.y+t.p.y;return s.neo(m,a)}if("p"in i&&"q"in i){var h=n.identity();return h.q=o.mulRot(t.q,i.q),h.p=s.add(o.mulVec2(t.q,i.p),t.p),h}},n.mulAll=function(t,i){for(var e=[],s=0;s<i.length;s++)e[s]=n.mul(t,i[s]);return e},n.mulFn=function(t){return function(i){return n.mul(t,i)}},n.mulVec2=function(t,i){var e=t.q.c*i.x-t.q.s*i.y+t.p.x,o=t.q.s*i.x+t.q.c*i.y+t.p.y;return s.neo(e,o)},n.mulXf=function(t,i){var e=n.identity();return e.q=o.mulRot(t.q,i.q),e.p=s.add(o.mulVec2(t.q,i.p),t.p),e},n.mulT=function(t,i){if("x"in i&&"y"in i){var e=i.x-t.p.x,r=i.y-t.p.y,m=t.q.c*e+t.q.s*r,a=-t.q.s*e+t.q.c*r;return s.neo(m,a)}if("p"in i&&"q"in i){var h=n.identity();return h.q.set(o.mulTRot(t.q,i.q)),h.p.set(o.mulTVec2(t.q,s.sub(i.p,t.p))),h}},n.mulTVec2=function(t,i){var e=i.x-t.p.x,o=i.y-t.p.y,n=t.q.c*e+t.q.s*o,r=-t.q.s*e+t.q.c*o;return s.neo(n,r)},n.mulTXf=function(t,i){var e=n.identity();return e.q.set(o.mulTRot(t.q,i.q)),e.p.set(o.mulTVec2(t.q,s.sub(i.p,t.p))),e}},function(t,i,e){Object.prototype.propertyIsEnumerable;t.exports=function(t,i){null==t&&(t={});var e=Object.assign({},t);for(var s in i)i.hasOwnProperty(s)&&void 0===t[s]&&(e[s]=i[s]);if("function"==typeof Object.getOwnPropertySymbols)for(var o=Object.getOwnPropertySymbols(i),n=0;n<o.length;n++){var r=o[n];i.propertyIsEnumerable(r)&&void 0===t[s]&&(e[r]=i[r])}return e}},function(t,i,e){t.exports=o;e(2);var s=e(1);function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);void 0===t?(this.x=0,this.y=0,this.z=0):"object"==typeof t?(this.x=t.x,this.y=t.y,this.z=t.z):(this.x=t,this.y=i,this.z=e)}o.prototype._serialize=function(){return{x:this.x,y:this.y,z:this.z}},o._deserialize=function(t){var i=Object.create(o.prototype);return i.x=t.x,i.y=t.y,i.z=t.z,i},o.neo=function(t,i,e){var s=Object.create(o.prototype);return s.x=t,s.y=i,s.z=e,s},o.clone=function(t){return o.neo(t.x,t.y,t.z)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&s.isFinite(t.x)&&s.isFinite(t.y)&&s.isFinite(t.z)},o.assert=function(t){},o.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},o.prototype.set=function(t,i,e){return this.x=t,this.y=i,this.z=e,this},o.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},o.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},o.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},o.areEqual=function(t,i){return t==i||"object"==typeof t&&null!==t&&"object"==typeof i&&null!==i&&t.x===i.x&&t.y===i.y&&t.z===i.z},o.dot=function(t,i){return t.x*i.x+t.y*i.y+t.z*i.z},o.cross=function(t,i){return new o(t.y*i.z-t.z*i.y,t.z*i.x-t.x*i.z,t.x*i.y-t.y*i.x)},o.add=function(t,i){return new o(t.x+i.x,t.y+i.y,t.z+i.z)},o.sub=function(t,i){return new o(t.x-i.x,t.y-i.y,t.z-i.z)},o.mul=function(t,i){return new o(i*t.x,i*t.y,i*t.z)},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},o.neg=function(t){return new o(-t.x,-t.y,-t.z)}},function(t,i,e){t.exports=y;e(2);var s=e(6),o=e(0),n=e(3),r=(e(1),e(9)),m=e(5),a=e(12),h=e(13),_=e(26),c=(e(15),y.STATIC="static"),l=y.KINEMATIC="kinematic",u=y.DYNAMIC="dynamic",p={type:c,position:o.zero(),angle:0,linearVelocity:o.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null};function y(t,i){i=s(i,p),this.m_world=t,this.m_awakeFlag=i.awake,this.m_autoSleepFlag=i.allowSleep,this.m_bulletFlag=i.bullet,this.m_fixedRotationFlag=i.fixedRotation,this.m_activeFlag=i.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=i.userData,this.m_type=i.type,this.m_type==u?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=m.identity(),this.m_xf.p=o.clone(i.position),this.m_xf.q.setAngle(i.angle),this.m_sweep=new r,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new a,this.c_position=new h,this.m_force=o.zero(),this.m_torque=0,this.m_linearVelocity=o.clone(i.linearVelocity),this.m_angularVelocity=i.angularVelocity,this.m_linearDamping=i.linearDamping,this.m_angularDamping=i.angularDamping,this.m_gravityScale=i.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null,this.m_destroyed=!1}function d(){this.mass=0,this.center=o.zero(),this.I=0}y.prototype._serialize=function(){for(var t=[],i=this.m_fixtureList;i;i=i.m_next)t.push(i);return{type:this.m_type,bullet:this.m_bulletFlag,position:this.m_xf.p,angle:this.m_xf.q.getAngle(),linearVelocity:this.m_linearVelocity,angularVelocity:this.m_angularVelocity,fixtures:t}},y._deserialize=function(t,i,e){var s=new y(i,t);if(t.fixtures)for(var o=t.fixtures.length-1;o>=0;o--){var n=e(_,t.fixtures[o],s);s._addFixture(n)}return s},y.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},y.prototype.getWorld=function(){return this.m_world},y.prototype.getNext=function(){return this.m_next},y.prototype.setUserData=function(t){this.m_userData=t},y.prototype.getUserData=function(){return this.m_userData},y.prototype.getFixtureList=function(){return this.m_fixtureList},y.prototype.getJointList=function(){return this.m_jointList},y.prototype.getContactList=function(){return this.m_contactList},y.prototype.isStatic=function(){return this.m_type==c},y.prototype.isDynamic=function(){return this.m_type==u},y.prototype.isKinematic=function(){return this.m_type==l},y.prototype.setStatic=function(){return this.setType(c),this},y.prototype.setDynamic=function(){return this.setType(u),this},y.prototype.setKinematic=function(){return this.setType(l),this},y.prototype.getType=function(){return this.m_type},y.prototype.setType=function(t){if(1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==c&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var i=this.m_contactList;i;){var e=i;i=i.next,this.m_world.destroyContact(e.contact)}this.m_contactList=null;for(var s=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)for(var n=o.m_proxyCount,r=0;r<n;++r)s.touchProxy(o.m_proxies[r].proxyId)}},y.prototype.isBullet=function(){return this.m_bulletFlag},y.prototype.setBullet=function(t){this.m_bulletFlag=!!t},y.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},y.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},y.prototype.isAwake=function(){return this.m_awakeFlag},y.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},y.prototype.isActive=function(){return this.m_activeFlag},y.prototype.setActive=function(t){if(t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.createProxies(i,this.m_xf);else{for(i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.destroyProxies(i);for(var s=this.m_contactList;s;){var o=s;s=s.next,this.m_world.destroyContact(o.contact)}this.m_contactList=null}},y.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},y.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},y.prototype.getTransform=function(){return this.m_xf},y.prototype.setTransform=function(t,i){if(1!=this.isWorldLocked()){this.m_xf.set(t,i),this.m_sweep.setTransform(this.m_xf);for(var e=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)s.synchronize(e,this.m_xf,this.m_xf)}},y.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},y.prototype.synchronizeFixtures=function(){var t=m.identity();this.m_sweep.getTransform(t,0);for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.synchronize(i,t,this.m_xf)},y.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.set(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},y.prototype.getPosition=function(){return this.m_xf.p},y.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},y.prototype.getAngle=function(){return this.m_sweep.a},y.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},y.prototype.getWorldCenter=function(){return this.m_sweep.c},y.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},y.prototype.getLinearVelocity=function(){return this.m_linearVelocity},y.prototype.getLinearVelocityFromWorldPoint=function(t){var i=o.sub(t,this.m_sweep.c);return o.add(this.m_linearVelocity,o.cross(this.m_angularVelocity,i))},y.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},y.prototype.setLinearVelocity=function(t){this.m_type!=c&&(o.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.set(t))},y.prototype.getAngularVelocity=function(){return this.m_angularVelocity},y.prototype.setAngularVelocity=function(t){this.m_type!=c&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},y.prototype.getLinearDamping=function(){return this.m_linearDamping},y.prototype.setLinearDamping=function(t){this.m_linearDamping=t},y.prototype.getAngularDamping=function(){return this.m_angularDamping},y.prototype.setAngularDamping=function(t){this.m_angularDamping=t},y.prototype.getGravityScale=function(){return this.m_gravityScale},y.prototype.setGravityScale=function(t){this.m_gravityScale=t},y.prototype.getMass=function(){return this.m_mass},y.prototype.getInertia=function(){return this.m_I+this.m_mass*o.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},y.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.set(this.m_sweep.localCenter)},y.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.set(this.m_xf.p),this.m_sweep.c.set(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);for(var t=o.zero(),i=this.m_fixtureList;i;i=i.m_next)if(0!=i.m_density){var e=new d;i.getMassData(e),this.m_mass+=e.mass,t.addMul(e.mass,e.center),this.m_I+=e.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*o.dot(t,t),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var s=o.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(o.cross(this.m_angularVelocity,o.sub(this.m_sweep.c,s)))},y.prototype.setMassData=function(t){if(1!=this.isWorldLocked()&&this.m_type==u){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*o.dot(t.center,t.center),this.m_invI=1/this.m_I);var i=o.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(o.cross(this.m_angularVelocity,o.sub(this.m_sweep.c,i)))}},y.prototype.applyForce=function(t,i,e){this.m_type==u&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=o.cross(o.sub(i,this.m_sweep.c),t)))},y.prototype.applyForceToCenter=function(t,i){this.m_type==u&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},y.prototype.applyTorque=function(t,i){this.m_type==u&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},y.prototype.applyLinearImpulse=function(t,i,e){this.m_type==u&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.addMul(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*o.cross(o.sub(i,this.m_sweep.c),t)))},y.prototype.applyAngularImpulse=function(t,i){this.m_type==u&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},y.prototype.shouldCollide=function(t){if(this.m_type!=u&&t.m_type!=u)return!1;for(var i=this.m_jointList;i;i=i.next)if(i.other==t&&0==i.joint.m_collideConnected)return!1;return!0},y.prototype._addFixture=function(t){if(1==this.isWorldLocked())return null;if(this.m_activeFlag){var i=this.m_world.m_broadPhase;t.createProxies(i,this.m_xf)}return t.m_next=this.m_fixtureList,this.m_fixtureList=t,t.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,t},y.prototype.createFixture=function(t,i){if(1==this.isWorldLocked())return null;var e=new _(this,t,i);return this._addFixture(e),e},y.prototype.destroyFixture=function(t){if(1!=this.isWorldLocked()){if(this.m_fixtureList===t)this.m_fixtureList=t.m_next,!0;else for(var i=this.m_fixtureList;null!=i;){if(i.m_next===t){i.m_next=t.m_next,!0;break}i=i.m_next}for(var e=this.m_contactList;e;){var s=e.contact;e=e.next;var o=s.getFixtureA(),n=s.getFixtureB();t!=o&&t!=n||this.m_world.destroyContact(s)}if(this.m_activeFlag){var r=this.m_world.m_broadPhase;t.destroyProxies(r)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},y.prototype.getWorldPoint=function(t){return m.mulVec2(this.m_xf,t)},y.prototype.getWorldVector=function(t){return n.mulVec2(this.m_xf.q,t)},y.prototype.getLocalPoint=function(t){return m.mulTVec2(this.m_xf,t)},y.prototype.getLocalVector=function(t){return n.mulTVec2(this.m_xf.q,t)}},function(t,i,e){t.exports=m;e(2);var s=e(1),o=e(0),n=e(3),r=e(5);function m(t,i){this.localCenter=o.zero(),this.c=o.zero(),this.a=0,this.alpha0=0,this.c0=o.zero(),this.a0=0}m.prototype.setTransform=function(t){var i=r.mulVec2(t,this.localCenter);this.c.set(i),this.c0.set(i),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},m.prototype.setLocalCenter=function(t,i){this.localCenter.set(t);var e=r.mulVec2(i,this.localCenter);this.c.set(e),this.c0.set(e)},m.prototype.getTransform=function(t,i){i=void 0===i?0:i,t.q.setAngle((1-i)*this.a0+i*this.a),t.p.setCombine(1-i,this.c0,i,this.c),t.p.sub(n.mulVec2(t.q,this.localCenter))},m.prototype.advance=function(t){var i=(t-this.alpha0)/(1-this.alpha0);this.c0.setCombine(i,this.c,1-i,this.c0),this.a0=i*this.a+(1-i)*this.a0,this.alpha0=t},m.prototype.forward=function(){this.a0=this.a,this.c0.set(this.c)},m.prototype.normalize=function(){var t=s.mod(this.a0,-s.PI,+s.PI);this.a-=this.a0-t,this.a0=t},m.prototype.clone=function(){var t=new m;return t.localCenter.set(this.localCenter),t.alpha0=this.alpha0,t.a0=this.a0,t.a=this.a,t.c0.set(this.c0),t.c.set(this.c),t},m.prototype.set=function(t){this.localCenter.set(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.set(t.c0),this.c.set(t.c)}},function(t,i,e){t.exports=o;e(2),e(1);var s=e(0);function o(t,i,e,o){"object"==typeof t&&null!==t?(this.ex=s.clone(t),this.ey=s.clone(i)):"number"==typeof t?(this.ex=s.neo(t,e),this.ey=s.neo(i,o)):(this.ex=s.zero(),this.ey=s.zero())}o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&s.isValid(t.ex)&&s.isValid(t.ey)},o.assert=function(t){},o.prototype.set=function(t,i,e,s){"number"==typeof t&&"number"==typeof i&&"number"==typeof e&&"number"==typeof s?(this.ex.set(t,e),this.ey.set(i,s)):"object"==typeof t&&"object"==typeof i?(this.ex.set(t),this.ey.set(i)):"object"==typeof t&&(this.ex.set(t.ex),this.ey.set(t.ey))},o.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},o.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},o.prototype.getInverse=function(){var t=this.ex.x,i=this.ey.x,e=this.ex.y,s=this.ey.y,n=t*s-i*e;0!=n&&(n=1/n);var r=new o;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*e,r.ey.y=n*t,r},o.prototype.solve=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,n=this.ey.y,r=i*n-e*o;0!=r&&(r=1/r);var m=s.zero();return m.x=r*(n*t.x-e*t.y),m.y=r*(i*t.y-o*t.x),m},o.mul=function(t,i){if(i&&"x"in i&&"y"in i){var e=t.ex.x*i.x+t.ey.x*i.y,n=t.ex.y*i.x+t.ey.y*i.y;return s.neo(e,n)}if(i&&"ex"in i&&"ey"in i)return new o(t.ex.x*i.ex.x+t.ey.x*i.ex.y,t.ex.x*i.ey.x+t.ey.x*i.ey.y,t.ex.y*i.ex.x+t.ey.y*i.ex.y,t.ex.y*i.ey.x+t.ey.y*i.ey.y)},o.mulVec2=function(t,i){var e=t.ex.x*i.x+t.ey.x*i.y,o=t.ex.y*i.x+t.ey.y*i.y;return s.neo(e,o)},o.mulMat22=function(t,i){return new o(t.ex.x*i.ex.x+t.ey.x*i.ex.y,t.ex.x*i.ey.x+t.ey.x*i.ey.y,t.ex.y*i.ex.x+t.ey.y*i.ex.y,t.ex.y*i.ey.x+t.ey.y*i.ey.y)},o.mulT=function(t,i){return i&&"x"in i&&"y"in i?s.neo(s.dot(i,t.ex),s.dot(i,t.ey)):i&&"ex"in i&&"ey"in i?new o(s.neo(s.dot(t.ex,i.ex),s.dot(t.ey,i.ex)),s.neo(s.dot(t.ex,i.ey),s.dot(t.ey,i.ey))):void 0},o.mulTVec2=function(t,i){return s.neo(s.dot(i,t.ex),s.dot(i,t.ey))},o.mulTMat22=function(t,i){return new o(s.neo(s.dot(t.ex,i.ex),s.dot(t.ey,i.ex)),s.neo(s.dot(t.ex,i.ey),s.dot(t.ey,i.ey)))},o.abs=function(t){return new o(s.abs(t.ex),s.abs(t.ey))},o.add=function(t,i){return new o(s.add(t.ex,i.ex),s.add(t.ey,i.ey))}},function(t,i,e){t.exports=o;e(2);function s(){this.other=null,this.joint=null,this.prev=null,this.next=null}function o(t,i,e){i=t.bodyA||i,e=t.bodyB||e,this.m_type="unknown-joint",this.m_bodyA=i,this.m_bodyB=e,this.m_index=0,this.m_collideConnected=!!t.collideConnected,this.m_prev=null,this.m_next=null,this.m_edgeA=new s,this.m_edgeB=new s,this.m_islandFlag=!1,this.m_userData=t.userData}o.TYPES={},o._deserialize=function(t,i,e){var s=o.TYPES[t.type];return s&&e(s,t)},o.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},o.prototype.getType=function(){return this.m_type},o.prototype.getBodyA=function(){return this.m_bodyA},o.prototype.getBodyB=function(){return this.m_bodyB},o.prototype.getNext=function(){return this.m_next},o.prototype.getUserData=function(){return this.m_userData},o.prototype.setUserData=function(t){this.m_userData=t},o.prototype.getCollideConnected=function(){return this.m_collideConnected},o.prototype.getAnchorA=function(){},o.prototype.getAnchorB=function(){},o.prototype.getReactionForce=function(t){},o.prototype.getReactionTorque=function(t){},o.prototype.shiftOrigin=function(t){},o.prototype.initVelocityConstraints=function(t){},o.prototype.solveVelocityConstraints=function(t){},o.prototype.solvePositionConstraints=function(t){}},function(t,i,e){t.exports=function(){this.v=s.zero(),this.w=0};var s=e(0)},function(t,i,e){t.exports=n;var s=e(0),o=e(3);function n(){this.c=s.zero(),this.a=0}n.prototype.getTransform=function(t,i){return t.q.set(this.a),t.p.set(s.sub(this.c,o.mulVec2(t.q,i))),t}},function(t,i,e){t.exports=n;e(2),e(1);var s=e(0),o=e(7);function n(t,i,e){"object"==typeof t&&null!==t?(this.ex=o.clone(t),this.ey=o.clone(i),this.ez=o.clone(e)):(this.ex=o(),this.ey=o(),this.ez=o())}n.prototype.toString=function(){return JSON.stringify(this)},n.isValid=function(t){return t&&o.isValid(t.ex)&&o.isValid(t.ey)&&o.isValid(t.ez)},n.assert=function(t){},n.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},n.prototype.solve33=function(t){var i=o.dot(this.ex,o.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=new o;return e.x=i*o.dot(t,o.cross(this.ey,this.ez)),e.y=i*o.dot(this.ex,o.cross(t,this.ez)),e.z=i*o.dot(this.ex,o.cross(this.ey,t)),e},n.prototype.solve22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,n=this.ey.y,r=i*n-e*o;0!=r&&(r=1/r);var m=s.zero();return m.x=r*(n*t.x-e*t.y),m.y=r*(i*t.y-o*t.x),m},n.prototype.getInverse22=function(t){var i=this.ex.x,e=this.ey.x,s=this.ex.y,o=this.ey.y,n=i*o-e*s;0!=n&&(n=1/n),t.ex.x=n*o,t.ey.x=-n*e,t.ex.z=0,t.ex.y=-n*s,t.ey.y=n*i,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},n.prototype.getSymInverse33=function(t){var i=o.dot(this.ex,o.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=this.ex.x,s=this.ey.x,n=this.ez.x,r=this.ey.y,m=this.ez.y,a=this.ez.z;t.ex.x=i*(r*a-m*m),t.ex.y=i*(n*m-s*a),t.ex.z=i*(s*m-n*r),t.ey.x=t.ex.y,t.ey.y=i*(e*a-n*n),t.ey.z=i*(n*s-e*m),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=i*(e*r-s*s)},n.mul=function(t,i){if(i&&"z"in i&&"y"in i&&"x"in i){var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,n=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,r=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new o(e,n,r)}if(i&&"y"in i&&"x"in i){e=t.ex.x*i.x+t.ey.x*i.y,n=t.ex.y*i.x+t.ey.y*i.y;return s.neo(e,n)}},n.mulVec3=function(t,i){var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,s=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,n=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new o(e,s,n)},n.mulVec2=function(t,i){var e=t.ex.x*i.x+t.ey.x*i.y,o=t.ex.y*i.x+t.ey.y*i.y;return s.neo(e,o)},n.add=function(t,i){return new n(o.add(t.ex,i.ex),o.add(t.ey,i.ey),o.add(t.ez,i.ez))}},function(t,i,e){t.exports=s;e(1);function s(){this.m_type,this.m_radius}s.prototype._reset=function(){},s.prototype._serialize=function(){return{}},s.TYPES={},s._deserialize=function(t,i,e){var o=s.TYPES[t.type];return o&&e(o,t)},s.isValid=function(t){return!!t},s.prototype.getRadius=function(){return this.m_radius},s.prototype.getType=function(){return this.m_type},s.prototype._clone=function(){},s.prototype.getChildCount=function(){},s.prototype.testPoint=function(t,i){},s.prototype.rayCast=function(t,i,e,s){},s.prototype.computeAABB=function(t,i,e){},s.prototype.computeMass=function(t,i){},s.prototype.computeDistanceProxy=function(t){}},function(t,i,e){e(4),e(2);var s=e(1),o=e(0);function n(t,i){if(!(this instanceof n))return new n(t,i);this.lowerBound=o.zero(),this.upperBound=o.zero(),"object"==typeof t&&this.lowerBound.set(t),"object"==typeof i?this.upperBound.set(i):"object"==typeof t&&this.upperBound.set(t)}t.exports=n,n.prototype.isValid=function(){return n.isValid(this)},n.isValid=function(t){var i=o.sub(t.upperBound,t.lowerBound);return i.x>=0&&i.y>=0&&o.isValid(t.lowerBound)&&o.isValid(t.upperBound)},n.assert=function(t){},n.prototype.getCenter=function(){return o.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},n.prototype.getExtents=function(){return o.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},n.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},n.prototype.combine=function(t,i){i=i||this;var e=t.lowerBound,o=t.upperBound,n=i.lowerBound,r=i.upperBound,m=s.min(e.x,n.x),a=s.min(e.y,n.y),h=s.max(r.x,o.x),_=s.max(r.y,o.y);this.lowerBound.set(m,a),this.upperBound.set(h,_)},n.prototype.combinePoints=function(t,i){this.lowerBound.set(s.min(t.x,i.x),s.min(t.y,i.y)),this.upperBound.set(s.max(t.x,i.x),s.max(t.y,i.y))},n.prototype.set=function(t){this.lowerBound.set(t.lowerBound.x,t.lowerBound.y),this.upperBound.set(t.upperBound.x,t.upperBound.y)},n.prototype.contains=function(t){var i=!0;return i=(i=(i=(i=i&&this.lowerBound.x<=t.lowerBound.x)&&this.lowerBound.y<=t.lowerBound.y)&&t.upperBound.x<=this.upperBound.x)&&t.upperBound.y<=this.upperBound.y},n.prototype.extend=function(t){return n.extend(this,t),this},n.extend=function(t,i){t.lowerBound.x-=i,t.lowerBound.y-=i,t.upperBound.x+=i,t.upperBound.y+=i},n.testOverlap=function(t,i){var e=i.lowerBound.x-t.upperBound.x,s=t.lowerBound.x-i.upperBound.x,o=i.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-i.upperBound.y;return!(e>0||o>0||s>0||n>0)},n.areEqual=function(t,i){return o.areEqual(t.lowerBound,i.lowerBound)&&o.areEqual(t.upperBound,i.upperBound)},n.diff=function(t,i){var e=s.max(0,s.min(t.upperBound.x,i.upperBound.x)-s.max(i.lowerBound.x,t.lowerBound.x)),o=s.max(0,s.min(t.upperBound.y,i.upperBound.y)-s.max(i.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(i.upperBound.x-i.lowerBound.x)*(i.upperBound.y-i.lowerBound.y)-e*o},n.prototype.rayCast=function(t,i){for(var e=-1/0,n=1/0,r=i.p1,m=o.sub(i.p2,i.p1),a=o.abs(m),h=o.zero(),_="x";null!==_;_="x"===_?"y":null)if(a.x<s.EPSILON){if(r[_]<this.lowerBound[_]||this.upperBound[_]<r[_])return!1}else{var c=1/m[_],l=(this.lowerBound[_]-r[_])*c,u=(this.upperBound[_]-r[_])*c,p=-1;if(l>u){var y=l;l=u,u=y,p=1}if(l>e&&(h.setZero(),h[_]=p,e=l),e>(n=s.min(n,u)))return!1}return!(e<0||i.maxFraction<e)&&(t.fraction=e,t.normal=h,!0)},n.prototype.toString=function(){return JSON.stringify(this)}},function(t,i,e){e(2);var s=e(1),o=e(0),n=e(5),r=e(10),m=e(3),a=e(4),h=e(18),_=e(21);function c(t){this.contact=t,this.prev,this.next,this.other}function l(t,i,e,s,n){this.m_nodeA=new c(this),this.m_nodeB=new c(this),this.m_fixtureA=t,this.m_fixtureB=e,this.m_indexA=i,this.m_indexB=s,this.m_evaluateFcn=n,this.m_manifold=new h,this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_friction=p(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=y(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution),this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.v_points=[],this.v_normal=o.zero(),this.v_normalMass=new r,this.v_K=new r,this.v_pointCount,this.v_tangentSpeed,this.v_friction,this.v_restitution,this.v_invMassA,this.v_invMassB,this.v_invIA,this.v_invIB,this.p_localPoints=[],this.p_localNormal=o.zero(),this.p_localPoint=o.zero(),this.p_localCenterA=o.zero(),this.p_localCenterB=o.zero(),this.p_type,this.p_radiusA,this.p_radiusB,this.p_pointCount,this.p_invMassA,this.p_invMassB,this.p_invIA,this.p_invIB}function u(){this.rA=o.zero(),this.rB=o.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0}function p(t,i){return s.sqrt(t*i)}function y(t,i){return t>i?t:i}t.exports=l,l.prototype.initConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,s=i.getShape(),n=e.getShape(),r=i.getBody(),m=e.getBody(),a=this.getManifold(),h=a.pointCount;this.v_invMassA=r.m_invMass,this.v_invMassB=m.m_invMass,this.v_invIA=r.m_invI,this.v_invIB=m.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=h,this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=r.m_invMass,this.p_invMassB=m.m_invMass,this.p_invIA=r.m_invI,this.p_invIB=m.m_invI,this.p_localCenterA=o.clone(r.m_sweep.localCenter),this.p_localCenterB=o.clone(m.m_sweep.localCenter),this.p_radiusA=s.m_radius,this.p_radiusB=n.m_radius,this.p_type=a.type,this.p_localNormal=o.clone(a.localNormal),this.p_localPoint=o.clone(a.localPoint),this.p_pointCount=h;for(var _=0;_<h;++_){var c=a.points[_],l=this.v_points[_]=new u;t.warmStarting?(l.normalImpulse=t.dtRatio*c.normalImpulse,l.tangentImpulse=t.dtRatio*c.tangentImpulse):(l.normalImpulse=0,l.tangentImpulse=0),l.rA.setZero(),l.rB.setZero(),l.normalMass=0,l.tangentMass=0,l.velocityBias=0,this.p_localPoints[_]=o.clone(c.localPoint)}},l.prototype.getManifold=function(){return this.m_manifold},l.prototype.getWorldManifold=function(t){var i=this.m_fixtureA.getBody(),e=this.m_fixtureB.getBody(),s=this.m_fixtureA.getShape(),o=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,i.getTransform(),s.m_radius,e.getTransform(),o.m_radius)},l.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},l.prototype.isEnabled=function(){return this.m_enabledFlag},l.prototype.isTouching=function(){return this.m_touchingFlag},l.prototype.getNext=function(){return this.m_next},l.prototype.getFixtureA=function(){return this.m_fixtureA},l.prototype.getFixtureB=function(){return this.m_fixtureB},l.prototype.getChildIndexA=function(){return this.m_indexA},l.prototype.getChildIndexB=function(){return this.m_indexB},l.prototype.flagForFiltering=function(){this.m_filterFlag=!0},l.prototype.setFriction=function(t){this.m_friction=t},l.prototype.getFriction=function(){return this.m_friction},l.prototype.resetFriction=function(){this.m_friction=p(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},l.prototype.setRestitution=function(t){this.m_restitution=t},l.prototype.getRestitution=function(){return this.m_restitution},l.prototype.resetRestitution=function(){this.m_restitution=y(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},l.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},l.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},l.prototype.evaluate=function(t,i,e){this.m_evaluateFcn(t,i,this.m_fixtureA,this.m_indexA,e,this.m_fixtureB,this.m_indexB)},l.prototype.update=function(t){this.m_enabledFlag=!0;var i=!1,e=this.m_touchingFlag,s=this.m_fixtureA.isSensor(),o=this.m_fixtureB.isSensor(),n=s||o,r=this.m_fixtureA.getBody(),m=this.m_fixtureB.getBody(),a=r.getTransform(),c=m.getTransform();if(n){var l=this.m_fixtureA.getShape(),u=this.m_fixtureB.getShape();i=_.testOverlap(l,this.m_indexA,u,this.m_indexB,a,c),this.m_manifold.pointCount=0}else{var p=this.m_manifold;this.m_manifold=new h,this.evaluate(this.m_manifold,a,c),i=this.m_manifold.pointCount>0;for(var y=0;y<this.m_manifold.pointCount;++y){var d=this.m_manifold.points[y];d.normalImpulse=0,d.tangentImpulse=0;for(var f=0;f<p.pointCount;++f){var v=p.points[f];if(v.id.key==d.id.key){d.normalImpulse=v.normalImpulse,d.tangentImpulse=v.tangentImpulse;break}}}i!=e&&(r.setAwake(!0),m.setAwake(!0))}this.m_touchingFlag=i,0==e&&1==i&&t&&t.beginContact(this),1==e&&0==i&&t&&t.endContact(this),0==n&&i&&t&&t.preSolve(this,p)},l.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t,!1)},l.prototype.solvePositionConstraintTOI=function(t,i,e){return this._solvePositionConstraint(t,!0,i,e)},l.prototype._solvePositionConstraint=function(t,i,e,r){var _=this.m_fixtureA,c=this.m_fixtureB,l=_.getBody(),u=c.getBody(),p=(l.c_velocity,u.c_velocity,l.c_position),y=u.c_position,d=o.clone(this.p_localCenterA),f=o.clone(this.p_localCenterB),v=0,x=0;i&&l!=e&&l!=r||(v=this.p_invMassA,x=this.p_invIA);var A=0,b=0;i&&u!=e&&u!=r||(A=this.p_invMassB,b=this.p_invIB);for(var g=o.clone(p.c),B=p.a,w=o.clone(y.c),C=y.a,M=0,I=0;I<this.p_pointCount;++I){var z,S,V,P=n.identity(),T=n.identity();switch(P.q.set(B),T.q.set(C),P.p=o.sub(g,m.mulVec2(P.q,d)),T.p=o.sub(w,m.mulVec2(T.q,f)),this.p_type){case h.e_circles:var L=n.mulVec2(P,this.p_localPoint),q=n.mulVec2(T,this.p_localPoints[0]);(z=o.sub(q,L)).normalize(),S=o.combine(.5,L,.5,q),V=o.dot(o.sub(q,L),z)-this.p_radiusA-this.p_radiusB;break;case h.e_faceA:z=m.mulVec2(P.q,this.p_localNormal);var F=n.mulVec2(P,this.p_localPoint),k=n.mulVec2(T,this.p_localPoints[I]);V=o.dot(o.sub(k,F),z)-this.p_radiusA-this.p_radiusB,S=k;break;case h.e_faceB:z=m.mulVec2(T.q,this.p_localNormal);F=n.mulVec2(T,this.p_localPoint),k=n.mulVec2(P,this.p_localPoints[I]);V=o.dot(o.sub(k,F),z)-this.p_radiusA-this.p_radiusB,S=k,z.mul(-1)}var j=o.sub(S,g),D=o.sub(S,w);M=s.min(M,V);var R=i?a.toiBaugarte:a.baumgarte,O=a.linearSlop,E=a.maxLinearCorrection,Y=s.clamp(R*(V+O),-E,0),J=o.cross(j,z),N=o.cross(D,z),W=v+A+x*J*J+b*N*N,H=W>0?-Y/W:0,Z=o.mul(H,z);g.subMul(v,Z),B-=x*o.cross(j,Z),w.addMul(A,Z),C+=b*o.cross(D,Z)}return p.c.set(g),p.a=B,y.c.set(w),y.a=C,M},l.prototype.initVelocityConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,s=i.getBody(),r=e.getBody(),h=s.c_velocity,_=r.c_velocity,c=s.c_position,l=r.c_position,u=this.p_radiusA,p=this.p_radiusB,y=this.getManifold(),d=this.v_invMassA,f=this.v_invMassB,v=this.v_invIA,x=this.v_invIB,A=o.clone(this.p_localCenterA),b=o.clone(this.p_localCenterB),g=o.clone(c.c),B=c.a,w=o.clone(h.v),C=h.w,M=o.clone(l.c),I=l.a,z=o.clone(_.v),S=_.w,V=n.identity(),P=n.identity();V.q.set(B),P.q.set(I),V.p.setCombine(1,g,-1,m.mulVec2(V.q,A)),P.p.setCombine(1,M,-1,m.mulVec2(P.q,b));var T=y.getWorldManifold(null,V,u,P,p);this.v_normal.set(T.normal);for(var L=0;L<this.v_pointCount;++L){var q=this.v_points[L];q.rA.set(o.sub(T.points[L],g)),q.rB.set(o.sub(T.points[L],M));var F=o.cross(q.rA,this.v_normal),k=o.cross(q.rB,this.v_normal),j=d+f+v*F*F+x*k*k;q.normalMass=j>0?1/j:0;var D=o.cross(this.v_normal,1),R=o.cross(q.rA,D),O=o.cross(q.rB,D),E=d+f+v*R*R+x*O*O;q.tangentMass=E>0?1/E:0,q.velocityBias=0;var Y=o.dot(this.v_normal,z)+o.dot(this.v_normal,o.cross(S,q.rB))-o.dot(this.v_normal,w)-o.dot(this.v_normal,o.cross(C,q.rA));Y<-a.velocityThreshold&&(q.velocityBias=-this.v_restitution*Y)}if(2==this.v_pointCount&&t.blockSolve){var J=this.v_points[0],N=this.v_points[1],W=o.cross(J.rA,this.v_normal),H=o.cross(J.rB,this.v_normal),Z=o.cross(N.rA,this.v_normal),X=o.cross(N.rB,this.v_normal),G=d+f+v*W*W+x*H*H,K=d+f+v*Z*Z+x*X*X,U=d+f+v*W*Z+x*H*X;G*G<1e3*(G*K-U*U)?(this.v_K.ex.set(G,U),this.v_K.ey.set(U,K),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}c.c.set(g),c.a=B,h.v.set(w),h.w=C,l.c.set(M),l.a=I,_.v.set(z),_.w=S},l.prototype.warmStartConstraint=function(t){for(var i=this.m_fixtureA,e=this.m_fixtureB,s=i.getBody(),n=e.getBody(),r=s.c_velocity,m=n.c_velocity,a=(s.c_position,n.c_position,this.v_invMassA),h=this.v_invIA,_=this.v_invMassB,c=this.v_invIB,l=o.clone(r.v),u=r.w,p=o.clone(m.v),y=m.w,d=this.v_normal,f=o.cross(d,1),v=0;v<this.v_pointCount;++v){var x=this.v_points[v],A=o.combine(x.normalImpulse,d,x.tangentImpulse,f);u-=h*o.cross(x.rA,A),l.subMul(a,A),y+=c*o.cross(x.rB,A),p.addMul(_,A)}r.v.set(l),r.w=u,m.v.set(p),m.w=y},l.prototype.storeConstraintImpulses=function(t){for(var i=this.m_manifold,e=0;e<this.v_pointCount;++e)i.points[e].normalImpulse=this.v_points[e].normalImpulse,i.points[e].tangentImpulse=this.v_points[e].tangentImpulse},l.prototype.solveVelocityConstraint=function(t){for(var i=this.m_fixtureA.m_body,e=this.m_fixtureB.m_body,n=i.c_velocity,m=(i.c_position,e.c_velocity),a=(e.c_position,this.v_invMassA),h=this.v_invIA,_=this.v_invMassB,c=this.v_invIB,l=o.clone(n.v),u=n.w,p=o.clone(m.v),y=m.w,d=this.v_normal,f=o.cross(d,1),v=this.v_friction,x=0;x<this.v_pointCount;++x){var A=this.v_points[x];(M=o.zero()).addCombine(1,p,1,o.cross(y,A.rB)),M.subCombine(1,l,1,o.cross(u,A.rA));var b=o.dot(M,f)-this.v_tangentSpeed,g=A.tangentMass*-b,B=v*A.normalImpulse;g=(I=s.clamp(A.tangentImpulse+g,-B,B))-A.tangentImpulse,A.tangentImpulse=I;var w=o.mul(g,f);l.subMul(a,w),u-=h*o.cross(A.rA,w),p.addMul(_,w),y+=c*o.cross(A.rB,w)}if(1==this.v_pointCount||0==t.blockSolve)for(var C=0;C<this.v_pointCount;++C){var M;A=this.v_points[C];(M=o.zero()).addCombine(1,p,1,o.cross(y,A.rB)),M.subCombine(1,l,1,o.cross(u,A.rA));var I,z=o.dot(M,d);g=-A.normalMass*(z-A.velocityBias);g=(I=s.max(A.normalImpulse+g,0))-A.normalImpulse,A.normalImpulse=I;w=o.mul(g,d);l.subMul(a,w),u-=h*o.cross(A.rA,w),p.addMul(_,w),y+=c*o.cross(A.rB,w)}else{var S=this.v_points[0],V=this.v_points[1],P=o.neo(S.normalImpulse,V.normalImpulse),T=o.zero().add(p).add(o.cross(y,S.rB)).sub(l).sub(o.cross(u,S.rA)),L=o.zero().add(p).add(o.cross(y,V.rB)).sub(l).sub(o.cross(u,V.rA)),q=o.dot(T,d),F=o.dot(L,d),k=o.neo(q-S.velocityBias,F-V.velocityBias);k.sub(r.mulVec2(this.v_K,P));for(;;){var j=r.mulVec2(this.v_normalMass,k).neg();if(j.x>=0&&j.y>=0){var D=o.sub(j,P),R=o.mul(D.x,d),O=o.mul(D.y,d);l.subCombine(a,R,a,O),u-=h*(o.cross(S.rA,R)+o.cross(V.rA,O)),p.addCombine(_,R,_,O),y+=c*(o.cross(S.rB,R)+o.cross(V.rB,O)),S.normalImpulse=j.x,V.normalImpulse=j.y;break}if(j.x=-S.normalMass*k.x,j.y=0,q=0,F=this.v_K.ex.y*j.x+k.y,j.x>=0&&F>=0){D=o.sub(j,P),R=o.mul(D.x,d),O=o.mul(D.y,d);l.subCombine(a,R,a,O),u-=h*(o.cross(S.rA,R)+o.cross(V.rA,O)),p.addCombine(_,R,_,O),y+=c*(o.cross(S.rB,R)+o.cross(V.rB,O)),S.normalImpulse=j.x,V.normalImpulse=j.y;break}if(j.x=0,j.y=-V.normalMass*k.y,q=this.v_K.ey.x*j.y+k.x,F=0,j.y>=0&&q>=0){D=o.sub(j,P),R=o.mul(D.x,d),O=o.mul(D.y,d);l.subCombine(a,R,a,O),u-=h*(o.cross(S.rA,R)+o.cross(V.rA,O)),p.addCombine(_,R,_,O),y+=c*(o.cross(S.rB,R)+o.cross(V.rB,O)),S.normalImpulse=j.x,V.normalImpulse=j.y;break}if(j.x=0,j.y=0,q=k.x,F=k.y,q>=0&&F>=0){D=o.sub(j,P),R=o.mul(D.x,d),O=o.mul(D.y,d);l.subCombine(a,R,a,O),u-=h*(o.cross(S.rA,R)+o.cross(V.rA,O)),p.addCombine(_,R,_,O),y+=c*(o.cross(S.rB,R)+o.cross(V.rB,O)),S.normalImpulse=j.x,V.normalImpulse=j.y;break}break}}n.v.set(l),n.w=u,m.v.set(p),m.w=y};var d=[];l.addType=function(t,i,e){d[t]=d[t]||{},d[t][i]=e},l.create=function(t,i,e,s){var o,n,r=t.getType(),m=e.getType();if(n=d[r]&&d[r][m])o=new l(t,i,e,s,n);else{if(!(n=d[m]&&d[m][r]))return null;o=new l(e,s,t,i,n)}t=o.getFixtureA(),e=o.getFixtureB(),i=o.getChildIndexA(),s=o.getChildIndexB();var a=t.getBody(),h=e.getBody();return o.m_nodeA.contact=o,o.m_nodeA.other=h,o.m_nodeA.prev=null,o.m_nodeA.next=a.m_contactList,null!=a.m_contactList&&(a.m_contactList.prev=o.m_nodeA),a.m_contactList=o.m_nodeA,o.m_nodeB.contact=o,o.m_nodeB.other=a,o.m_nodeB.prev=null,o.m_nodeB.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=o.m_nodeB),h.m_contactList=o.m_nodeB,0==t.isSensor()&&0==e.isSensor()&&(a.setAwake(!0),h.setAwake(!0)),o},l.destroy=function(t,i){var e=t.m_fixtureA,s=t.m_fixtureB,o=e.getBody(),n=s.getBody();t.isTouching()&&i.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA==o.m_contactList&&(o.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB==n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&0==e.isSensor()&&0==s.isSensor()&&(o.setAwake(!0),n.setAwake(!0));var r=e.getType(),m=s.getType(),a=d[r][m].destroyFcn;"function"==typeof a&&a(t)}},function(t,i,e){e(2);var s=e(0),o=e(5),n=e(1),r=e(3);function m(){this.type,this.localNormal=s.zero(),this.localPoint=s.zero(),this.points=[new a,new a],this.pointCount=0}function a(){this.localPoint=s.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new h}function h(){this.cf=new _}function _(){this.indexA,this.indexB,this.typeA,this.typeB}function c(){this.normal,this.points=[],this.separations=[]}t.exports=m,t.exports.clipSegmentToLine=function(t,i,e,o,n){var r=0,a=s.dot(e,i[0].v)-o,h=s.dot(e,i[1].v)-o;a<=0&&t[r++].set(i[0]);h<=0&&t[r++].set(i[1]);if(a*h<0){var _=a/(a-h);t[r].v.setCombine(1-_,i[0].v,_,i[1].v),t[r].id.cf.indexA=n,t[r].id.cf.indexB=i[0].id.cf.indexB,t[r].id.cf.typeA=m.e_vertex,t[r].id.cf.typeB=m.e_face,++r}return r},t.exports.clipVertex=u,t.exports.getPointStates=function(t,i,e,s){for(var o=0;o<e.pointCount;++o){var n=e.points[o].id;t[o]=l.removeState;for(var r=0;r<s.pointCount;++r)if(s.points[r].id.key==n.key){t[o]=l.persistState;break}}for(o=0;o<s.pointCount;++o){n=s.points[o].id;i[o]=l.addState;for(r=0;r<e.pointCount;++r)if(e.points[r].id.key==n.key){i[o]=l.persistState;break}}},t.exports.PointState=l,m.e_circles=0,m.e_faceA=1,m.e_faceB=2,m.e_vertex=0,m.e_face=1,Object.defineProperty(h.prototype,"key",{get:function(){return this.cf.indexA+4*this.cf.indexB+16*this.cf.typeA+64*this.cf.typeB},enumerable:!0,configurable:!0}),h.prototype.set=function(t){this.cf.set(t.cf)},_.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},m.prototype.getWorldManifold=function(t,i,e,a,h){if(0!=this.pointCount){var _=(t=t||new c).normal,l=t.points,u=t.separations;switch(this.type){case m.e_circles:_=s.neo(1,0);var p=o.mulVec2(i,this.localPoint),y=o.mulVec2(a,this.points[0].localPoint),d=s.sub(y,p);s.lengthSquared(d)>n.EPSILON*n.EPSILON&&(_.set(d),_.normalize());var f=p.clone().addMul(e,_),v=y.clone().addMul(-h,_);l[0]=s.mid(f,v),u[0]=s.dot(s.sub(v,f),_),l.length=1,u.length=1;break;case m.e_faceA:_=r.mulVec2(i.q,this.localNormal);for(var x=o.mulVec2(i,this.localPoint),A=0;A<this.pointCount;++A){var b=o.mulVec2(a,this.points[A].localPoint);f=s.clone(b).addMul(e-s.dot(s.sub(b,x),_),_),v=s.clone(b).subMul(h,_);l[A]=s.mid(f,v),u[A]=s.dot(s.sub(v,f),_)}l.length=this.pointCount,u.length=this.pointCount;break;case m.e_faceB:_=r.mulVec2(a.q,this.localNormal);for(x=o.mulVec2(a,this.localPoint),A=0;A<this.pointCount;++A){b=o.mulVec2(i,this.points[A].localPoint),v=s.combine(1,b,h-s.dot(s.sub(b,x),_),_),f=s.combine(1,b,-e,_);l[A]=s.mid(f,v),u[A]=s.dot(s.sub(f,v),_)}l.length=this.pointCount,u.length=this.pointCount,_.mul(-1)}return t.normal=_,t.points=l,t.separations=u,t}};var l={nullState:0,addState:1,persistState:2,removeState:3};function u(){this.v=s.zero(),this.id=new h}u.prototype.set=function(t){this.v.set(t.v),this.id.set(t.id)}},,function(t,i,e){t.exports=h;e(2),e(6);var s=e(1),o=e(5),n=e(3),r=e(0),m=(e(16),e(4)),a=e(15);function h(t){if(!(this instanceof h))return new h(t);h._super.call(this),this.m_type=h.TYPE,this.m_radius=m.polygonRadius,this.m_centroid=r.zero(),this.m_vertices=[],this.m_normals=[],this.m_count=0,t&&t.length&&this._set(t)}h._super=a,h.prototype=Object.create(h._super.prototype),h.TYPE="polygon",a.TYPES[h.TYPE]=h,h.prototype._serialize=function(){return{type:this.m_type,vertices:this.m_vertices}},h._deserialize=function(t,i,e){var s=[];if(t.vertices)for(var o=0;o<t.vertices.length;o++)s.push(e(r,t.vertices[o]));return new h(s)},h.prototype.getVertex=function(t){return this.m_vertices[t]},h.prototype._clone=function(){var t=new h;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.set(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},h.prototype.getChildCount=function(){return 1},h.prototype._reset=function(){this._set(this.m_vertices)},h.prototype._set=function(t){if(t.length<3)this._setAsBox(1,1);else{for(var i=s.min(t.length,m.maxPolygonVertices),e=[],o=0;o<i;++o){for(var n=t[o],a=!0,h=0;h<e.length;++h)if(r.distanceSquared(n,e[h])<.25*m.linearSlopSquared){a=!1;break}a&&e.push(n)}if((i=e.length)<3)this._setAsBox(1,1);else{var _=0,c=e[0].x;for(o=1;o<i;++o){var l=e[o].x;(l>c||l===c&&e[o].y<e[_].y)&&(_=o,c=l)}for(var u=[],p=0,y=_;;){u[p]=y;var d=0;for(h=1;h<i;++h)if(d!==y){var f=r.sub(e[d],e[u[p]]),v=(n=r.sub(e[h],e[u[p]]),r.cross(f,n));v<0&&(d=h),0===v&&n.lengthSquared()>f.lengthSquared()&&(d=h)}else d=h;if(++p,y=d,d===_)break}if(p<3)this._setAsBox(1,1);else{this.m_count=p,this.m_vertices=[];for(o=0;o<p;++o)this.m_vertices[o]=e[u[o]];for(o=0;o<p;++o){var x=o,A=o+1<p?o+1:0,b=r.sub(this.m_vertices[A],this.m_vertices[x]);this.m_normals[o]=r.cross(b,1),this.m_normals[o].normalize()}this.m_centroid=function(t,i){for(var e=r.zero(),s=0,o=r.zero(),n=0;n<i;++n){var m=o,a=t[n],h=n+1<i?t[n+1]:t[0],_=r.sub(a,m),c=r.sub(h,m),l=.5*r.cross(_,c);s+=l,e.addMul(l*(1/3),m),e.addMul(l*(1/3),a),e.addMul(l*(1/3),h)}return e.mul(1/s),e}(this.m_vertices,p)}}}},h.prototype._setAsBox=function(t,i,e,s){if(this.m_vertices[0]=r.neo(t,-i),this.m_vertices[1]=r.neo(t,i),this.m_vertices[2]=r.neo(-t,i),this.m_vertices[3]=r.neo(-t,-i),this.m_normals[0]=r.neo(1,0),this.m_normals[1]=r.neo(0,1),this.m_normals[2]=r.neo(-1,0),this.m_normals[3]=r.neo(0,-1),this.m_count=4,r.isValid(e)){s=s||0,this.m_centroid.set(e);var m=o.identity();m.p.set(e),m.q.set(s);for(var a=0;a<this.m_count;++a)this.m_vertices[a]=o.mulVec2(m,this.m_vertices[a]),this.m_normals[a]=n.mulVec2(m.q,this.m_normals[a])}},h.prototype.testPoint=function(t,i){for(var e=n.mulTVec2(t.q,r.sub(i,t.p)),s=0;s<this.m_count;++s){if(r.dot(this.m_normals[s],r.sub(e,this.m_vertices[s]))>0)return!1}return!0},h.prototype.rayCast=function(t,i,e,s){for(var o=n.mulTVec2(e.q,r.sub(i.p1,e.p)),m=n.mulTVec2(e.q,r.sub(i.p2,e.p)),a=r.sub(m,o),h=0,_=i.maxFraction,c=-1,l=0;l<this.m_count;++l){var u=r.dot(this.m_normals[l],r.sub(this.m_vertices[l],o)),p=r.dot(this.m_normals[l],a);if(0==p){if(u<0)return!1}else p<0&&u<h*p?(h=u/p,c=l):p>0&&u<_*p&&(_=u/p);if(_<h)return!1}return c>=0&&(t.fraction=h,t.normal=n.mulVec2(e.q,this.m_normals[c]),!0)},h.prototype.computeAABB=function(t,i,e){for(var n=1/0,r=1/0,m=-1/0,a=-1/0,h=0;h<this.m_count;++h){var _=o.mulVec2(i,this.m_vertices[h]);n=s.min(n,_.x),m=s.max(m,_.x),r=s.min(r,_.y),a=s.max(a,_.y)}t.lowerBound.set(n,r),t.upperBound.set(m,a),t.extend(this.m_radius)},h.prototype.computeMass=function(t,i){for(var e=r.zero(),s=0,o=0,n=r.zero(),m=0;m<this.m_count;++m)n.add(this.m_vertices[m]);n.mul(1/this.m_count);for(m=0;m<this.m_count;++m){var a=r.sub(this.m_vertices[m],n),h=m+1<this.m_count?r.sub(this.m_vertices[m+1],n):r.sub(this.m_vertices[0],n),_=r.cross(a,h),c=.5*_;s+=c,e.addCombine(c*(1/3),a,c*(1/3),h);var l=a.x,u=a.y,p=h.x,y=h.y;o+=1/3*.25*_*(l*l+p*l+p*p+(u*u+y*u+y*y))}t.mass=i*s,e.mul(1/s),t.center.setCombine(1,e,1,n),t.I=i*o,t.I+=t.mass*(r.dot(t.center,t.center)-r.dot(e,e))},h.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var i=t,e=t<this.m_count-1?i+1:0,s=this.m_vertices[i],o=r.sub(this.m_vertices[e],s),n=0;n<this.m_count;++n)if(n!=i&&n!=e){var m=r.sub(this.m_vertices[n],s);if(r.cross(o,m)<0)return!1}return!0},h.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius}},function(t,i,e){t.exports=l,t.exports.Input=h,t.exports.Output=_,t.exports.Proxy=u,t.exports.Cache=c;var s=e(4),o=(e(2),e(27)),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5));e(12),e(13);function h(){this.proxyA=new u,this.proxyB=new u,this.transformA=null,this.transformB=null,this.useRadii=!1}function _(){this.pointA=r.zero(),this.pointB=r.zero(),this.distance,this.iterations}function c(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0}function l(t,i,e){++o.gjkCalls;var h=e.proxyA,_=e.proxyB,c=e.transformA,l=e.transformB,u=new y;u.readCache(i,h,c,_,l);for(var p=u.m_v,d=s.maxDistnceIterations,f=[],v=[],x=0,A=0;A<d;){x=u.m_count;for(var b=0;b<x;++b)f[b]=p[b].indexA,v[b]=p[b].indexB;if(u.solve(),3==u.m_count)break;(z=u.getClosestPoint()).lengthSquared();var g=u.getSearchDirection();if(g.lengthSquared()<n.EPSILON*n.EPSILON)break;var B=p[u.m_count];B.indexA=h.getSupport(m.mulTVec2(c.q,r.neg(g))),B.wA=a.mulVec2(c,h.getVertex(B.indexA)),B.indexB=_.getSupport(m.mulTVec2(l.q,g)),B.wB=a.mulVec2(l,_.getVertex(B.indexB)),B.w=r.sub(B.wB,B.wA),++A,++o.gjkIters;var w=!1;for(b=0;b<x;++b)if(B.indexA==f[b]&&B.indexB==v[b]){w=!0;break}if(w)break;++u.m_count}if(o.gjkMaxIters=n.max(o.gjkMaxIters,A),u.getWitnessPoints(t.pointA,t.pointB),t.distance=r.distance(t.pointA,t.pointB),t.iterations=A,u.writeCache(i),e.useRadii){var C=h.m_radius,M=_.m_radius;if(t.distance>C+M&&t.distance>n.EPSILON){t.distance-=C+M;var I=r.sub(t.pointB,t.pointA);I.normalize(),t.pointA.addMul(C,I),t.pointB.subMul(M,I)}else{var z=r.mid(t.pointA,t.pointB);t.pointA.set(z),t.pointB.set(z),t.distance=0}}}function u(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}function p(){this.indexA,this.indexB,this.wA=r.zero(),this.wB=r.zero(),this.w=r.zero(),this.a}function y(){this.m_v1=new p,this.m_v2=new p,this.m_v3=new p,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}o.gjkCalls=0,o.gjkIters=0,o.gjkMaxIters=0,u.prototype.getVertexCount=function(){return this.m_count},u.prototype.getVertex=function(t){return this.m_vertices[t]},u.prototype.getSupport=function(t){for(var i=0,e=r.dot(this.m_vertices[0],t),s=0;s<this.m_count;++s){var o=r.dot(this.m_vertices[s],t);o>e&&(i=s,e=o)}return i},u.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},u.prototype.set=function(t,i){t.computeDistanceProxy(this,i)},p.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=r.clone(t.wA),this.wB=r.clone(t.wB),this.w=r.clone(t.w),this.a=t.a},y.prototype.print=function(){return 3==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},y.prototype.readCache=function(t,i,e,s,o){this.m_count=t.count;for(var m=0;m<this.m_count;++m){(u=this.m_v[m]).indexA=t.indexA[m],u.indexB=t.indexB[m];var h=i.getVertex(u.indexA),_=s.getVertex(u.indexB);u.wA=a.mulVec2(e,h),u.wB=a.mulVec2(o,_),u.w=r.sub(u.wB,u.wA),u.a=0}if(this.m_count>1){var c=t.metric,l=this.getMetric();(l<.5*c||2*c<l||l<n.EPSILON)&&(this.m_count=0)}if(0==this.m_count){var u;(u=this.m_v[0]).indexA=0,u.indexB=0;h=i.getVertex(0),_=s.getVertex(0);u.wA=a.mulVec2(e,h),u.wB=a.mulVec2(o,_),u.w=r.sub(u.wB,u.wA),u.a=1,this.m_count=1}},y.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var i=0;i<this.m_count;++i)t.indexA[i]=this.m_v[i].indexA,t.indexB[i]=this.m_v[i].indexB},y.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return r.neg(this.m_v1.w);case 2:var t=r.sub(this.m_v2.w,this.m_v1.w);return r.cross(t,r.neg(this.m_v1.w))>0?r.cross(1,t):r.cross(t,1);default:return r.zero()}},y.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return r.zero();case 1:return r.clone(this.m_v1.w);case 2:return r.combine(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:default:return r.zero()}},y.prototype.getWitnessPoints=function(t,i){switch(this.m_count){case 0:break;case 1:t.set(this.m_v1.wA),i.set(this.m_v1.wB);break;case 2:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),i.setCombine(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.addMul(this.m_v3.a,this.m_v3.wA),i.set(t)}},y.prototype.getMetric=function(){switch(this.m_count){case 0:case 1:return 0;case 2:return r.distance(this.m_v1.w,this.m_v2.w);case 3:return r.cross(r.sub(this.m_v2.w,this.m_v1.w),r.sub(this.m_v3.w,this.m_v1.w));default:return 0}},y.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3()}},y.prototype.solve2=function(){var t=this.m_v1.w,i=this.m_v2.w,e=r.sub(i,t),s=-r.dot(t,e);if(s<=0)return this.m_v1.a=1,void(this.m_count=1);var o=r.dot(i,e);if(o<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(o+s);this.m_v1.a=o*n,this.m_v2.a=s*n,this.m_count=2},y.prototype.solve3=function(){var t=this.m_v1.w,i=this.m_v2.w,e=this.m_v3.w,s=r.sub(i,t),o=r.dot(t,s),n=r.dot(i,s),m=-o,a=r.sub(e,t),h=r.dot(t,a),_=r.dot(e,a),c=-h,l=r.sub(e,i),u=r.dot(i,l),p=r.dot(e,l),y=-u,d=r.cross(s,a),f=d*r.cross(i,e),v=d*r.cross(e,t),x=d*r.cross(t,i);if(m<=0&&c<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&m>0&&x<=0){var A=1/(n+m);return this.m_v1.a=n*A,this.m_v2.a=m*A,void(this.m_count=2)}if(_>0&&c>0&&v<=0){var b=1/(_+c);return this.m_v1.a=_*b,this.m_v3.a=c*b,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&y<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(_<=0&&p<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(p>0&&y>0&&f<=0){var g=1/(p+y);return this.m_v2.a=p*g,this.m_v3.a=y*g,this.m_count=2,void this.m_v1.set(this.m_v3)}var B=1/(f+v+x);this.m_v1.a=f*B,this.m_v2.a=v*B,this.m_v3.a=x*B,this.m_count=3},l.testOverlap=function(t,i,e,s,o,r){var m=new h;m.proxyA.set(t,i),m.proxyB.set(e,s),m.transformA=o,m.transformB=r,m.useRadii=!0;var a=new c,u=new _;return l(u,a,m),u.distance<10*n.EPSILON}},function(t,i,e){t.exports=m;e(2),e(6);var s=e(1),o=(e(5),e(3)),n=e(0),r=(e(16),e(4),e(15));function m(t,i){if(!(this instanceof m))return new m(t,i);m._super.call(this),this.m_type=m.TYPE,this.m_p=n.zero(),this.m_radius=1,"object"==typeof t&&n.isValid(t)?(this.m_p.set(t),"number"==typeof i&&(this.m_radius=i)):"number"==typeof t&&(this.m_radius=t)}m._super=r,m.prototype=Object.create(m._super.prototype),m.TYPE="circle",r.TYPES[m.TYPE]=m,m.prototype._serialize=function(){return{type:this.m_type,p:this.m_p,radius:this.m_radius}},m._deserialize=function(t){return new m(t.p,t.radius)},m.prototype.getRadius=function(){return this.m_radius},m.prototype.getCenter=function(){return this.m_p},m.prototype.getVertex=function(t){return this.m_p},m.prototype.getVertexCount=function(t){return 1},m.prototype._clone=function(){var t=new m;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},m.prototype.getChildCount=function(){return 1},m.prototype.testPoint=function(t,i){var e=n.add(t.p,o.mulVec2(t.q,this.m_p)),s=n.sub(i,e);return n.dot(s,s)<=this.m_radius*this.m_radius},m.prototype.rayCast=function(t,i,e,r){var m=n.add(e.p,o.mulVec2(e.q,this.m_p)),a=n.sub(i.p1,m),h=n.dot(a,a)-this.m_radius*this.m_radius,_=n.sub(i.p2,i.p1),c=n.dot(a,_),l=n.dot(_,_),u=c*c-l*h;if(u<0||l<s.EPSILON)return!1;var p=-(c+s.sqrt(u));return 0<=p&&p<=i.maxFraction*l&&(p/=l,t.fraction=p,t.normal=n.add(a,n.mul(p,_)),t.normal.normalize(),!0)},m.prototype.computeAABB=function(t,i,e){var s=n.add(i.p,o.mulVec2(i.q,this.m_p));t.lowerBound.set(s.x-this.m_radius,s.y-this.m_radius),t.upperBound.set(s.x+this.m_radius,s.y+this.m_radius)},m.prototype.computeMass=function(t,i){t.mass=i*s.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+n.dot(this.m_p,this.m_p))},m.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius}},function(t,i,e){t.exports=a;e(6);var s=e(4),o=e(15),n=(e(1),e(5)),r=e(3),m=e(0);e(16);function a(t,i){if(!(this instanceof a))return new a(t,i);a._super.call(this),this.m_type=a.TYPE,this.m_radius=s.polygonRadius,this.m_vertex1=t?m.clone(t):m.zero(),this.m_vertex2=i?m.clone(i):m.zero(),this.m_vertex0=m.zero(),this.m_vertex3=m.zero(),this.m_hasVertex0=!1,this.m_hasVertex3=!1}a._super=o,a.prototype=Object.create(a._super.prototype),a.TYPE="edge",o.TYPES[a.TYPE]=a,a.prototype._serialize=function(){return{type:this.m_type,vertex1:this.m_vertex1,vertex2:this.m_vertex2,vertex0:this.m_vertex0,vertex3:this.m_vertex3,hasVertex0:this.m_hasVertex0,hasVertex3:this.m_hasVertex3}},a._deserialize=function(t){var i=new a(t.vertex1,t.vertex2);return i.hasVertex0&&i.setPrev(t.vertex0),i.hasVertex3&&i.setNext(t.vertex3),i},a.prototype.setNext=function(t){return t?(this.m_vertex3.set(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},a.prototype.setPrev=function(t){return t?(this.m_vertex0.set(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},a.prototype._set=function(t,i){return this.m_vertex1.set(t),this.m_vertex2.set(i),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},a.prototype._clone=function(){var t=new a;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.set(this.m_vertex1),t.m_vertex2.set(this.m_vertex2),t.m_vertex0.set(this.m_vertex0),t.m_vertex3.set(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},a.prototype.getChildCount=function(){return 1},a.prototype.testPoint=function(t,i){return!1},a.prototype.rayCast=function(t,i,e,s){var o=r.mulTVec2(e.q,m.sub(i.p1,e.p)),n=r.mulTVec2(e.q,m.sub(i.p2,e.p)),a=m.sub(n,o),h=this.m_vertex1,_=this.m_vertex2,c=m.sub(_,h),l=m.neo(c.y,-c.x);l.normalize();var u=m.dot(l,m.sub(h,o)),p=m.dot(l,a);if(0==p)return!1;var y=u/p;if(y<0||i.maxFraction<y)return!1;var d=m.add(o,m.mul(y,a)),f=m.sub(_,h),v=m.dot(f,f);if(0==v)return!1;var x=m.dot(m.sub(d,h),f)/v;return!(x<0||1<x)&&(t.fraction=y,t.normal=u>0?r.mulVec2(e.q,l).neg():r.mulVec2(e.q,l),!0)},a.prototype.computeAABB=function(t,i,e){var s=n.mulVec2(i,this.m_vertex1),o=n.mulVec2(i,this.m_vertex2);t.combinePoints(s,o),t.extend(this.m_radius)},a.prototype.computeMass=function(t,i){t.mass=0,t.center.setCombine(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},a.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius}},,,function(t,i,e){t.exports=h;e(2);var s=e(6),o=(e(1),e(0)),n=e(16),r=e(15),m={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535};function a(t,i){this.aabb=new n,this.fixture=t,this.childIndex=i,this.proxyId}function h(t,i,e){i.shape?(e=i,i=i.shape):"number"==typeof e&&(e={density:e}),e=s(e,m),this.m_body=t,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_density=e.density,this.m_isSensor=e.isSensor,this.m_filterGroupIndex=e.filterGroupIndex,this.m_filterCategoryBits=e.filterCategoryBits,this.m_filterMaskBits=e.filterMaskBits,this.m_shape=i,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var o=this.m_shape.getChildCount(),n=0;n<o;++n)this.m_proxies[n]=new a(this,n);this.m_userData=e.userData}h.prototype._reset=function(){var t=this.getBody(),i=t.m_world.m_broadPhase;this.destroyProxies(i),this.m_shape._reset&&this.m_shape._reset();for(var e=this.m_shape.getChildCount(),s=0;s<e;++s)this.m_proxies[s]=new a(this,s);this.createProxies(i,t.m_xf),t.resetMassData()},h.prototype._serialize=function(){return{friction:this.m_friction,restitution:this.m_restitution,density:this.m_density,isSensor:this.m_isSensor,filterGroupIndex:this.m_filterGroupIndex,filterCategoryBits:this.m_filterCategoryBits,filterMaskBits:this.m_filterMaskBits,shape:this.m_shape}},h._deserialize=function(t,i,e){var s=e(r,t.shape);return s&&new h(i,s,t)},h.prototype.getType=function(){return this.m_shape.getType()},h.prototype.getShape=function(){return this.m_shape},h.prototype.isSensor=function(){return this.m_isSensor},h.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},h.prototype.getUserData=function(){return this.m_userData},h.prototype.setUserData=function(t){this.m_userData=t},h.prototype.getBody=function(){return this.m_body},h.prototype.getNext=function(){return this.m_next},h.prototype.getDensity=function(){return this.m_density},h.prototype.setDensity=function(t){this.m_density=t},h.prototype.getFriction=function(){return this.m_friction},h.prototype.setFriction=function(t){this.m_friction=t},h.prototype.getRestitution=function(){return this.m_restitution},h.prototype.setRestitution=function(t){this.m_restitution=t},h.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},h.prototype.rayCast=function(t,i,e){return this.m_shape.rayCast(t,i,this.m_body.getTransform(),e)},h.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},h.prototype.getAABB=function(t){return this.m_proxies[t].aabb},h.prototype.createProxies=function(t,i){this.m_proxyCount=this.m_shape.getChildCount();for(var e=0;e<this.m_proxyCount;++e){var s=this.m_proxies[e];this.m_shape.computeAABB(s.aabb,i,e),s.proxyId=t.createProxy(s.aabb,s)}},h.prototype.destroyProxies=function(t){for(var i=0;i<this.m_proxyCount;++i){var e=this.m_proxies[i];t.destroyProxy(e.proxyId),e.proxyId=null}this.m_proxyCount=0},h.prototype.synchronize=function(t,i,e){for(var s=0;s<this.m_proxyCount;++s){var r=this.m_proxies[s],m=new n,a=new n;this.m_shape.computeAABB(m,i,r.childIndex),this.m_shape.computeAABB(a,e,r.childIndex),r.aabb.combine(m,a);var h=o.sub(e.p,i.p);t.moveProxy(r.proxyId,r.aabb,h)}},h.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},h.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},h.prototype.setFilterGroupIndex=function(t){return this.m_filterGroupIndex=t},h.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},h.prototype.setFilterCategoryBits=function(t){this.m_filterCategoryBits=t},h.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},h.prototype.setFilterMaskBits=function(t){this.m_filterMaskBits=t},h.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var i=t.contact,e=i.getFixtureA(),s=i.getFixtureB();e!=this&&s!=this||i.flagForFiltering(),t=t.next}var o=this.m_body.getWorld();if(null!=o)for(var n=o.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},h.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex===this.m_filterGroupIndex&&0!==t.m_filterGroupIndex)return t.m_filterGroupIndex>0;var i=0!=(t.m_filterMaskBits&this.m_filterCategoryBits),e=0!=(t.m_filterCategoryBits&this.m_filterMaskBits);return i&&e}},function(t,i,e){i.toString=function(t){t="string"==typeof t?t:"\n";var i="";for(var e in this)"function"!=typeof this[e]&&"object"!=typeof this[e]&&(i+=e+": "+this[e]+t);return i}},function(t,i,e){t.exports=a;e(2),e(6),e(1);var s=e(5),o=(e(3),e(0)),n=(e(16),e(4)),r=e(15),m=e(23);function a(t,i){if(!(this instanceof a))return new a(t,i);a._super.call(this),this.m_type=a.TYPE,this.m_radius=n.polygonRadius,this.m_vertices=[],this.m_count=0,this.m_prevVertex=null,this.m_nextVertex=null,this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_isLoop=i,t&&t.length&&(i?this._createLoop(t):this._createChain(t))}a._super=r,a.prototype=Object.create(a._super.prototype),a.TYPE="chain",r.TYPES[a.TYPE]=a,a.prototype._serialize=function(){const t={type:this.m_type,vertices:this.m_vertices,isLoop:this.m_isLoop,hasPrevVertex:this.m_hasPrevVertex,hasNextVertex:this.m_hasNextVertex};return this.m_prevVertex&&(t.prevVertex=this.m_prevVertex),this.m_nextVertex&&(t.nextVertex=this.m_nextVertex),t},a._deserialize=function(t,i,e){var s=[];if(t.vertices)for(var n=0;n<t.vertices.length;n++)s.push(e(o,t.vertices[n]));var r=new a(s,t.isLoop);return t.prevVertex&&r.setPrevVertex(t.prevVertex),t.nextVertex&&r.setNextVertex(t.nextVertex),r},a.prototype._createLoop=function(t){for(var i=1;i<t.length;++i)t[i-1],t[i];this.m_vertices=[],this.m_count=t.length+1;for(i=0;i<t.length;++i)this.m_vertices[i]=o.clone(t[i]);return this.m_vertices[t.length]=o.clone(t[0]),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},a.prototype._createChain=function(t){for(var i=1;i<t.length;++i)t[i-1],t[i];this.m_count=t.length;for(i=0;i<t.length;++i)this.m_vertices[i]=o.clone(t[i]);return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},a.prototype._reset=function(){this.m_isLoop?this._createLoop(this.m_vertices):this._createChain(this.m_vertices)},a.prototype.setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},a.prototype.setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},a.prototype._clone=function(){var t=new a;return t.createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},a.prototype.getChildCount=function(){return this.m_count-1},a.prototype.getChildEdge=function(t,i){t.m_type=m.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[i],t.m_vertex2=this.m_vertices[i+1],i>0?(t.m_vertex0=this.m_vertices[i-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),i<this.m_count-2?(t.m_vertex3=this.m_vertices[i+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},a.prototype.getVertex=function(t){return t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},a.prototype.testPoint=function(t,i){return!1},a.prototype.rayCast=function(t,i,e,s){return new m(this.getVertex(s),this.getVertex(s+1)).rayCast(t,i,e,0)},a.prototype.computeAABB=function(t,i,e){var o=s.mulVec2(i,this.getVertex(e)),n=s.mulVec2(i,this.getVertex(e+1));t.combinePoints(o,n)},a.prototype.computeMass=function(t,i){t.mass=0,t.center=o.neo(),t.I=0},a.prototype.computeDistanceProxy=function(t,i){t.m_buffer[0]=this.getVertex(i),t.m_buffer[1]=this.getVertex(i+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius}},,function(t,i,e){t.exports=c;var s=e(6),o=(e(2),e(0)),n=e(40),r=e(42),m=e(8),a=e(11),h=e(17),_={gravity:o.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3};function c(t){if(!(this instanceof c))return new c(t);t&&o.isValid(t)&&(t={gravity:t}),t=s(t,_),this.m_solver=new r(this),this.m_broadPhase=new n,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=t.allowSleep,this.m_gravity=o.clone(t.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=t.warmStarting,this.m_continuousPhysics=t.continuousPhysics,this.m_subStepping=t.subStepping,this.m_blockSolve=t.blockSolve,this.m_velocityIterations=t.velocityIterations,this.m_positionIterations=t.positionIterations,this.m_t=0,this.addPair=this.createContact.bind(this)}c.prototype._serialize=function(){for(var t=[],i=[],e=this.getBodyList();e;e=e.getNext())t.push(e);for(var s=this.getJointList();s;s=s.getNext())"function"==typeof s._serialize&&i.push(s);return{gravity:this.m_gravity,bodies:t,joints:i}},c._deserialize=function(t,i,e){if(!t)return new c;var s=new c(t.gravity);if(t.bodies)for(var o=t.bodies.length-1;o>=0;o-=1)s._addBody(e(m,t.bodies[o],s));if(t.joints)for(o=t.joints.length-1;o>=0;o--)s.createJoint(e(a,t.joints[o],s));return s},c.prototype.getBodyList=function(){return this.m_bodyList},c.prototype.getJointList=function(){return this.m_jointList},c.prototype.getContactList=function(){return this.m_contactList},c.prototype.getBodyCount=function(){return this.m_bodyCount},c.prototype.getJointCount=function(){return this.m_jointCount},c.prototype.getContactCount=function(){return this.m_contactCount},c.prototype.setGravity=function(t){this.m_gravity=t},c.prototype.getGravity=function(){return this.m_gravity},c.prototype.isLocked=function(){return this.m_locked},c.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var i=this.m_bodyList;i;i=i.m_next)i.setAwake(!0)},c.prototype.getAllowSleeping=function(){return this.m_allowSleep},c.prototype.setWarmStarting=function(t){this.m_warmStarting=t},c.prototype.getWarmStarting=function(){return this.m_warmStarting},c.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},c.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},c.prototype.setSubStepping=function(t){this.m_subStepping=t},c.prototype.getSubStepping=function(){return this.m_subStepping},c.prototype.setAutoClearForces=function(t){this.m_clearForces=t},c.prototype.getAutoClearForces=function(){return this.m_clearForces},c.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},c.prototype.queryAABB=function(t,i){var e=this.m_broadPhase;this.m_broadPhase.query(t,(function(t){var s=e.getUserData(t);return i(s.fixture)}))},c.prototype.rayCast=function(t,i,e){var s=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:i},(function(t,i){var n=s.getUserData(i),r=n.fixture,m=n.childIndex,a={};if(r.rayCast(a,t,m)){var h=a.fraction,_=o.add(o.mul(1-h,t.p1),o.mul(h,t.p2));return e(r,_,a.normal,h)}return t.maxFraction}))},c.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},c.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},c.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},c.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},c.prototype.shiftOrigin=function(t){if(!this.m_locked){for(var i=this.m_bodyList;i;i=i.m_next)i.m_xf.p.sub(t),i.m_sweep.c0.sub(t),i.m_sweep.c.sub(t);for(var e=this.m_jointList;e;e=e.m_next)e.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},c.prototype._addBody=function(t){this.isLocked()||(t.m_prev=null,t.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=t),this.m_bodyList=t,++this.m_bodyCount)},c.prototype.createBody=function(t,i){if(this.isLocked())return null;t&&o.isValid(t)&&(t={position:t,angle:i});var e=new m(this,t);return this._addBody(e),e},c.prototype.createDynamicBody=function(t,i){return t?o.isValid(t)&&(t={position:t,angle:i}):t={},t.type="dynamic",this.createBody(t)},c.prototype.createKinematicBody=function(t,i){return t?o.isValid(t)&&(t={position:t,angle:i}):t={},t.type="kinematic",this.createBody(t)},c.prototype.destroyBody=function(t){if(!this.isLocked()){if(t.m_destroyed)return!1;for(var i=t.m_jointList;i;){var e=i;i=i.next,this.publish("remove-joint",e.joint),this.destroyJoint(e.joint),t.m_jointList=i}t.m_jointList=null;for(var s=t.m_contactList;s;){var o=s;s=s.next,this.destroyContact(o.contact),t.m_contactList=s}t.m_contactList=null;for(var n=t.m_fixtureList;n;){var r=n;n=n.m_next,this.publish("remove-fixture",r),r.destroyProxies(this.m_broadPhase),t.m_fixtureList=n}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,this.publish("remove-body",t),!0}},c.prototype.createJoint=function(t){if(this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var i=t.m_bodyB.getContactList();i;i=i.next)i.other==t.m_bodyA&&i.contact.flagForFiltering();return t},c.prototype.destroyJoint=function(t){if(!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var i=t.m_bodyA,e=t.m_bodyB;if(i.setAwake(!0),e.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==i.m_jointList&&(i.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==e.m_jointList&&(e.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,--this.m_jointCount,0==t.m_collideConnected)for(var s=e.getContactList();s;)s.other==i&&s.contact.flagForFiltering(),s=s.next;this.publish("remove-joint",t)}};var l=new r.TimeStep;c.prototype.step=function(t,i,e){if(this.publish("pre-step",t),(0|i)!==i&&(i=0),i=i||this.m_velocityIterations,e=e||this.m_positionIterations,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,l.reset(t),l.velocityIterations=i,l.positionIterations=e,l.warmStarting=this.m_warmStarting,l.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(l);for(var s=this.m_bodyList;s;s=s.getNext())0!=s.m_islandFlag&&(s.isStatic()||s.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(l),this.m_clearForces&&this.clearForces(),this.m_locked=!1,this.publish("post-step",t)},c.prototype.findNewContacts=function(){this.m_broadPhase.updatePairs(this.addPair)},c.prototype.createContact=function(t,i){var e=t.fixture,s=i.fixture,o=t.childIndex,n=i.childIndex,r=e.getBody(),m=s.getBody();if(r!=m){for(var a=m.getContactList();a;){if(a.other==r){var _=a.contact.getFixtureA(),c=a.contact.getFixtureB(),l=a.contact.getChildIndexA(),u=a.contact.getChildIndexB();if(_==e&&c==s&&l==o&&u==n)return;if(_==s&&c==e&&l==n&&u==o)return}a=a.next}if(0!=m.shouldCollide(r)&&0!=s.shouldCollide(e)){var p=h.create(e,o,s,n);null!=p&&(p.m_prev=null,null!=this.m_contactList&&(p.m_next=this.m_contactList,this.m_contactList.m_prev=p),this.m_contactList=p,++this.m_contactCount)}}},c.prototype.updateContacts=function(){for(var t,i=this.m_contactList;t=i;){i=t.getNext();var e=t.getFixtureA(),s=t.getFixtureB(),o=t.getChildIndexA(),n=t.getChildIndexB(),r=e.getBody(),m=s.getBody();if(t.m_filterFlag){if(0==m.shouldCollide(r)){this.destroyContact(t);continue}if(0==s.shouldCollide(e)){this.destroyContact(t);continue}t.m_filterFlag=!1}var a=r.isAwake()&&!r.isStatic(),h=m.isAwake()&&!m.isStatic();if(0!=a||0!=h){var _=e.m_proxies[o].proxyId,c=s.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(_,c)?t.update(this):this.destroyContact(t)}}},c.prototype.destroyContact=function(t){h.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},c.prototype._listeners=null,c.prototype.on=function(t,i){return"string"!=typeof t||"function"!=typeof i||(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(i)),this},c.prototype.off=function(t,i){if("string"!=typeof t||"function"!=typeof i)return this;var e=this._listeners&&this._listeners[t];if(!e||!e.length)return this;var s=e.indexOf(i);return s>=0&&e.splice(s,1),this},c.prototype.publish=function(t,i,e,s){var o=this._listeners&&this._listeners[t];if(!o||!o.length)return 0;for(var n=0;n<o.length;n++)o[n].call(this,i,e,s);return o.length},c.prototype.beginContact=function(t){this.publish("begin-contact",t)},c.prototype.endContact=function(t){this.publish("end-contact",t)},c.prototype.preSolve=function(t,i){this.publish("pre-solve",t,i)},c.prototype.postSolve=function(t,i){this.publish("post-solve",t,i)}},function(t,i,e){var s=e(4),o=(e(2),e(41)),n=e(0),r=e(1),m=e(16);function a(t){this.id=t,this.aabb=new m,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.toString=function(){return this.id+": "+this.userData}}function h(){this.m_root=null,this.m_nodes={},this.m_lastProxyId=0,this.m_pool=new o({create:function(){return new a}})}t.exports=h,a.prototype.isLeaf=function(){return null==this.child1},h.prototype.getUserData=function(t){var i=this.m_nodes[t];return i.userData},h.prototype.getFatAABB=function(t){var i=this.m_nodes[t];return i.aabb},h.prototype.allocateNode=function(){var t=this.m_pool.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},h.prototype.freeNode=function(t){this.m_pool.release(t),t.height=-1,delete this.m_nodes[t.id]},h.prototype.createProxy=function(t,i){var e=this.allocateNode();return e.aabb.set(t),m.extend(e.aabb,s.aabbExtension),e.userData=i,e.height=0,this.insertLeaf(e),e.id},h.prototype.destroyProxy=function(t){var i=this.m_nodes[t];this.removeLeaf(i),this.freeNode(i)},h.prototype.moveProxy=function(t,i,e){var o=this.m_nodes[t];return!o.aabb.contains(i)&&(this.removeLeaf(o),o.aabb.set(i),i=o.aabb,m.extend(i,s.aabbExtension),e.x<0?i.lowerBound.x+=e.x*s.aabbMultiplier:i.upperBound.x+=e.x*s.aabbMultiplier,e.y<0?i.lowerBound.y+=e.y*s.aabbMultiplier:i.upperBound.y+=e.y*s.aabbMultiplier,this.insertLeaf(o),!0)},h.prototype.insertLeaf=function(t){if(null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var i=t.aabb,e=this.m_root;0==e.isLeaf();){var s=e.child1,o=e.child2,n=e.aabb.getPerimeter(),a=new m;a.combine(e.aabb,i);var h,_,c=a.getPerimeter(),l=2*c,u=2*(c-n);if(s.isLeaf()){(y=new m).combine(i,s.aabb),h=y.getPerimeter()+u}else{(y=new m).combine(i,s.aabb);var p=s.aabb.getPerimeter();h=y.getPerimeter()-p+u}if(o.isLeaf()){(y=new m).combine(i,o.aabb),_=y.getPerimeter()+u}else{var y;(y=new m).combine(i,o.aabb);p=o.aabb.getPerimeter();_=y.getPerimeter()-p+u}if(l<h&&l<_)break;e=h<_?s:o}var d=e,f=d.parent,v=this.allocateNode();for(v.parent=f,v.userData=null,v.aabb.combine(i,d.aabb),v.height=d.height+1,null!=f?(f.child1==d?f.child1=v:f.child2=v,v.child1=d,v.child2=t,d.parent=v,t.parent=v):(v.child1=d,v.child2=t,d.parent=v,t.parent=v,this.m_root=v),e=t.parent;null!=e;){s=(e=this.balance(e)).child1,o=e.child2;e.height=1+r.max(s.height,o.height),e.aabb.combine(s.aabb,o.aabb),e=e.parent}},h.prototype.removeLeaf=function(t){if(t!=this.m_root){var i,e=t.parent,s=e.parent;if(i=e.child1==t?e.child2:e.child1,null!=s){s.child1==e?s.child1=i:s.child2=i,i.parent=s,this.freeNode(e);for(var o=s;null!=o;){var n=(o=this.balance(o)).child1,m=o.child2;o.aabb.combine(n.aabb,m.aabb),o.height=1+r.max(n.height,m.height),o=o.parent}}else this.m_root=i,i.parent=null,this.freeNode(e)}else this.m_root=null},h.prototype.balance=function(t){var i=t;if(i.isLeaf()||i.height<2)return t;var e=i.child1,s=i.child2,o=s.height-e.height;if(o>1){var n=s.child1,m=s.child2;return s.child1=i,s.parent=i.parent,i.parent=s,null!=s.parent?s.parent.child1==t?s.parent.child1=s:s.parent.child2=s:this.m_root=s,n.height>m.height?(s.child2=n,i.child2=m,m.parent=i,i.aabb.combine(e.aabb,m.aabb),s.aabb.combine(i.aabb,n.aabb),i.height=1+r.max(e.height,m.height),s.height=1+r.max(i.height,n.height)):(s.child2=m,i.child2=n,n.parent=i,i.aabb.combine(e.aabb,n.aabb),s.aabb.combine(i.aabb,m.aabb),i.height=1+r.max(e.height,n.height),s.height=1+r.max(i.height,m.height)),s}if(o<-1){var a=e.child1,h=e.child2;return e.child1=i,e.parent=i.parent,i.parent=e,null!=e.parent?e.parent.child1==i?e.parent.child1=e:e.parent.child2=e:this.m_root=e,a.height>h.height?(e.child2=a,i.child1=h,h.parent=i,i.aabb.combine(s.aabb,h.aabb),e.aabb.combine(i.aabb,a.aabb),i.height=1+r.max(s.height,h.height),e.height=1+r.max(i.height,a.height)):(e.child2=h,i.child1=a,a.parent=i,i.aabb.combine(s.aabb,a.aabb),e.aabb.combine(i.aabb,h.aabb),i.height=1+r.max(s.height,a.height),e.height=1+r.max(i.height,h.height)),e}return i},h.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},h.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,i=this.m_root.aabb.getPerimeter(),e=0,s=l.allocate().preorder(this.m_root);t=s.next();)t.height<0||(e+=t.aabb.getPerimeter());return l.release(s),e/i},h.prototype.computeHeight=function(t){var i;if((i=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var e=this.computeHeight(i.child1.id),s=this.computeHeight(i.child2.id);return 1+r.max(e,s)},h.prototype.validateStructure=function(t){if(null!=t){this.m_root;var i=t.child1,e=t.child2;t.isLeaf()||(this.validateStructure(i),this.validateStructure(e))}},h.prototype.validateMetrics=function(t){if(null!=t){var i=t.child1,e=t.child2;if(!t.isLeaf()){var s=i.height,o=e.height,n=(r.max(s,o),new m);n.combine(i.aabb,e.aabb),this.validateMetrics(i),this.validateMetrics(e)}}},h.prototype.validate=function(){this.validateStructure(this.m_root),this.validateMetrics(this.m_root)},h.prototype.getMaxBalance=function(){for(var t,i=0,e=l.allocate().preorder(this.m_root);t=e.next();)if(!(t.height<=1)){var s=r.abs(t.child2.height-t.child1.height);i=r.max(i,s)}return l.release(e),i},h.prototype.rebuildBottomUp=function(){for(var t,i=[],e=0,s=l.allocate().preorder(this.m_root);t=s.next();)t.height<0||(t.isLeaf()?(t.parent=null,i[e]=t,++e):this.freeNode(t));for(l.release(s);e>1;){for(var o=1/0,n=-1,a=-1,h=0;h<e;++h)for(var _=i[h].aabb,c=h+1;c<e;++c){var u=i[c].aabb,p=new m;p.combine(_,u);var y=p.getPerimeter();y<o&&(n=h,a=c,o=y)}var d=i[n],f=i[a],v=this.allocateNode();v.child1=d,v.child2=f,v.height=1+r.max(d.height,f.height),v.aabb.combine(d.aabb,f.aabb),v.parent=null,d.parent=v,f.parent=v,i[a]=i[e-1],i[n]=v,--e}this.m_root=i[0],this.validate()},h.prototype.shiftOrigin=function(t){for(var i,e=l.allocate().preorder(this.m_root);i=e.next();){var s=i.aabb;s.lowerBound.x-=t.x,s.lowerBound.y-=t.y,s.upperBound.x-=t.x,s.upperBound.y-=t.y}l.release(e)},h.prototype.query=function(t,i){var e=c.allocate();for(e.push(this.m_root);e.length>0;){var s=e.pop();if(null!=s)if(m.testOverlap(s.aabb,t))if(s.isLeaf()){if(0==i(s.id))return}else e.push(s.child1),e.push(s.child2)}c.release(e)},h.prototype.rayCast=function(t,i){var e=t.p1,s=t.p2,o=n.sub(s,e);o.normalize();var a=n.cross(1,o),h=n.abs(a),l=t.maxFraction,u=new m,p=n.combine(1-l,e,l,s);u.combinePoints(e,p);var y=c.allocate(),d=_.allocate();for(y.push(this.m_root);y.length>0;){var f=y.pop();if(null!=f&&0!=m.testOverlap(f.aabb,u)){var v=f.aabb.getCenter(),x=f.aabb.getExtents();if(!(r.abs(n.dot(a,n.sub(e,v)))-n.dot(h,x)>0))if(f.isLeaf()){d.p1=n.clone(t.p1),d.p2=n.clone(t.p2),d.maxFraction=l;var A=i(d,f.id);if(0==A)return;A>0&&(l=A,p=n.combine(1-l,e,l,s),u.combinePoints(e,p))}else y.push(f.child1),y.push(f.child2)}}c.release(y),_.release(d)};var _=new o({create:function(){return{}},release:function(t){}}),c=new o({create:function(){return[]},release:function(t){t.length=0}}),l=new o({create:function(){return new u},release:function(t){t.close()}});function u(){var t=[],i=[];return{preorder:function(e){return t.length=0,t.push(e),i.length=0,i.push(0),this},next:function(){for(;t.length>0;){var e=t.length-1,s=t[e];if(0===i[e])return i[e]=1,s;if(1===i[e]&&(i[e]=2,s.child1))return t.push(s.child1),i.push(1),s.child1;if(2===i[e]&&(i[e]=3,s.child2))return t.push(s.child2),i.push(1),s.child2;t.pop(),i.pop()}},close:function(){t.length=0}}}},function(t,i,e){t.exports=function(t,i){var e=o.now();++n.toiCalls,t.state=d.e_unknown,t.t=i.tMax;var m=i.proxyA,a=i.proxyB,h=i.sweepA,p=i.sweepB;h.normalize(),p.normalize();var v=i.tMax,x=m.m_radius+a.m_radius,A=r.max(s.linearSlop,x-3*s.linearSlop),b=.25*s.linearSlop;var g=0,B=s.maxTOIIterations,w=0,C=new y,M=new l;for(M.proxyA=i.proxyA,M.proxyB=i.proxyB,M.useRadii=!1;;){var I=_.identity(),z=_.identity();h.getTransform(I,g),p.getTransform(z,g),M.transformA=I,M.transformB=z;var S=new u;if(c(S,C,M),S.distance<=0){t.state=d.e_overlapped,t.t=0;break}if(S.distance<A+b){t.state=d.e_touching,t.t=g;break}var V=new f;V.initialize(C,m,h,a,p,g);for(var P=!1,T=v,L=0;;){var q=V.findMinSeparation(T);V.indexA,V.indexB;if(q>A+b){t.state=d.e_separated,t.t=v,P=!0;break}if(q>A-b){g=T;break}var F=V.evaluate(g);V.indexA,V.indexB;if(F<A-b){t.state=d.e_failed,t.t=g,P=!0;break}if(F<=A+b){t.state=d.e_touching,t.t=g,P=!0;break}for(var k=0,j=g,D=T;;){var R;R=1&k?j+(A-F)*(D-j)/(q-F):.5*(j+D),++k,++n.toiRootIters;var O=V.evaluate(R);V.indexA,V.indexB;if(r.abs(O-A)<b){T=R;break}if(O>A?(j=R,F=O):(D=R,q=O),50==k)break}if(n.toiMaxRootIters=r.max(n.toiMaxRootIters,k),++L==s.maxPolygonVertices)break}if(++w,++n.toiIters,P)break;if(w==B){t.state=d.e_failed,t.t=g;break}}n.toiMaxIters=r.max(n.toiMaxIters,w);var E=o.diff(e);n.toiMaxTime=r.max(n.toiMaxTime,E),n.toiTime+=E},t.exports.Input=function(){this.proxyA=new p,this.proxyB=new p,this.sweepA=new h,this.sweepB=new h,this.tMax},t.exports.Output=d;var s=e(4),o=(e(2),e(43)),n=e(27),r=e(1),m=e(0),a=(e(7),e(10),e(14),e(3)),h=e(9),_=e(5),c=(e(12),e(13),e(21)),l=c.Input,u=c.Output,p=c.Proxy,y=c.Cache;function d(){this.state,this.t}d.e_unknown=0,d.e_failed=1,d.e_overlapped=2,d.e_touching=3,d.e_separated=4,n.toiTime=0,n.toiMaxTime=0,n.toiCalls=0,n.toiIters=0,n.toiMaxIters=0,n.toiRootIters=0,n.toiMaxRootIters=0;function f(){this.m_proxyA=new p,this.m_proxyB=new p,this.m_sweepA,this.m_sweepB,this.indexA,this.indexB,this.m_type,this.m_localPoint=m.zero(),this.m_axis=m.zero()}f.prototype.initialize=function(t,i,e,s,o,n){this.m_proxyA=i,this.m_proxyB=s;var r=t.count;this.m_sweepA=e,this.m_sweepB=o;var h=_.identity(),c=_.identity();if(this.m_sweepA.getTransform(h,n),this.m_sweepB.getTransform(c,n),1==r){this.m_type=1;var l=this.m_proxyA.getVertex(t.indexA[0]),u=this.m_proxyB.getVertex(t.indexB[0]),p=_.mulVec2(h,l),y=_.mulVec2(c,u);return this.m_axis.setCombine(1,y,-1,p),b=this.m_axis.normalize()}if(t.indexA[0]==t.indexA[1]){this.m_type=3;var d=s.getVertex(t.indexB[0]),f=s.getVertex(t.indexB[1]);this.m_axis=m.cross(m.sub(f,d),1),this.m_axis.normalize();var v=a.mulVec2(c.q,this.m_axis);this.m_localPoint=m.mid(d,f);y=_.mulVec2(c,this.m_localPoint),l=i.getVertex(t.indexA[0]),p=_.mulVec2(h,l);return(b=m.dot(p,v)-m.dot(y,v))<0&&(this.m_axis=m.neg(this.m_axis),b=-b),b}this.m_type=2;var x=this.m_proxyA.getVertex(t.indexA[0]),A=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=m.cross(m.sub(A,x),1),this.m_axis.normalize();v=a.mulVec2(h.q,this.m_axis);this.m_localPoint=m.mid(x,A);var b;p=_.mulVec2(h,this.m_localPoint),u=this.m_proxyB.getVertex(t.indexB[0]),y=_.mulVec2(c,u);return(b=m.dot(y,v)-m.dot(p,v))<0&&(this.m_axis=m.neg(this.m_axis),b=-b),b},f.prototype.compute=function(t,i){var e=_.identity(),s=_.identity();switch(this.m_sweepA.getTransform(e,i),this.m_sweepB.getTransform(s,i),this.m_type){case 1:if(t){var o=a.mulTVec2(e.q,this.m_axis),n=a.mulTVec2(s.q,m.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(o),this.indexB=this.m_proxyB.getSupport(n)}var r=this.m_proxyA.getVertex(this.indexA),h=this.m_proxyB.getVertex(this.indexB),c=_.mulVec2(e,r),l=_.mulVec2(s,h);return m.dot(l,this.m_axis)-m.dot(c,this.m_axis);case 2:var u=a.mulVec2(e.q,this.m_axis);c=_.mulVec2(e,this.m_localPoint);if(t){n=a.mulTVec2(s.q,m.neg(u));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(n)}h=this.m_proxyB.getVertex(this.indexB),l=_.mulVec2(s,h);return m.dot(l,u)-m.dot(c,u);case 3:u=a.mulVec2(s.q,this.m_axis),l=_.mulVec2(s,this.m_localPoint);if(t){o=a.mulTVec2(e.q,m.neg(u));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(o)}r=this.m_proxyA.getVertex(this.indexA),c=_.mulVec2(e,r);return m.dot(c,u)-m.dot(l,u);default:return t&&(this.indexA=-1,this.indexB=-1),0}},f.prototype.findMinSeparation=function(t){return this.compute(!0,t)},f.prototype.evaluate=function(t){return this.compute(!1,t)}},function(t,i,e){t.exports=p;e(2);var s=e(6),o=e(4),n=e(1),r=e(0),m=e(7),a=e(10),h=e(14),_=e(3),c=(e(9),e(5),e(12),e(13),e(11)),l=e(8);p.TYPE="revolute-joint",c.TYPES[p.TYPE]=p,p._super=c,p.prototype=Object.create(p._super.prototype);var u={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1};function p(t,i,e,o){if(!(this instanceof p))return new p(t,i,e,o);t=s(t,u),c.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=p.TYPE,this.m_localAnchorA=r.clone(o?i.getLocalPoint(o):t.localAnchorA||r.zero()),this.m_localAnchorB=r.clone(o?e.getLocalPoint(o):t.localAnchorB||r.zero()),this.m_referenceAngle=n.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_impulse=m(),this.m_motorImpulse=0,this.m_lowerAngle=t.lowerAngle,this.m_upperAngle=t.upperAngle,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new h,this.m_motorMass,this.m_limitState=0}p.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,lowerAngle:this.m_lowerAngle,upperAngle:this.m_upperAngle,maxMotorTorque:this.m_maxMotorTorque,motorSpeed:this.m_motorSpeed,enableLimit:this.m_enableLimit,enableMotor:this.m_enableMotor,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,referenceAngle:this.m_referenceAngle}},p._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(l,t.bodyA,i),t.bodyB=e(l,t.bodyB,i),new p(t)},p.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB)},p.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},p.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},p.prototype.getReferenceAngle=function(){return this.m_referenceAngle},p.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},p.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},p.prototype.isMotorEnabled=function(){return this.m_enableMotor},p.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},p.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},p.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},p.prototype.getMotorSpeed=function(){return this.m_motorSpeed},p.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},p.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},p.prototype.isLimitEnabled=function(){return this.m_enableLimit},p.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},p.prototype.getLowerLimit=function(){return this.m_lowerAngle},p.prototype.getUpperLimit=function(){return this.m_upperAngle},p.prototype.setLimits=function(t,i){t==this.m_lowerAngle&&i==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=i)},p.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},p.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},p.prototype.getReactionForce=function(t){return r.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},p.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},p.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,m=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,c=_.neo(i),l=_.neo(m);this.m_rA=_.mulVec2(c,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=_.mulVec2(l,r.sub(this.m_localAnchorB,this.m_localCenterB));var u=this.m_invMassA,p=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,f=y+d===0;if(this.m_mass.ex.x=u+p+this.m_rA.y*this.m_rA.y*y+this.m_rB.y*this.m_rB.y*d,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*y-this.m_rB.y*this.m_rB.x*d,this.m_mass.ez.x=-this.m_rA.y*y-this.m_rB.y*d,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=u+p+this.m_rA.x*this.m_rA.x*y+this.m_rB.x*this.m_rB.x*d,this.m_mass.ez.y=this.m_rA.x*y+this.m_rB.x*d,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=y+d,this.m_motorMass=y+d,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||f)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==f){var v=m-i-this.m_referenceAngle;n.abs(this.m_upperAngle-this.m_lowerAngle)<2*o.angularSlop?this.m_limitState=3:v<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):v>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=0,this.m_impulse.z=0)}else this.m_limitState=0;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var x=r.neo(this.m_impulse.x,this.m_impulse.y);e.subMul(u,x),s-=y*(r.cross(this.m_rA,x)+this.m_motorImpulse+this.m_impulse.z),a.addMul(p,x),h+=d*(r.cross(this.m_rB,x)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=h},p.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,a=this.m_invMassA,h=this.m_invMassB,_=this.m_invIA,c=this.m_invIB,l=_+c===0;if(this.m_enableMotor&&3!=this.m_limitState&&0==l){var u=o-e-this.m_motorSpeed,p=-this.m_motorMass*u,y=this.m_motorImpulse,d=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=n.clamp(this.m_motorImpulse+p,-d,d),e-=_*(p=this.m_motorImpulse-y),o+=c*p}if(this.m_enableLimit&&0!=this.m_limitState&&0==l){var f=r.zero();f.addCombine(1,s,1,r.cross(o,this.m_rB)),f.subCombine(1,i,1,r.cross(e,this.m_rA));var v=o-e;u=m(f.x,f.y,v),p=m.neg(this.m_mass.solve33(u));if(3==this.m_limitState)this.m_impulse.add(p);else if(1==this.m_limitState){if(this.m_impulse.z+p.z<0){var x=r.combine(-1,f,this.m_impulse.z,r.neo(this.m_mass.ez.x,this.m_mass.ez.y)),A=this.m_mass.solve22(x);p.x=A.x,p.y=A.y,p.z=-this.m_impulse.z,this.m_impulse.x+=A.x,this.m_impulse.y+=A.y,this.m_impulse.z=0}else this.m_impulse.add(p)}else if(2==this.m_limitState){if(this.m_impulse.z+p.z>0){x=r.combine(-1,f,this.m_impulse.z,r.neo(this.m_mass.ez.x,this.m_mass.ez.y)),A=this.m_mass.solve22(x);p.x=A.x,p.y=A.y,p.z=-this.m_impulse.z,this.m_impulse.x+=A.x,this.m_impulse.y+=A.y,this.m_impulse.z=0}else this.m_impulse.add(p)}var b=r.neo(p.x,p.y);i.subMul(a,b),e-=_*(r.cross(this.m_rA,b)+p.z),s.addMul(h,b),o+=c*(r.cross(this.m_rB,b)+p.z)}else{(u=r.zero()).addCombine(1,s,1,r.cross(o,this.m_rB)),u.subCombine(1,i,1,r.cross(e,this.m_rA));p=this.m_mass.solve22(r.neg(u));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y,i.subMul(a,p),e-=_*r.cross(this.m_rA,p),s.addMul(h,p),o+=c*r.cross(this.m_rB,p)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=o},p.prototype.solvePositionConstraints=function(t){var i,e=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,m=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,c=_.neo(s),l=_.neo(h),u=0,p=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&0!=this.m_limitState&&0==p){var y=h-s-this.m_referenceAngle,d=0;if(3==this.m_limitState){var f=n.clamp(y-this.m_lowerAngle,-o.maxAngularCorrection,o.maxAngularCorrection);d=-this.m_motorMass*f,u=n.abs(f)}else if(1==this.m_limitState){u=-(f=y-this.m_lowerAngle),f=n.clamp(f+o.angularSlop,-o.maxAngularCorrection,0),d=-this.m_motorMass*f}else if(2==this.m_limitState){u=f=y-this.m_upperAngle,f=n.clamp(f-o.angularSlop,0,o.maxAngularCorrection),d=-this.m_motorMass*f}s-=this.m_invIA*d,h+=this.m_invIB*d}c.set(s),l.set(h);var v=_.mulVec2(c,r.sub(this.m_localAnchorA,this.m_localCenterA)),x=_.mulVec2(l,r.sub(this.m_localAnchorB,this.m_localCenterB));(f=r.zero()).addCombine(1,m,1,x),f.subCombine(1,e,1,v),i=f.length();var A=this.m_invMassA,b=this.m_invMassB,g=this.m_invIA,B=this.m_invIB,w=new a;w.ex.x=A+b+g*v.y*v.y+B*x.y*x.y,w.ex.y=-g*v.x*v.y-B*x.x*x.y,w.ey.x=w.ex.y,w.ey.y=A+b+g*v.x*v.x+B*x.x*x.x;var C=r.neg(w.solve(f));return e.subMul(A,C),s-=g*r.cross(v,C),m.addMul(b,C),h+=B*r.cross(x,C),this.m_bodyA.c_position.c.set(e),this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c.set(m),this.m_bodyB.c_position.a=h,i<=o.linearSlop&&u<=o.angularSlop}},function(t,i,e){t.exports=p;e(2);var s=e(6),o=e(4),n=e(1),r=e(0),m=e(7),a=e(10),h=e(14),_=e(3),c=(e(9),e(5),e(12),e(13),e(11)),l=e(8);p.TYPE="prismatic-joint",c.TYPES[p.TYPE]=p,p._super=c,p.prototype=Object.create(p._super.prototype);var u={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0};function p(t,i,e,o,a){if(!(this instanceof p))return new p(t,i,e,o,a);t=s(t,u),c.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=p.TYPE,this.m_localAnchorA=r.clone(o?i.getLocalPoint(o):t.localAnchorA||r.zero()),this.m_localAnchorB=r.clone(o?e.getLocalPoint(o):t.localAnchorB||r.zero()),this.m_localXAxisA=r.clone(a?i.getLocalVector(a):t.localAxisA||r.neo(1,0)),this.m_localXAxisA.normalize(),this.m_localYAxisA=r.cross(1,this.m_localXAxisA),this.m_referenceAngle=n.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_impulse=m(),this.m_motorMass=0,this.m_motorImpulse=0,this.m_lowerTranslation=t.lowerTranslation,this.m_upperTranslation=t.upperTranslation,this.m_maxMotorForce=t.maxMotorForce,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_limitState=0,this.m_axis=r.zero(),this.m_perp=r.zero(),this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_axis,this.m_perp,this.m_s1,this.m_s2,this.m_a1,this.m_a2,this.m_K=new h,this.m_motorMass}p.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,lowerTranslation:this.m_lowerTranslation,upperTranslation:this.m_upperTranslation,maxMotorForce:this.m_maxMotorForce,motorSpeed:this.m_motorSpeed,enableLimit:this.m_enableLimit,enableMotor:this.m_enableMotor,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,localAxisA:this.m_localXAxisA,referenceAngle:this.m_referenceAngle}},p._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(l,t.bodyA,i),t.bodyB=e(l,t.bodyB,i),t.localAxisA=r(t.localAxisA),new p(t)},p.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB),t.localAxisA&&(this.m_localXAxisA.set(t.localAxisA),this.m_localYAxisA.set(r.cross(1,t.localAxisA)))},p.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},p.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},p.prototype.getLocalAxisA=function(){return this.m_localXAxisA},p.prototype.getReferenceAngle=function(){return this.m_referenceAngle},p.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_bodyB.getWorldPoint(this.m_localAnchorB),e=r.sub(i,t),s=this.m_bodyA.getWorldVector(this.m_localXAxisA);return r.dot(e,s)},p.prototype.getJointSpeed=function(){var t=this.m_bodyA,i=this.m_bodyB,e=_.mulVec2(t.m_xf.q,r.sub(this.m_localAnchorA,t.m_sweep.localCenter)),s=_.mulVec2(i.m_xf.q,r.sub(this.m_localAnchorB,i.m_sweep.localCenter)),o=r.add(t.m_sweep.c,e),n=r.add(i.m_sweep.c,s),m=r.sub(n,o),a=_.mulVec2(t.m_xf.q,this.m_localXAxisA),h=t.m_linearVelocity,c=i.m_linearVelocity,l=t.m_angularVelocity,u=i.m_angularVelocity;return r.dot(m,r.cross(l,a))+r.dot(a,r.sub(r.addCross(c,u,s),r.addCross(h,l,e)))},p.prototype.isLimitEnabled=function(){return this.m_enableLimit},p.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},p.prototype.getLowerLimit=function(){return this.m_lowerTranslation},p.prototype.getUpperLimit=function(){return this.m_upperTranslation},p.prototype.setLimits=function(t,i){t==this.m_lowerTranslation&&i==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=i,this.m_impulse.z=0)},p.prototype.isMotorEnabled=function(){return this.m_enableMotor},p.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},p.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},p.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},p.prototype.getMaxMotorForce=function(){return this.m_maxMotorForce},p.prototype.getMotorSpeed=function(){return this.m_motorSpeed},p.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},p.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},p.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},p.prototype.getReactionForce=function(t){return r.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis).mul(t)},p.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},p.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyA.c_velocity.v,m=this.m_bodyA.c_velocity.w,a=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=_.neo(e),p=_.neo(h),y=_.mulVec2(u,r.sub(this.m_localAnchorA,this.m_localCenterA)),d=_.mulVec2(p,r.sub(this.m_localAnchorB,this.m_localCenterB)),f=r.zero();f.addCombine(1,a,1,d),f.subCombine(1,i,1,y);var v=this.m_invMassA,x=this.m_invMassB,A=this.m_invIA,b=this.m_invIB;this.m_axis=_.mulVec2(u,this.m_localXAxisA),this.m_a1=r.cross(r.add(f,y),this.m_axis),this.m_a2=r.cross(d,this.m_axis),this.m_motorMass=v+x+A*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=_.mulVec2(u,this.m_localYAxisA),this.m_s1=r.cross(r.add(f,y),this.m_perp),this.m_s2=r.cross(d,this.m_perp);r.cross(y,this.m_perp);var g=v+x+A*this.m_s1*this.m_s1+b*this.m_s2*this.m_s2,B=A*this.m_s1+b*this.m_s2,w=A*this.m_s1*this.m_a1+b*this.m_s2*this.m_a2,C=A+b;0==C&&(C=1);var M=A*this.m_a1+b*this.m_a2,I=v+x+A*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2;if(this.m_K.ex.set(g,B,w),this.m_K.ey.set(B,C,M),this.m_K.ez.set(w,M,I),this.m_enableLimit){var z=r.dot(this.m_axis,f);n.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*o.linearSlop?this.m_limitState=3:z<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):z>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=0,this.m_impulse.z=0)}else this.m_limitState=0,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var S=r.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),V=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,P=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;s.subMul(v,S),m-=A*V,c.addMul(x,S),l+=b*P}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(s),this.m_bodyA.c_velocity.w=m,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=l},p.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,a=this.m_invMassA,h=this.m_invMassB,_=this.m_invIA,c=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var l=r.dot(this.m_axis,r.sub(s,i))+this.m_a2*o-this.m_a1*e,u=this.m_motorMass*(this.m_motorSpeed-l),p=this.m_motorImpulse,y=t.dt*this.m_maxMotorForce;this.m_motorImpulse=n.clamp(this.m_motorImpulse+u,-y,y),u=this.m_motorImpulse-p;var d=r.mul(u,this.m_axis),f=u*this.m_a1,v=u*this.m_a2;i.subMul(a,d),e-=_*f,s.addMul(h,d),o+=c*v}var x=r.zero();if(x.x+=r.dot(this.m_perp,s)+this.m_s2*o,x.x-=r.dot(this.m_perp,i)+this.m_s1*e,x.y=o-e,this.m_enableLimit&&0!=this.m_limitState){var A=0;A+=r.dot(this.m_axis,s)+this.m_a2*o,A-=r.dot(this.m_axis,i)+this.m_a1*e;l=m(x.x,x.y,A);var b=m(this.m_impulse),g=this.m_K.solve33(m.neg(l));this.m_impulse.add(g),1==this.m_limitState?this.m_impulse.z=n.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=n.min(this.m_impulse.z,0));var B=r.combine(-1,x,-(this.m_impulse.z-b.z),r.neo(this.m_K.ez.x,this.m_K.ez.y)),w=r.add(this.m_K.solve22(B),r.neo(b.x,b.y));this.m_impulse.x=w.x,this.m_impulse.y=w.y,g=m.sub(this.m_impulse,b);d=r.combine(g.x,this.m_perp,g.z,this.m_axis),f=g.x*this.m_s1+g.y+g.z*this.m_a1,v=g.x*this.m_s2+g.y+g.z*this.m_a2;i.subMul(a,d),e-=_*f,s.addMul(h,d),o+=c*v}else{g=this.m_K.solve22(r.neg(x));this.m_impulse.x+=g.x,this.m_impulse.y+=g.y;d=r.mul(g.x,this.m_perp),f=g.x*this.m_s1+g.y,v=g.x*this.m_s2+g.y;i.subMul(a,d),e-=_*f,s.addMul(h,d),o+=c*v}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=o},p.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,l=_.neo(e),u=_.neo(c),p=this.m_invMassA,y=this.m_invMassB,d=this.m_invIA,f=this.m_invIB,v=_.mulVec2(l,r.sub(this.m_localAnchorA,this.m_localCenterA)),x=_.mulVec2(u,r.sub(this.m_localAnchorB,this.m_localCenterB)),A=r.sub(r.add(s,x),r.add(i,v)),b=_.mulVec2(l,this.m_localXAxisA),g=r.cross(r.add(A,v),b),B=r.cross(x,b),w=_.mulVec2(l,this.m_localYAxisA),C=r.cross(r.add(A,v),w),M=r.cross(x,w),I=m(),z=r.zero();z.x=r.dot(w,A),z.y=c-e-this.m_referenceAngle;var S=n.abs(z.x),V=n.abs(z.y),P=o.linearSlop,T=o.maxLinearCorrection,L=!1,q=0;if(this.m_enableLimit){var F=r.dot(b,A);n.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*P?(q=n.clamp(F,-T,T),S=n.max(S,n.abs(F)),L=!0):F<=this.m_lowerTranslation?(q=n.clamp(F-this.m_lowerTranslation+P,-T,0),S=n.max(S,this.m_lowerTranslation-F),L=!0):F>=this.m_upperTranslation&&(q=n.clamp(F-this.m_upperTranslation-P,0,T),S=n.max(S,F-this.m_upperTranslation),L=!0)}if(L){var k=p+y+d*C*C+f*M*M,j=d*C+f*M,D=d*C*g+f*M*B;0==(Y=d+f)&&(Y=1);var R=d*g+f*B,O=p+y+d*g*g+f*B*B;(J=new h).ex.set(k,j,D),J.ey.set(j,Y,R),J.ez.set(D,R,O);var E=m();E.x=z.x,E.y=z.y,E.z=q,I=J.solve33(m.neg(E))}else{var Y,J;k=p+y+d*C*C+f*M*M,j=d*C+f*M;0==(Y=d+f)&&(Y=1),(J=new a).ex.set(k,j),J.ey.set(j,Y);var N=J.solve(r.neg(z));I.x=N.x,I.y=N.y,I.z=0}var W=r.combine(I.x,w,I.z,b),H=I.x*C+I.y+I.z*g,Z=I.x*M+I.y+I.z*B;return i.subMul(p,W),e-=d*H,s.addMul(y,W),c+=f*Z,this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=s,this.m_bodyB.c_position.a=c,S<=o.linearSlop&&V<=o.angularSlop}},,,,function(t,i,e){i.internal={},i.Serializer=e(39),i.Math=e(1),i.Vec2=e(0),i.Vec3=e(7),i.Mat22=e(10),i.Mat33=e(14),i.Transform=e(5),i.Rot=e(3),i.AABB=e(16),i.Shape=e(15),i.Fixture=e(26),i.Body=e(8),i.Contact=e(17),i.Joint=e(11),i.World=e(30),i.Circle=e(22),i.Edge=e(23),i.Polygon=e(20),i.Chain=e(28),i.Box=e(44),e(45),e(46),i.internal.CollidePolygons=e(47),e(48),e(49),i.DistanceJoint=e(50),i.FrictionJoint=e(51),i.GearJoint=e(52),i.MotorJoint=e(53),i.MouseJoint=e(54),i.PrismaticJoint=e(34),i.PulleyJoint=e(55),i.RevoluteJoint=e(33),i.RopeJoint=e(56),i.WeldJoint=e(57),i.WheelJoint=e(58),i.Settings=e(4),i.internal.Sweep=e(9),i.internal.stats=e(27),i.internal.Manifold=e(18),i.internal.Distance=e(21),i.internal.TimeOfImpact=e(32),i.internal.DynamicTree=e(31),i.internal.Settings=i.Settings},function(t,i,e){var s=e(30),o=e(8),n=e(11),r=e(26),m=e(15),a=e(0),h=e(7),_=0;function c(t){var i=(t=t||{}).rootClass||s,e=t.preSerialize||function(t){return t},c=t.postSerialize||function(t,i){return t},l=t.preDeserialize||function(t){return t},u=t.postDeserialize||function(t,i){return t},p={World:s,Body:o,Joint:n,Fixture:r,Shape:m},y=Object.assign({Vec2:a,Vec3:h},p);this.toJson=function(t){var i=[],s=[t],o={};function n(t,e){if(t.__sid=t.__sid||++_,!o[t.__sid]){s.push(t);var n={refIndex:i.length+s.length,refType:e};o[t.__sid]=n}return o[t.__sid]}function r(t,i){if("object"!=typeof t||null===t)return t;if("function"==typeof t._serialize){if(t!==i)for(var s in p)if(t instanceof p[s])return n(t,s);t=function(t){var i=(t=e(t))._serialize();return i=c(i,t)}(t)}if(Array.isArray(t)){for(var o=[],m=0;m<t.length;m++)o[m]=r(t[m]);t=o}else{o={};for(var m in t)t.hasOwnProperty(m)&&(o[m]=r(t[m]));t=o}return t}for(;s.length;){var m=s.shift(),a=r(m,m);i.push(a)}return i},this.fromJson=function(t){var e={};function s(t,i,e){i=l(i);var s=t._deserialize(i,e,o);return s=u(s,i)}function o(i,o,n){if(!o.refIndex)return i&&i._deserialize&&s(i,o,n);i=y[o.refType]||i;var r=o.refIndex;if(!e[r]){var m=s(i,t[r],n);e[r]=m}return e[r]}return i._deserialize(t[0],null,o)}}t.exports=c;var l=new c;t.exports.toJson=l.toJson,t.exports.fromJson=l.fromJson},function(t,i,e){e(4),e(2);var s=e(1),o=e(16),n=e(31);function r(){this.m_tree=new n,this.m_proxyCount=0,this.m_moveBuffer=[],this.queryCallback=this.queryCallback.bind(this)}t.exports=r,r.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},r.prototype.testOverlap=function(t,i){var e=this.m_tree.getFatAABB(t),s=this.m_tree.getFatAABB(i);return o.testOverlap(e,s)},r.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},r.prototype.getProxyCount=function(){return this.m_proxyCount},r.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},r.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},r.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},r.prototype.query=function(t,i){this.m_tree.query(t,i)},r.prototype.rayCast=function(t,i){this.m_tree.rayCast(t,i)},r.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},r.prototype.createProxy=function(t,i){var e=this.m_tree.createProxy(t,i);return this.m_proxyCount++,this.bufferMove(e),e},r.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},r.prototype.moveProxy=function(t,i,e){this.m_tree.moveProxy(t,i,e)&&this.bufferMove(t)},r.prototype.touchProxy=function(t){this.bufferMove(t)},r.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},r.prototype.unbufferMove=function(t){for(var i=0;i<this.m_moveBuffer.length;++i)this.m_moveBuffer[i]==t&&(this.m_moveBuffer[i]=null)},r.prototype.updatePairs=function(t){for(this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var i=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(i,this.queryCallback)}},r.prototype.queryCallback=function(t){if(t==this.m_queryProxyId)return!0;var i=s.min(t,this.m_queryProxyId),e=s.max(t,this.m_queryProxyId),o=this.m_tree.getUserData(i),n=this.m_tree.getUserData(e);return this.m_callback(o,n),!0}},function(t,i,e){t.exports=function(t){var i=[],e=t.max||1/0,s=t.create,o=t.allocate,n=t.release,r=t.discard,m=0,a=0,h=0,_=0;this.max=function(t){return"number"==typeof t?(e=t,this):e},this.size=function(){return i.length},this.allocate=function(){var t;return i.length>0?t=i.shift():(m++,t="function"==typeof s?s():{}),a++,"function"==typeof o&&o(t),t},this.release=function(t){i.length<e?(h++,"function"==typeof n&&n(t),i.push(t)):(_++,"function"==typeof r&&(t=r(t)))},this.toString=function(){return" +"+m+" >"+a+" <"+h+" -"+_+" ="+i.length+"/"+e}}},function(t,i,e){t.exports=l,t.exports.TimeStep=c;var s=e(4),o=e(2),n=e(0),r=e(1),m=(e(8),e(17),e(11),e(32)),a=m.Input,h=m.Output,_=e(21);_.Input,_.Output,_.Proxy,_.Cache;function c(t){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}function l(t){this.m_world=t,this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}c.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},l.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},l.prototype.addBody=function(t){this.m_bodies.push(t)},l.prototype.addContact=function(t){this.m_contacts.push(t)},l.prototype.addJoint=function(t){this.m_joints.push(t)},l.prototype.solveWorld=function(t){for(var i=this.m_world,e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1;for(var s=i.m_contactList;s;s=s.m_next)s.m_islandFlag=!1;for(var o=i.m_jointList;o;o=o.m_next)o.m_islandFlag=!1;for(var n=this.m_stack,r=i.m_bodyList;r;r=r.m_next)if(!r.m_islandFlag&&0!=r.isAwake()&&0!=r.isActive()&&!r.isStatic()){for(this.clear(),n.push(r),r.m_islandFlag=!0;n.length>0;){e=n.pop();if(this.addBody(e),e.setAwake(!0),!e.isStatic()){for(var m=e.m_contactList;m;m=m.next){var a=m.contact;if(!a.m_islandFlag&&(0!=a.isEnabled()&&0!=a.isTouching())){var h=a.m_fixtureA.m_isSensor,_=a.m_fixtureB.m_isSensor;if(!h&&!_)this.addContact(a),a.m_islandFlag=!0,(l=m.other).m_islandFlag||(n.push(l),l.m_islandFlag=!0)}}for(var c=e.m_jointList;c;c=c.next){var l;if(1!=c.joint.m_islandFlag)0!=(l=c.other).isActive()&&(this.addJoint(c.joint),c.joint.m_islandFlag=!0,l.m_islandFlag||(n.push(l),l.m_islandFlag=!0))}}}this.solveIsland(t);for(var u=0;u<this.m_bodies.length;++u){(e=this.m_bodies[u]).isStatic()&&(e.m_islandFlag=!1)}}},l.prototype.solveIsland=function(t){for(var i=this.m_world,e=i.m_gravity,o=i.m_allowSleep,m=t.dt,a=0;a<this.m_bodies.length;++a){var h=this.m_bodies[a],_=n.clone(h.m_sweep.c),c=h.m_sweep.a,l=n.clone(h.m_linearVelocity),u=h.m_angularVelocity;h.m_sweep.c0.set(h.m_sweep.c),h.m_sweep.a0=h.m_sweep.a,h.isDynamic()&&(l.addMul(m*h.m_gravityScale,e),l.addMul(m*h.m_invMass,h.m_force),u+=m*h.m_invI*h.m_torque,l.mul(1/(1+m*h.m_linearDamping)),u*=1/(1+m*h.m_angularDamping)),h.c_position.c=_,h.c_position.a=c,h.c_velocity.v=l,h.c_velocity.w=u}for(a=0;a<this.m_contacts.length;++a){this.m_contacts[a].initConstraint(t)}for(a=0;a<this.m_contacts.length;++a){this.m_contacts[a].initVelocityConstraint(t)}if(t.warmStarting)for(a=0;a<this.m_contacts.length;++a){this.m_contacts[a].warmStartConstraint(t)}for(a=0;a<this.m_joints.length;++a){this.m_joints[a].initVelocityConstraints(t)}for(a=0;a<t.velocityIterations;++a){for(var p=0;p<this.m_joints.length;++p){this.m_joints[p].solveVelocityConstraints(t)}for(p=0;p<this.m_contacts.length;++p){this.m_contacts[p].solveVelocityConstraint(t)}}for(a=0;a<this.m_contacts.length;++a){this.m_contacts[a].storeConstraintImpulses(t)}for(a=0;a<this.m_bodies.length;++a){h=this.m_bodies[a],_=n.clone(h.c_position.c),c=h.c_position.a,l=n.clone(h.c_velocity.v),u=h.c_velocity.w;var y=n.mul(m,l);if(n.lengthSquared(y)>s.maxTranslationSquared){var d=s.maxTranslation/y.length();l.mul(d)}var f=m*u;if(f*f>s.maxRotationSquared)u*=d=s.maxRotation/r.abs(f);_.addMul(m,l),c+=m*u,h.c_position.c.set(_),h.c_position.a=c,h.c_velocity.v.set(l),h.c_velocity.w=u}var v=!1;for(a=0;a<t.positionIterations;++a){var x=0;for(p=0;p<this.m_contacts.length;++p){var A=this.m_contacts[p].solvePositionConstraint(t);x=r.min(x,A)}var b=x>=-3*s.linearSlop,g=!0;for(p=0;p<this.m_joints.length;++p){var B=this.m_joints[p].solvePositionConstraints(t);g=g&&B}if(b&&g){v=!0;break}}for(a=0;a<this.m_bodies.length;++a){(h=this.m_bodies[a]).m_sweep.c.set(h.c_position.c),h.m_sweep.a=h.c_position.a,h.m_linearVelocity.set(h.c_velocity.v),h.m_angularVelocity=h.c_velocity.w,h.synchronizeTransform()}if(this.postSolveIsland(),o){var w=1/0,C=s.linearSleepToleranceSqr,M=s.angularSleepToleranceSqr;for(a=0;a<this.m_bodies.length;++a){(h=this.m_bodies[a]).isStatic()||(0==h.m_autoSleepFlag||h.m_angularVelocity*h.m_angularVelocity>M||n.lengthSquared(h.m_linearVelocity)>C?(h.m_sleepTime=0,w=0):(h.m_sleepTime+=m,w=r.min(w,h.m_sleepTime)))}if(w>=s.timeToSleep&&v)for(a=0;a<this.m_bodies.length;++a){(h=this.m_bodies[a]).setAwake(!1)}}},l.prototype.printBodies=function(t){for(var i=0;i<this.m_bodies.length;++i){var e=this.m_bodies[i];o.debug(t,e.c_position.a,e.c_position.c.x,e.c_position.c.y,e.c_velocity.w,e.c_velocity.v.x,e.c_velocity.v.y)}};var u=new c;function p(){this.normalImpulses=[],this.tangentImpulses=[]}l.prototype.solveWorldTOI=function(t){var i=this.m_world;if(i.m_stepComplete){for(var e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1,e.m_sweep.alpha0=0;for(var o=i.m_contactList;o;o=o.m_next)o.m_toiFlag=!1,o.m_islandFlag=!1,o.m_toiCount=0,o.m_toi=1}for(;;){for(var n=null,_=1,o=i.m_contactList;o;o=o.m_next)if(0!=o.isEnabled()&&!(o.m_toiCount>s.maxSubSteps)){var c=1;if(o.m_toiFlag)c=o.m_toi;else{var l=o.getFixtureA(),p=o.getFixtureB();if(l.isSensor()||p.isSensor())continue;var y=l.getBody(),d=p.getBody(),f=y.isAwake()&&!y.isStatic(),v=d.isAwake()&&!d.isStatic();if(0==f&&0==v)continue;var x=y.isBullet()||!y.isDynamic(),A=d.isBullet()||!d.isDynamic();if(0==x&&0==A)continue;var b=y.m_sweep.alpha0;y.m_sweep.alpha0<d.m_sweep.alpha0?(b=d.m_sweep.alpha0,y.m_sweep.advance(b)):d.m_sweep.alpha0<y.m_sweep.alpha0&&(b=y.m_sweep.alpha0,d.m_sweep.advance(b));var g=o.getChildIndexA(),B=o.getChildIndexB(),w=(y.m_sweep,d.m_sweep,new a);w.proxyA.set(l.getShape(),g),w.proxyB.set(p.getShape(),B),w.sweepA.set(y.m_sweep),w.sweepB.set(d.m_sweep),w.tMax=1;var C=new h;m(C,w);var M=C.t;c=C.state==h.e_touching?r.min(b+(1-b)*M,1):1,o.m_toi=c,o.m_toiFlag=!0}c<_&&(n=o,_=c)}if(null==n||1-10*r.EPSILON<_){i.m_stepComplete=!0;break}l=n.getFixtureA(),p=n.getFixtureB(),y=l.getBody(),d=p.getBody();var I=y.m_sweep.clone(),z=d.m_sweep.clone();if(y.advance(_),d.advance(_),n.update(i),n.m_toiFlag=!1,++n.m_toiCount,0!=n.isEnabled()&&0!=n.isTouching()){y.setAwake(!0),d.setAwake(!0),this.clear(),this.addBody(y),this.addBody(d),this.addContact(n),y.m_islandFlag=!0,d.m_islandFlag=!0,n.m_islandFlag=!0;for(var S=[y,d],V=0;V<S.length;++V){if((j=S[V]).isDynamic())for(var P=j.m_contactList;P;P=P.next){var T=P.contact;if(!T.m_islandFlag){var L=P.other;if(!L.isDynamic()||j.isBullet()||L.isBullet()){var q=T.m_fixtureA.m_isSensor,F=T.m_fixtureB.m_isSensor;if(!q&&!F){var k=L.m_sweep.clone();0==L.m_islandFlag&&L.advance(_),T.update(i),0!=T.isEnabled()&&0!=T.isTouching()?(T.m_islandFlag=!0,this.addContact(T),L.m_islandFlag||(L.m_islandFlag=!0,L.isStatic()||L.setAwake(!0),this.addBody(L))):(L.m_sweep.set(k),L.synchronizeTransform())}}}}}u.reset((1-_)*t.dt),u.dtRatio=1,u.positionIterations=20,u.velocityIterations=t.velocityIterations,u.warmStarting=!1,this.solveIslandTOI(u,y,d);for(V=0;V<this.m_bodies.length;++V){var j;if((j=this.m_bodies[V]).m_islandFlag=!1,j.isDynamic()){j.synchronizeFixtures();for(P=j.m_contactList;P;P=P.next)P.contact.m_toiFlag=!1,P.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else n.setEnabled(!1),y.m_sweep.set(I),d.m_sweep.set(z),y.synchronizeTransform(),d.synchronizeTransform()}},l.prototype.solveIslandTOI=function(t,i,e){this.m_world;for(var o=0;o<this.m_bodies.length;++o){(c=this.m_bodies[o]).c_position.c.set(c.m_sweep.c),c.c_position.a=c.m_sweep.a,c.c_velocity.v.set(c.m_linearVelocity),c.c_velocity.w=c.m_angularVelocity}for(var o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initConstraint(t)}for(o=0;o<t.positionIterations;++o){for(var m=0,a=0;a<this.m_contacts.length;++a){var h=this.m_contacts[a].solvePositionConstraintTOI(t,i,e);m=r.min(m,h)}if(m>=-1.5*s.linearSlop)break}i.m_sweep.c0.set(i.c_position.c),i.m_sweep.a0=i.c_position.a,e.m_sweep.c0.set(e.c_position.c),e.m_sweep.a0=e.c_position.a;for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initVelocityConstraint(t)}for(o=0;o<t.velocityIterations;++o)for(a=0;a<this.m_contacts.length;++a){this.m_contacts[a].solveVelocityConstraint(t)}var _=t.dt;for(o=0;o<this.m_bodies.length;++o){var c=this.m_bodies[o],l=n.clone(c.c_position.c),u=c.c_position.a,p=n.clone(c.c_velocity.v),y=c.c_velocity.w,d=n.mul(_,p);if(n.dot(d,d)>s.maxTranslationSquared){var f=s.maxTranslation/d.length();p.mul(f)}var v=_*y;if(v*v>s.maxRotationSquared)y*=f=s.maxRotation/r.abs(v);l.addMul(_,p),u+=_*y,c.c_position.c=l,c.c_position.a=u,c.c_velocity.v=p,c.c_velocity.w=y,c.m_sweep.c=l,c.m_sweep.a=u,c.m_linearVelocity=p,c.m_angularVelocity=y,c.synchronizeTransform()}this.postSolveIsland()},l.prototype.postSolveIsland=function(){for(var t=new p,i=0;i<this.m_contacts.length;++i){for(var e=this.m_contacts[i],s=0;s<e.v_points.length;++s)t.normalImpulses.push(e.v_points[s].normalImpulse),t.tangentImpulses.push(e.v_points[s].tangentImpulse);this.m_world.postSolve(e,t)}}},function(t,i,e){t.exports.now=function(){return Date.now()},t.exports.diff=function(t){return Date.now()-t}},function(t,i,e){t.exports=o;e(2);var s=e(20);function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);o._super.call(this),this._setAsBox(t,i,e,s)}o._super=s,o.prototype=Object.create(o._super.prototype),o.TYPE="polygon"},function(t,i,e){e(2),e(1);var s=e(5),o=e(0),n=(e(4),e(15),e(17)),r=e(18),m=e(22);function a(t,i,e,n,m){t.pointCount=0;var a=s.mulVec2(e,i.m_p),h=s.mulVec2(m,n.m_p),_=o.distanceSquared(h,a),c=i.m_radius+n.m_radius;_>c*c||(t.type=r.e_circles,t.localPoint.set(i.m_p),t.localNormal.setZero(),t.pointCount=1,t.points[0].localPoint.set(n.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=r.e_vertex)}n.addType(m.TYPE,m.TYPE,(function(t,i,e,s,o,n,r){a(t,e.getShape(),i,n.getShape(),o)})),i.CollideCircles=a},function(t,i,e){e(2),e(1);var s=e(5),o=e(0),n=(e(3),e(4),e(15),e(17)),r=e(18),m=e(23),a=e(28),h=e(22);function _(t,i,e,n,m){t.pointCount=0;var a=s.mulTVec2(e,s.mulVec2(m,n.m_p)),h=i.m_vertex1,_=i.m_vertex2,c=o.sub(_,h),l=o.dot(c,o.sub(_,a)),u=o.dot(c,o.sub(a,h)),p=i.m_radius+n.m_radius;if(u<=0){var y=o.clone(h),d=o.sub(a,y);if(o.dot(d,d)>p*p)return;if(i.m_hasVertex0){var f=i.m_vertex0,v=h,x=o.sub(v,f);if(o.dot(x,o.sub(v,a))>0)return}return t.type=r.e_circles,t.localNormal.setZero(),t.localPoint.set(y),t.pointCount=1,t.points[0].localPoint.set(n.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=r.e_vertex)}if(l<=0){y=o.clone(_),d=o.sub(a,y);if(o.dot(d,d)>p*p)return;if(i.m_hasVertex3){var A=i.m_vertex3,b=_,g=o.sub(A,b);if(o.dot(g,o.sub(a,b))>0)return}return t.type=r.e_circles,t.localNormal.setZero(),t.localPoint.set(y),t.pointCount=1,t.points[0].localPoint.set(n.m_p),t.points[0].id.cf.indexA=1,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=r.e_vertex)}var B=o.dot(c,c);y=o.combine(l/B,h,u/B,_),d=o.sub(a,y);if(!(o.dot(d,d)>p*p)){var w=o.neo(-c.y,c.x);o.dot(w,o.sub(a,h))<0&&w.set(-w.x,-w.y),w.normalize(),t.type=r.e_faceA,t.localNormal=w,t.localPoint.set(h),t.pointCount=1,t.points[0].localPoint.set(n.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_face,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=r.e_vertex}}n.addType(m.TYPE,h.TYPE,(function(t,i,e,s,o,n,r){var m=e.getShape(),a=n.getShape();_(t,m,i,a,o)})),n.addType(a.TYPE,h.TYPE,(function(t,i,e,s,o,n,r){var a=e.getShape(),h=new m;a.getChildEdge(h,s);var c=h,l=n.getShape();_(t,c,i,l,o)}))},function(t,i,e){e(2),e(1);var s=e(5),o=e(3),n=e(0),r=(e(16),e(4)),m=e(18),a=e(17),h=(e(15),e(20));function _(t,i,e,r){for(var m=t.m_count,a=e.m_count,h=t.m_normals,c=t.m_vertices,l=e.m_vertices,u=s.mulTXf(r,i),p=0,y=-1/0,d=0;d<m;++d){for(var f=o.mulVec2(u.q,h[d]),v=s.mulVec2(u,c[d]),x=1/0,A=0;A<a;++A){var b=n.dot(f,l[A])-n.dot(f,v);b<x&&(x=b)}x>y&&(y=x,p=d)}_._maxSeparation=y,_._bestIndex=p}function c(t,i,e,a,h){t.pointCount=0;var c=i.m_radius+a.m_radius;_(i,e,a,h);var l=_._bestIndex,u=_._maxSeparation;if(!(u>c)){_(a,h,i,e);var p=_._bestIndex,y=_._maxSeparation;if(!(y>c)){var d,f,v,x,A,b;y>u+.1*r.linearSlop?(d=a,f=i,v=h,x=e,A=p,t.type=m.e_faceB,b=1):(d=i,f=a,v=e,x=h,A=l,t.type=m.e_faceA,b=0);var g=[new m.clipVertex,new m.clipVertex];!function(t,i,e,r,a,h){for(var _=i.m_normals,c=a.m_count,l=a.m_vertices,u=a.m_normals,p=o.mulT(h.q,o.mulVec2(e.q,_[r])),y=0,d=1/0,f=0;f<c;++f){var v=n.dot(p,u[f]);v<d&&(d=v,y=f)}var x=y,A=x+1<c?x+1:0;t[0].v=s.mulVec2(h,l[x]),t[0].id.cf.indexA=r,t[0].id.cf.indexB=x,t[0].id.cf.typeA=m.e_face,t[0].id.cf.typeB=m.e_vertex,t[1].v=s.mulVec2(h,l[A]),t[1].id.cf.indexA=r,t[1].id.cf.indexB=A,t[1].id.cf.typeA=m.e_face,t[1].id.cf.typeB=m.e_vertex}(g,d,v,A,f,x);var B=d.m_count,w=d.m_vertices,C=A,M=A+1<B?A+1:0,I=w[C],z=w[M],S=n.sub(z,I);S.normalize();var V=n.cross(S,1),P=n.combine(.5,I,.5,z),T=o.mulVec2(v.q,S),L=n.cross(T,1);I=s.mulVec2(v,I),z=s.mulVec2(v,z);var q=n.dot(L,I),F=-n.dot(T,I)+c,k=n.dot(T,z)+c,j=[new m.clipVertex,new m.clipVertex],D=[new m.clipVertex,new m.clipVertex];if(!(m.clipSegmentToLine(j,g,n.neg(T),F,C)<2||m.clipSegmentToLine(D,j,T,k,M)<2)){t.localNormal=V,t.localPoint=P;for(var R=0,O=0;O<D.length;++O){if(n.dot(L,D[O].v)-q<=c){var E=t.points[R];if(E.localPoint.set(s.mulTVec2(x,D[O].v)),E.id=D[O].id,b){var Y=E.id.cf,J=Y.indexA,N=Y.indexB,W=Y.typeA,H=Y.typeB;Y.indexA=N,Y.indexB=J,Y.typeA=H,Y.typeB=W}++R}}t.pointCount=R}}}}t.exports=c,a.addType(h.TYPE,h.TYPE,(function(t,i,e,s,o,n,r){c(t,e.getShape(),i,n.getShape(),o)}))},function(t,i,e){e(2);var s=e(1),o=e(5),n=(e(3),e(0)),r=(e(16),e(4),e(18)),m=e(17),a=(e(15),e(22)),h=e(20);m.addType(h.TYPE,a.TYPE,(function(t,i,e,m,a,h,_){!function(t,i,e,m,a){t.pointCount=0;for(var h=o.mulVec2(a,m.m_p),_=o.mulTVec2(e,h),c=0,l=-1/0,u=i.m_radius+m.m_radius,p=i.m_count,y=i.m_vertices,d=i.m_normals,f=0;f<p;++f){var v=n.dot(d[f],n.sub(_,y[f]));if(v>u)return;v>l&&(l=v,c=f)}var x=c,A=x+1<p?x+1:0,b=y[x],g=y[A];if(l<s.EPSILON)return t.pointCount=1,t.type=r.e_faceA,t.localNormal.set(d[c]),t.localPoint.setCombine(.5,b,.5,g),t.points[0].localPoint=m.m_p,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=r.e_vertex);var B=n.dot(n.sub(_,b),n.sub(g,b)),w=n.dot(n.sub(_,g),n.sub(b,g));if(B<=0){if(n.distanceSquared(_,b)>u*u)return;t.pointCount=1,t.type=r.e_faceA,t.localNormal.setCombine(1,_,-1,b),t.localNormal.normalize(),t.localPoint=b,t.points[0].localPoint.set(m.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=r.e_vertex}else if(w<=0){if(n.distanceSquared(_,g)>u*u)return;t.pointCount=1,t.type=r.e_faceA,t.localNormal.setCombine(1,_,-1,g),t.localNormal.normalize(),t.localPoint.set(g),t.points[0].localPoint.set(m.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=r.e_vertex}else{var C=n.mid(b,g);if((l=n.dot(_,d[x])-n.dot(C,d[x]))>u)return;t.pointCount=1,t.type=r.e_faceA,t.localNormal.set(d[x]),t.localPoint.set(C),t.points[0].localPoint.set(m.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=r.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=r.e_vertex}}(t,e.getShape(),i,h.getShape(),a)}))},function(t,i,e){e(2);var s=e(1),o=e(5),n=e(0),r=e(3),m=e(4),a=(e(15),e(17)),h=e(18),_=e(23),c=e(28),l=e(20);a.addType(_.TYPE,l.TYPE,(function(t,i,e,s,o,n,r){v(t,e.getShape(),i,n.getShape(),o)})),a.addType(c.TYPE,l.TYPE,(function(t,i,e,s,o,n,r){var m=e.getShape(),a=new _;m.getChildEdge(a,s),v(t,a,i,n.getShape(),o)}));function u(){this.type,this.index,this.separation}var p=new u,y=new u,d=new function(){this.vertices=[],this.normals=[],this.count=0},f=new function(){this.i1,this.i2,this.v1,this.v2,this.normal=n.zero(),this.sideNormal1=n.zero(),this.sideOffset1,this.sideNormal2=n.zero(),this.sideOffset2};function v(t,i,e,a,_){var c=o.mulTXf(e,_),l=o.mulVec2(c,a.m_centroid),u=i.m_vertex0,v=i.m_vertex1,x=i.m_vertex2,A=i.m_vertex3,b=i.m_hasVertex0,g=i.m_hasVertex3,B=n.sub(x,v);B.normalize();var w,C=n.neo(B.y,-B.x),M=n.dot(C,n.sub(l,v)),I=0,z=0,S=!1,V=!1;if(b){var P=n.sub(v,u);P.normalize();var T=n.neo(P.y,-P.x);S=n.cross(P,B)>=0,I=n.dot(T,l)-n.dot(T,u)}if(g){var L=n.sub(A,x);L.normalize();var q=n.neo(L.y,-L.x);V=n.cross(B,L)>0,z=n.dot(q,l)-n.dot(q,x)}var F=n.zero(),k=n.zero(),j=n.zero();b&&g?S&&V?(w=I>=0||M>=0||z>=0)?(F.set(C),k.set(T),j.set(q)):(F.setMul(-1,C),k.setMul(-1,C),j.setMul(-1,C)):S?(w=I>=0||M>=0&&z>=0)?(F.set(C),k.set(T),j.set(C)):(F.setMul(-1,C),k.setMul(-1,q),j.setMul(-1,C)):V?(w=z>=0||I>=0&&M>=0)?(F.set(C),k.set(C),j.set(q)):(F.setMul(-1,C),k.setMul(-1,C),j.setMul(-1,T)):(w=I>=0&&M>=0&&z>=0)?(F.set(C),k.set(C),j.set(C)):(F.setMul(-1,C),k.setMul(-1,q),j.setMul(-1,T)):b?S?(w=I>=0||M>=0)?(F.set(C),k.set(T),j.setMul(-1,C)):(F.setMul(-1,C),k.set(C),j.setMul(-1,C)):(w=I>=0&&M>=0)?(F.set(C),k.set(C),j.setMul(-1,C)):(F.setMul(-1,C),k.set(C),j.setMul(-1,T)):g?V?(w=M>=0||z>=0)?(F.set(C),k.setMul(-1,C),j.set(q)):(F.setMul(-1,C),k.setMul(-1,C),j.set(C)):(w=M>=0&&z>=0)?(F.set(C),k.setMul(-1,C),j.set(C)):(F.setMul(-1,C),k.setMul(-1,q),j.set(C)):(w=M>=0)?(F.set(C),k.setMul(-1,C),j.setMul(-1,C)):(F.setMul(-1,C),k.set(C),j.set(C)),d.count=a.m_count;for(var D=0;D<a.m_count;++D)d.vertices[D]=o.mulVec2(c,a.m_vertices[D]),d.normals[D]=r.mulVec2(c.q,a.m_normals[D]);var R=2*m.polygonRadius;t.pointCount=0,p.type=1,p.index=w?0:1,p.separation=1/0;for(D=0;D<d.count;++D){(E=n.dot(F,n.sub(d.vertices[D],v)))<p.separation&&(p.separation=E)}if(-1!=p.type&&!(p.separation>R)){y.type=-1,y.index=-1,y.separation=-1/0;var O=n.neo(-F.y,F.x);for(D=0;D<d.count;++D){var E,Y=n.neg(d.normals[D]),J=n.dot(Y,n.sub(d.vertices[D],v)),N=n.dot(Y,n.sub(d.vertices[D],x));if((E=s.min(J,N))>R){y.type=2,y.index=D,y.separation=E;break}if(n.dot(Y,O)>=0){if(n.dot(n.sub(Y,j),F)<-m.angularSlop)continue}else if(n.dot(n.sub(Y,k),F)<-m.angularSlop)continue;E>y.separation&&(y.type=2,y.index=D,y.separation=E)}if(!(-1!=y.type&&y.separation>R)){var W;W=-1==y.type?p:y.separation>.98*p.separation+.001?y:p;var H=[new h.clipVertex,new h.clipVertex];if(1==W.type){t.type=h.e_faceA;var Z=0,X=n.dot(F,d.normals[0]);for(D=1;D<d.count;++D){var G=n.dot(F,d.normals[D]);G<X&&(X=G,Z=D)}var K=Z,U=K+1<d.count?K+1:0;H[0].v=d.vertices[K],H[0].id.cf.indexA=0,H[0].id.cf.indexB=K,H[0].id.cf.typeA=h.e_face,H[0].id.cf.typeB=h.e_vertex,H[1].v=d.vertices[U],H[1].id.cf.indexA=0,H[1].id.cf.indexB=U,H[1].id.cf.typeA=h.e_face,H[1].id.cf.typeB=h.e_vertex,w?(f.i1=0,f.i2=1,f.v1=v,f.v2=x,f.normal.set(C)):(f.i1=1,f.i2=0,f.v1=x,f.v2=v,f.normal.setMul(-1,C))}else t.type=h.e_faceB,H[0].v=v,H[0].id.cf.indexA=0,H[0].id.cf.indexB=W.index,H[0].id.cf.typeA=h.e_vertex,H[0].id.cf.typeB=h.e_face,H[1].v=x,H[1].id.cf.indexA=0,H[1].id.cf.indexB=W.index,H[1].id.cf.typeA=h.e_vertex,H[1].id.cf.typeB=h.e_face,f.i1=W.index,f.i2=f.i1+1<d.count?f.i1+1:0,f.v1=d.vertices[f.i1],f.v2=d.vertices[f.i2],f.normal.set(d.normals[f.i1]);f.sideNormal1.set(f.normal.y,-f.normal.x),f.sideNormal2.setMul(-1,f.sideNormal1),f.sideOffset1=n.dot(f.sideNormal1,f.v1),f.sideOffset2=n.dot(f.sideNormal2,f.v2);var Q=[new h.clipVertex,new h.clipVertex],$=[new h.clipVertex,new h.clipVertex];if(!(h.clipSegmentToLine(Q,H,f.sideNormal1,f.sideOffset1,f.i1)<m.maxManifoldPoints||h.clipSegmentToLine($,Q,f.sideNormal2,f.sideOffset2,f.i2)<m.maxManifoldPoints)){1==W.type?(t.localNormal=n.clone(f.normal),t.localPoint=n.clone(f.v1)):(t.localNormal=n.clone(a.m_normals[f.i1]),t.localPoint=n.clone(a.m_vertices[f.i1]));var tt=0;for(D=0;D<m.maxManifoldPoints;++D){if(n.dot(f.normal,n.sub($[D].v,f.v1))<=R){var it=t.points[tt];1==W.type?(it.localPoint=o.mulT(c,$[D].v),it.id=$[D].id):(it.localPoint=$[D].v,it.id.cf.typeA=$[D].id.cf.typeB,it.id.cf.typeB=$[D].id.cf.typeA,it.id.cf.indexA=$[D].id.cf.indexB,it.id.cf.indexB=$[D].id.cf.indexA),++tt}}t.pointCount=tt}}}}},function(t,i,e){t.exports=c;var s=e(6),o=e(4),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="distance-joint",a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={frequencyHz:0,dampingRatio:0};function c(t,i,e,o,m){if(!(this instanceof c))return new c(t,i,e,o,m);if(e&&o&&"m_type"in o&&"x"in e&&"y"in e){var h=e;e=o,o=h}t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_localAnchorA=r.clone(o?i.getLocalPoint(o):t.localAnchorA||r.zero()),this.m_localAnchorB=r.clone(m?e.getLocalPoint(m):t.localAnchorB||r.zero()),this.m_length=n.isFinite(t.length)?t.length:r.distance(i.getWorldPoint(this.m_localAnchorA),e.getWorldPoint(this.m_localAnchorB)),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=0,this.m_gamma=0,this.m_bias=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,length:this.m_length,impulse:this.m_impulse,gamma:this.m_gamma,bias:this.m_bias}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB),t.length>0?this.m_length=+t.length:t.length<0||(t.anchorA||t.anchorA||t.anchorA||t.anchorA)&&(this.m_length=r.distance(this.m_bodyA.getWorldPoint(this.m_localAnchorA),this.m_bodyB.getWorldPoint(this.m_localAnchorB)))},c.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},c.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},c.prototype.setLength=function(t){this.m_length=t},c.prototype.getLength=function(){return this.m_length},c.prototype.setFrequency=function(t){this.m_frequencyHz=t},c.prototype.getFrequency=function(){return this.m_frequencyHz},c.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},c.prototype.getDampingRatio=function(){return this.m_dampingRatio},c.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},c.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},c.prototype.getReactionForce=function(t){return r.mul(this.m_impulse,this.m_u).mul(t)},c.prototype.getReactionTorque=function(t){return 0},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyA.c_velocity.v,a=this.m_bodyA.c_velocity.w,h=this.m_bodyB.c_position.c,_=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=m.neo(e),p=m.neo(_);this.m_rA=m.mulVec2(u,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=m.mulVec2(p,r.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=r.sub(r.add(h,this.m_rB),r.add(i,this.m_rA));var y=this.m_u.length();y>o.linearSlop?this.m_u.mul(1/y):this.m_u.set(0,0);var d=r.cross(this.m_rA,this.m_u),f=r.cross(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*d*d+this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=0!=v?1/v:0,this.m_frequencyHz>0){var x=y-this.m_length,A=2*n.PI*this.m_frequencyHz,b=2*this.m_mass*this.m_dampingRatio*A,g=this.m_mass*A*A,B=t.dt;this.m_gamma=B*(b+B*g),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*g*this.m_gamma,v+=this.m_gamma,this.m_mass=0!=v?1/v:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var w=r.mul(this.m_impulse,this.m_u);s.subMul(this.m_invMassA,w),a-=this.m_invIA*r.cross(this.m_rA,w),c.addMul(this.m_invMassB,w),l+=this.m_invIB*r.cross(this.m_rB,w)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(s),this.m_bodyA.c_velocity.w=a,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=l},c.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,n=r.add(i,r.cross(e,this.m_rA)),m=r.add(s,r.cross(o,this.m_rB)),a=r.dot(this.m_u,m)-r.dot(this.m_u,n),h=-this.m_mass*(a+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=h;var _=r.mul(h,this.m_u);i.subMul(this.m_invMassA,_),e-=this.m_invIA*r.cross(this.m_rA,_),s.addMul(this.m_invMassB,_),o+=this.m_invIB*r.cross(this.m_rB,_),this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(s),this.m_bodyB.c_velocity.w=o},c.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,a=this.m_bodyB.c_position.a,h=m.neo(e),_=m.neo(a),c=m.mulSub(h,this.m_localAnchorA,this.m_localCenterA),l=m.mulSub(_,this.m_localAnchorB,this.m_localCenterB),u=r.sub(r.add(s,l),r.add(i,c)),p=u.normalize()-this.m_length;p=n.clamp(p,-o.maxLinearCorrection,o.maxLinearCorrection);var y=-this.m_mass*p,d=r.mul(y,u);return i.subMul(this.m_invMassA,d),e-=this.m_invIA*r.cross(c,d),s.addMul(this.m_invMassB,d),a+=this.m_invIB*r.cross(l,d),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(s),this.m_bodyB.c_position.a=a,n.abs(p)<o.linearSlop}},function(t,i,e){t.exports=c;e(2);var s=e(6),o=(e(4),e(1)),n=e(0),r=(e(7),e(10)),m=(e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="friction-joint",a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={maxForce:0,maxTorque:0};function c(t,i,e,o){if(!(this instanceof c))return new c(t,i,e,o);t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_localAnchorA=n.clone(o?i.getLocalPoint(o):t.localAnchorA||n.zero()),this.m_localAnchorB=n.clone(o?e.getLocalPoint(o):t.localAnchorB||n.zero()),this.m_linearImpulse=n.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,maxForce:this.m_maxForce,maxTorque:this.m_maxTorque,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB)},c.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},c.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},c.prototype.setMaxForce=function(t){this.m_maxForce=t},c.prototype.getMaxForce=function(){return this.m_maxForce},c.prototype.setMaxTorque=function(t){this.m_maxTorque=t},c.prototype.getMaxTorque=function(){return this.m_maxTorque},c.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},c.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},c.prototype.getReactionForce=function(t){return n.mul(t,this.m_linearImpulse)},c.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=m.neo(i),c=m.neo(o);this.m_rA=m.mulVec2(_,n.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=m.mulVec2(c,n.sub(this.m_localAnchorB,this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,y=this.m_invIB,d=new r;if(d.ex.x=l+u+p*this.m_rA.y*this.m_rA.y+y*this.m_rB.y*this.m_rB.y,d.ex.y=-p*this.m_rA.x*this.m_rA.y-y*this.m_rB.x*this.m_rB.y,d.ey.x=d.ex.y,d.ey.y=l+u+p*this.m_rA.x*this.m_rA.x+y*this.m_rB.x*this.m_rB.x,this.m_linearMass=d.getInverse(),this.m_angularMass=p+y,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var f=n.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);e.subMul(l,f),s-=p*(n.cross(this.m_rA,f)+this.m_angularImpulse),a.addMul(u,f),h+=y*(n.cross(this.m_rB,f)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=h},c.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,a=this.m_invMassA,h=this.m_invMassB,_=this.m_invIA,c=this.m_invIB,l=t.dt,u=m-e,p=-this.m_angularMass*u,y=this.m_angularImpulse,d=l*this.m_maxTorque;this.m_angularImpulse=o.clamp(this.m_angularImpulse+p,-d,d),e-=_*(p=this.m_angularImpulse-y),m+=c*p;u=n.sub(n.add(s,n.cross(m,this.m_rB)),n.add(i,n.cross(e,this.m_rA))),p=n.neg(r.mulVec2(this.m_linearMass,u)),y=this.m_linearImpulse;this.m_linearImpulse.add(p);d=l*this.m_maxForce;this.m_linearImpulse.lengthSquared()>d*d&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(d)),p=n.sub(this.m_linearImpulse,y),i.subMul(a,p),e-=_*n.cross(this.m_rA,p),s.addMul(h,p),m+=c*n.cross(this.m_rB,p),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=m},c.prototype.solvePositionConstraints=function(t){return!0}},function(t,i,e){t.exports=l;e(2);var s=e(6),o=e(4),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8),_=e(33);e(34);l.TYPE="gear-joint",a.TYPES[l.TYPE]=l,l._super=a,l.prototype=Object.create(l._super.prototype);var c={ratio:1};function l(t,i,e,o,h,u){if(!(this instanceof l))return new l(t,i,e,o,h,u);var p,y;t=s(t,c),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=l.TYPE,this.m_joint1=o||t.joint1,this.m_joint2=h||t.joint2,this.m_ratio=n.isFinite(u)?u:t.ratio,this.m_type1=this.m_joint1.getType(),this.m_type2=this.m_joint2.getType(),this.m_bodyC=this.m_joint1.getBodyA(),this.m_bodyA=this.m_joint1.getBodyB();var d=this.m_bodyA.m_xf,f=this.m_bodyA.m_sweep.a,v=this.m_bodyC.m_xf,x=this.m_bodyC.m_sweep.a;if(this.m_type1===_.TYPE){var A=this.m_joint1;this.m_localAnchorC=A.m_localAnchorA,this.m_localAnchorA=A.m_localAnchorB,this.m_referenceAngleA=A.m_referenceAngle,this.m_localAxisC=r.zero(),p=f-x-this.m_referenceAngleA}else{var b=this.m_joint1;this.m_localAnchorC=b.m_localAnchorA,this.m_localAnchorA=b.m_localAnchorB,this.m_referenceAngleA=b.m_referenceAngle,this.m_localAxisC=b.m_localXAxisA;var g=this.m_localAnchorC,B=m.mulTVec2(v.q,r.add(m.mul(d.q,this.m_localAnchorA),r.sub(d.p,v.p)));p=r.dot(B,this.m_localAxisC)-r.dot(g,this.m_localAxisC)}this.m_bodyD=this.m_joint2.getBodyA(),this.m_bodyB=this.m_joint2.getBodyB();var w=this.m_bodyB.m_xf,C=this.m_bodyB.m_sweep.a,M=this.m_bodyD.m_xf,I=this.m_bodyD.m_sweep.a;if(this.m_type2===_.TYPE){A=this.m_joint2;this.m_localAnchorD=A.m_localAnchorA,this.m_localAnchorB=A.m_localAnchorB,this.m_referenceAngleB=A.m_referenceAngle,this.m_localAxisD=r.zero(),y=C-I-this.m_referenceAngleB}else{b=this.m_joint2;this.m_localAnchorD=b.m_localAnchorA,this.m_localAnchorB=b.m_localAnchorB,this.m_referenceAngleB=b.m_referenceAngle,this.m_localAxisD=b.m_localXAxisA;var z=this.m_localAnchorD,S=m.mulTVec2(M.q,r.add(m.mul(w.q,this.m_localAnchorB),r.sub(w.p,M.p)));y=r.dot(S,this.m_localAxisD)-r.dot(z,this.m_localAxisD)}this.m_constant=p+this.m_ratio*y,this.m_impulse=0,this.m_lcA,this.m_lcB,this.m_lcC,this.m_lcD,this.m_mA,this.m_mB,this.m_mC,this.m_mD,this.m_iA,this.m_iB,this.m_iC,this.m_iD,this.m_JvAC,this.m_JvBD,this.m_JwA,this.m_JwB,this.m_JwC,this.m_JwD,this.m_mass}l.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,joint1:this.m_joint1,joint2:this.m_joint2,ratio:this.m_ratio}},l._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),t.joint1=e(a,t.joint1,i),t.joint2=e(a,t.joint2,i),new l(t)},l.prototype.getJoint1=function(){return this.m_joint1},l.prototype.getJoint2=function(){return this.m_joint2},l.prototype.setRatio=function(t){this.m_ratio=t},l.prototype.getRatio=function(){return this.m_ratio},l.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},l.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},l.prototype.getReactionForce=function(t){return r.mul(this.m_impulse,this.m_JvAC).mul(t)},l.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},l.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,h=this.m_bodyC.c_position.a,c=this.m_bodyC.c_velocity.v,l=this.m_bodyC.c_velocity.w,u=this.m_bodyD.c_position.a,p=this.m_bodyD.c_velocity.v,y=this.m_bodyD.c_velocity.w,d=m.neo(i),f=m.neo(o),v=m.neo(h),x=m.neo(u);if(this.m_mass=0,this.m_type1==_.TYPE)this.m_JvAC=r.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var A=m.mulVec2(v,this.m_localAxisC),b=m.mulSub(v,this.m_localAnchorC,this.m_lcC),g=m.mulSub(d,this.m_localAnchorA,this.m_lcA);this.m_JvAC=A,this.m_JwC=r.cross(b,A),this.m_JwA=r.cross(g,A),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==_.TYPE)this.m_JvBD=r.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{A=m.mulVec2(x,this.m_localAxisD);var B=m.mulSub(x,this.m_localAnchorD,this.m_lcD),w=m.mulSub(f,this.m_localAnchorB,this.m_lcB);this.m_JvBD=r.mul(this.m_ratio,A),this.m_JwD=this.m_ratio*r.cross(B,A),this.m_JwB=this.m_ratio*r.cross(w,A),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(e.addMul(this.m_mA*this.m_impulse,this.m_JvAC),s+=this.m_iA*this.m_impulse*this.m_JwA,n.addMul(this.m_mB*this.m_impulse,this.m_JvBD),a+=this.m_iB*this.m_impulse*this.m_JwB,c.subMul(this.m_mC*this.m_impulse,this.m_JvAC),l-=this.m_iC*this.m_impulse*this.m_JwC,p.subMul(this.m_mD*this.m_impulse,this.m_JvBD),y-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(n),this.m_bodyB.c_velocity.w=a,this.m_bodyC.c_velocity.v.set(c),this.m_bodyC.c_velocity.w=l,this.m_bodyD.c_velocity.v.set(p),this.m_bodyD.c_velocity.w=y},l.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,m=this.m_bodyC.c_velocity.w,a=this.m_bodyD.c_velocity.v,h=this.m_bodyD.c_velocity.w,_=r.dot(this.m_JvAC,i)-r.dot(this.m_JvAC,n)+r.dot(this.m_JvBD,s)-r.dot(this.m_JvBD,a);_+=this.m_JwA*e-this.m_JwC*m+(this.m_JwB*o-this.m_JwD*h);var c=-this.m_mass*_;this.m_impulse+=c,i.addMul(this.m_mA*c,this.m_JvAC),e+=this.m_iA*c*this.m_JwA,s.addMul(this.m_mB*c,this.m_JvBD),o+=this.m_iB*c*this.m_JwB,n.subMul(this.m_mC*c,this.m_JvAC),m-=this.m_iC*c*this.m_JwC,a.subMul(this.m_mD*c,this.m_JvBD),h-=this.m_iD*c*this.m_JwD,this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(s),this.m_bodyB.c_velocity.w=o,this.m_bodyC.c_velocity.v.set(n),this.m_bodyC.c_velocity.w=m,this.m_bodyD.c_velocity.v.set(a),this.m_bodyD.c_velocity.w=h},l.prototype.solvePositionConstraints=function(t){var i,e,s,n,a,h,c,l,u=this.m_bodyA.c_position.c,p=this.m_bodyA.c_position.a,y=this.m_bodyB.c_position.c,d=this.m_bodyB.c_position.a,f=this.m_bodyC.c_position.c,v=this.m_bodyC.c_position.a,x=this.m_bodyD.c_position.c,A=this.m_bodyD.c_position.a,b=m.neo(p),g=m.neo(d),B=m.neo(v),w=m.neo(A),C=0;if(this.m_type1==_.TYPE)s=r.zero(),a=1,c=1,C+=this.m_iA+this.m_iC,i=p-v-this.m_referenceAngleA;else{var M=m.mulVec2(B,this.m_localAxisC),I=m.mulSub(B,this.m_localAnchorC,this.m_lcC),z=m.mulSub(b,this.m_localAnchorA,this.m_lcA);s=M,c=r.cross(I,M),a=r.cross(z,M),C+=this.m_mC+this.m_mA+this.m_iC*c*c+this.m_iA*a*a;var S=r.sub(this.m_localAnchorC,this.m_lcC),V=m.mulTVec2(B,r.add(z,r.sub(u,f)));i=r.dot(r.sub(V,S),this.m_localAxisC)}if(this.m_type2==_.TYPE)n=r.zero(),h=this.m_ratio,l=this.m_ratio,C+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),e=d-A-this.m_referenceAngleB;else{M=m.mulVec2(w,this.m_localAxisD);var P=m.mulSub(w,this.m_localAnchorD,this.m_lcD),T=m.mulSub(g,this.m_localAnchorB,this.m_lcB);n=r.mul(this.m_ratio,M),l=this.m_ratio*r.cross(P,M),h=this.m_ratio*r.cross(T,M),C+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*l*l+this.m_iB*h*h;var L=r.sub(this.m_localAnchorD,this.m_lcD),q=m.mulTVec2(w,r.add(T,r.sub(y,x)));e=r.dot(q,this.m_localAxisD)-r.dot(L,this.m_localAxisD)}var F=i+this.m_ratio*e-this.m_constant,k=0;return C>0&&(k=-F/C),u.addMul(this.m_mA*k,s),p+=this.m_iA*k*a,y.addMul(this.m_mB*k,n),d+=this.m_iB*k*h,f.subMul(this.m_mC*k,s),v-=this.m_iC*k*c,x.subMul(this.m_mD*k,n),A-=this.m_iD*k*l,this.m_bodyA.c_position.c.set(u),this.m_bodyA.c_position.a=p,this.m_bodyB.c_position.c.set(y),this.m_bodyB.c_position.a=d,this.m_bodyC.c_position.c.set(f),this.m_bodyC.c_position.a=v,this.m_bodyD.c_position.c.set(x),this.m_bodyD.c_position.a=A,0<o.linearSlop}},function(t,i,e){t.exports=c;e(2);var s=e(6),o=(e(4),e(1)),n=e(0),r=(e(7),e(10)),m=(e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="motor-joint",a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={maxForce:1,maxTorque:1,correctionFactor:.3};function c(t,i,e){if(!(this instanceof c))return new c(t,i,e);t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_linearOffset=o.isFinite(t.linearOffset)?t.linearOffset:i.getLocalPoint(e.getPosition()),this.m_angularOffset=o.isFinite(t.angularOffset)?t.angularOffset:e.getAngle()-i.getAngle(),this.m_linearImpulse=n.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_correctionFactor=t.correctionFactor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_linearError,this.m_angularError,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,maxForce:this.m_maxForce,maxTorque:this.m_maxTorque,correctionFactor:this.m_correctionFactor,linearOffset:this.m_linearOffset,angularOffset:this.m_angularOffset}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB)},c.prototype.setMaxForce=function(t){this.m_maxForce=t},c.prototype.getMaxForce=function(){return this.m_maxForce},c.prototype.setMaxTorque=function(t){this.m_maxTorque=t},c.prototype.getMaxTorque=function(){return this.m_maxTorque},c.prototype.setCorrectionFactor=function(t){this.m_correctionFactor=t},c.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},c.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},c.prototype.getLinearOffset=function(){return this.m_linearOffset},c.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},c.prototype.getAngularOffset=function(){return this.m_angularOffset},c.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},c.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},c.prototype.getReactionForce=function(t){return n.mul(t,this.m_linearImpulse)},c.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,a=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,_=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,l=m.neo(e),u=m.neo(h);this.m_rA=m.mulVec2(l,n.neg(this.m_localCenterA)),this.m_rB=m.mulVec2(u,n.neg(this.m_localCenterB));var p=this.m_invMassA,y=this.m_invMassB,d=this.m_invIA,f=this.m_invIB,v=new r;if(v.ex.x=p+y+d*this.m_rA.y*this.m_rA.y+f*this.m_rB.y*this.m_rB.y,v.ex.y=-d*this.m_rA.x*this.m_rA.y-f*this.m_rB.x*this.m_rB.y,v.ey.x=v.ex.y,v.ey.y=p+y+d*this.m_rA.x*this.m_rA.x+f*this.m_rB.x*this.m_rB.x,this.m_linearMass=v.getInverse(),this.m_angularMass=d+f,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=n.zero(),this.m_linearError.addCombine(1,a,1,this.m_rB),this.m_linearError.subCombine(1,i,1,this.m_rA),this.m_linearError.sub(m.mulVec2(l,this.m_linearOffset)),this.m_angularError=h-e-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var x=n.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);s.subMul(p,x),o-=d*(n.cross(this.m_rA,x)+this.m_angularImpulse),_.addMul(y,x),c+=f*(n.cross(this.m_rB,x)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=s,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=_,this.m_bodyB.c_velocity.w=c},c.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,a=this.m_invMassA,h=this.m_invMassB,_=this.m_invIA,c=this.m_invIB,l=t.dt,u=t.inv_dt,p=m-e+u*this.m_correctionFactor*this.m_angularError,y=-this.m_angularMass*p,d=this.m_angularImpulse,f=l*this.m_maxTorque;this.m_angularImpulse=o.clamp(this.m_angularImpulse+y,-f,f),e-=_*(y=this.m_angularImpulse-d),m+=c*y,(p=n.zero()).addCombine(1,s,1,n.cross(m,this.m_rB)),p.subCombine(1,i,1,n.cross(e,this.m_rA)),p.addMul(u*this.m_correctionFactor,this.m_linearError);y=n.neg(r.mulVec2(this.m_linearMass,p)),d=n.clone(this.m_linearImpulse);this.m_linearImpulse.add(y);f=l*this.m_maxForce;this.m_linearImpulse.clamp(f),y=n.sub(this.m_linearImpulse,d),i.subMul(a,y),e-=_*n.cross(this.m_rA,y),s.addMul(h,y),m+=c*n.cross(this.m_rB,y),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=m},c.prototype.solvePositionConstraints=function(t){return!0}},function(t,i,e){t.exports=l;e(2);var s=e(6),o=e(1),n=e(0),r=(e(7),e(10)),m=(e(14),e(3)),a=(e(9),e(5)),h=(e(12),e(13),e(11)),_=e(8);l.TYPE="mouse-joint",h.TYPES[l.TYPE]=l,l._super=h,l.prototype=Object.create(l._super.prototype);var c={maxForce:0,frequencyHz:5,dampingRatio:.7};function l(t,i,e,o){if(!(this instanceof l))return new l(t,i,e,o);t=s(t,c),h.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=l.TYPE,this.m_targetA=o?n.clone(o):t.target||n.zero(),this.m_localAnchorB=a.mulTVec2(e.getTransform(),this.m_targetA),this.m_maxForce=t.maxForce,this.m_impulse=n.zero(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_beta=0,this.m_gamma=0,this.m_rB=n.zero(),this.m_localCenterB=n.zero(),this.m_invMassB=0,this.m_invIB=0,this.mass=new r,this.m_C=n.zero()}l.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,target:this.m_targetA,maxForce:this.m_maxForce,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,_localAnchorB:this.m_localAnchorB}},l._deserialize=function(t,i,e){(t=Object.assign({},t)).bodyA=e(_,t.bodyA,i),t.bodyB=e(_,t.bodyB,i),t.target=n(t.target);var s=new l(t);return t._localAnchorB&&(s.m_localAnchorB=t._localAnchorB),s},l.prototype.setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=n.clone(t)},l.prototype.getTarget=function(){return this.m_targetA},l.prototype.setMaxForce=function(t){this.m_maxForce=t},l.getMaxForce=function(){return this.m_maxForce},l.prototype.setFrequency=function(t){this.m_frequencyHz=t},l.prototype.getFrequency=function(){return this.m_frequencyHz},l.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},l.prototype.getDampingRatio=function(){return this.m_dampingRatio},l.prototype.getAnchorA=function(){return n.clone(this.m_targetA)},l.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},l.prototype.getReactionForce=function(t){return n.mul(t,this.m_impulse)},l.prototype.getReactionTorque=function(t){return 0*t},l.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},l.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyB.c_position,e=this.m_bodyB.c_velocity,s=i.c,a=i.a,h=e.v,_=e.w,c=m.neo(a),l=this.m_bodyB.getMass(),u=2*o.PI*this.m_frequencyHz,p=2*l*this.m_dampingRatio*u,y=l*(u*u),d=t.dt;this.m_gamma=d*(p+d*y),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=d*y*this.m_gamma,this.m_rB=m.mulVec2(c,n.sub(this.m_localAnchorB,this.m_localCenterB));var f=new r;f.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,f.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,f.ey.x=f.ex.y,f.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=f.getInverse(),this.m_C.set(s),this.m_C.addCombine(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),_*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),h.addMul(this.m_invMassB,this.m_impulse),_+=this.m_invIB*n.cross(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),e.v.set(h),e.w=_},l.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyB.c_velocity,e=n.clone(i.v),s=i.w,o=n.cross(s,this.m_rB);o.add(e),o.addCombine(1,this.m_C,this.m_gamma,this.m_impulse),o.neg();var m=r.mulVec2(this.m_mass,o),a=n.clone(this.m_impulse);this.m_impulse.add(m);var h=t.dt*this.m_maxForce;this.m_impulse.clamp(h),m=n.sub(this.m_impulse,a),e.addMul(this.m_invMassB,m),s+=this.m_invIB*n.cross(this.m_rB,m),i.v.set(e),i.w=s},l.prototype.solvePositionConstraints=function(t){return!0}},function(t,i,e){t.exports=c;e(2);var s=e(6),o=e(4),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="pulley-joint",c.MIN_PULLEY_LENGTH=2,a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={collideConnected:!0};function c(t,i,e,o,m,h,l,u){if(!(this instanceof c))return new c(t,i,e,o,m,h,l,u);t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_groundAnchorA=o||(t.groundAnchorA||r.neo(-1,1)),this.m_groundAnchorB=m||(t.groundAnchorB||r.neo(1,1)),this.m_localAnchorA=h?i.getLocalPoint(h):t.localAnchorA||r.neo(-1,0),this.m_localAnchorB=l?e.getLocalPoint(l):t.localAnchorB||r.neo(1,0),this.m_lengthA=n.isFinite(t.lengthA)?t.lengthA:r.distance(h,o),this.m_lengthB=n.isFinite(t.lengthB)?t.lengthB:r.distance(l,m),this.m_ratio=n.isFinite(u)?u:t.ratio,this.m_constant=this.m_lengthA+this.m_ratio*this.m_lengthB,this.m_impulse=0,this.m_uA,this.m_uB,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,groundAnchorA:this.m_groundAnchorA,groundAnchorB:this.m_groundAnchorB,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,lengthA:this.m_lengthA,lengthB:this.m_lengthB,ratio:this.m_ratio}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype.getGroundAnchorA=function(){return this.m_groundAnchorA},c.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},c.prototype.getLengthA=function(){return this.m_lengthA},c.prototype.getLengthB=function(){return this.m_lengthB},c.prototype.getRatio=function(){return this.m_ratio},c.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_groundAnchorA;return r.distance(t,i)},c.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=this.m_groundAnchorB;return r.distance(t,i)},c.prototype.shiftOrigin=function(t){this.m_groundAnchorA.sub(t),this.m_groundAnchorB.sub(t)},c.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},c.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},c.prototype.getReactionForce=function(t){return r.mul(this.m_impulse,this.m_uB).mul(t)},c.prototype.getReactionTorque=function(t){return 0},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyA.c_velocity.v,n=this.m_bodyA.c_velocity.w,a=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,_=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,l=m.neo(e),u=m.neo(h);this.m_rA=m.mulVec2(l,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=m.mulVec2(u,r.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=r.sub(r.add(i,this.m_rA),this.m_groundAnchorA),this.m_uB=r.sub(r.add(a,this.m_rB),this.m_groundAnchorB);var p=this.m_uA.length(),y=this.m_uB.length();p>10*o.linearSlop?this.m_uA.mul(1/p):this.m_uA.setZero(),y>10*o.linearSlop?this.m_uB.mul(1/y):this.m_uB.setZero();var d=r.cross(this.m_rA,this.m_uA),f=r.cross(this.m_rB,this.m_uB),v=this.m_invMassA+this.m_invIA*d*d,x=this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=v+this.m_ratio*this.m_ratio*x,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var A=r.mul(-this.m_impulse,this.m_uA),b=r.mul(-this.m_ratio*this.m_impulse,this.m_uB);s.addMul(this.m_invMassA,A),n+=this.m_invIA*r.cross(this.m_rA,A),_.addMul(this.m_invMassB,b),c+=this.m_invIB*r.cross(this.m_rB,b)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=s,this.m_bodyA.c_velocity.w=n,this.m_bodyB.c_velocity.v=_,this.m_bodyB.c_velocity.w=c},c.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,n=r.add(i,r.cross(e,this.m_rA)),m=r.add(s,r.cross(o,this.m_rB)),a=-r.dot(this.m_uA,n)-this.m_ratio*r.dot(this.m_uB,m),h=-this.m_mass*a;this.m_impulse+=h;var _=r.mul(-h,this.m_uA),c=r.mul(-this.m_ratio*h,this.m_uB);i.addMul(this.m_invMassA,_),e+=this.m_invIA*r.cross(this.m_rA,_),s.addMul(this.m_invMassB,c),o+=this.m_invIB*r.cross(this.m_rB,c),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=o},c.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,a=this.m_bodyB.c_position.a,h=m.neo(e),_=m.neo(a),c=m.mulVec2(h,r.sub(this.m_localAnchorA,this.m_localCenterA)),l=m.mulVec2(_,r.sub(this.m_localAnchorB,this.m_localCenterB)),u=r.sub(r.add(i,this.m_rA),this.m_groundAnchorA),p=r.sub(r.add(s,this.m_rB),this.m_groundAnchorB),y=u.length(),d=p.length();y>10*o.linearSlop?u.mul(1/y):u.setZero(),d>10*o.linearSlop?p.mul(1/d):p.setZero();var f=r.cross(c,u),v=r.cross(l,p),x=this.m_invMassA+this.m_invIA*f*f,A=this.m_invMassB+this.m_invIB*v*v,b=x+this.m_ratio*this.m_ratio*A;b>0&&(b=1/b);var g=this.m_constant-y-this.m_ratio*d,B=n.abs(g),w=-b*g,C=r.mul(-w,u),M=r.mul(-this.m_ratio*w,p);return i.addMul(this.m_invMassA,C),e+=this.m_invIA*r.cross(c,C),s.addMul(this.m_invMassB,M),a+=this.m_invIB*r.cross(l,M),this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=s,this.m_bodyB.c_position.a=a,B<o.linearSlop}},function(t,i,e){t.exports=c;var s=e(6),o=e(4),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="rope-joint",a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={maxLength:0};function c(t,i,e,o){if(!(this instanceof c))return new c(t,i,e,o);t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_localAnchorA=o?i.getLocalPoint(o):t.localAnchorA||r.neo(-1,0),this.m_localAnchorB=o?e.getLocalPoint(o):t.localAnchorB||r.neo(1,0),this.m_maxLength=t.maxLength,this.m_mass=0,this.m_impulse=0,this.m_length=0,this.m_state=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,maxLength:this.m_maxLength}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},c.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},c.prototype.setMaxLength=function(t){this.m_maxLength=t},c.prototype.getMaxLength=function(){return this.m_maxLength},c.prototype.getLimitState=function(){return this.m_state},c.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},c.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},c.prototype.getReactionForce=function(t){return r.mul(this.m_impulse,this.m_u).mul(t)},c.prototype.getReactionTorque=function(t){return 0},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyA.c_velocity.v,n=this.m_bodyA.c_velocity.w,a=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,_=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,l=m.neo(e),u=m.neo(h);this.m_rA=m.mulSub(l,this.m_localAnchorA,this.m_localCenterA),this.m_rB=m.mulSub(u,this.m_localAnchorB,this.m_localCenterB),this.m_u=r.zero(),this.m_u.addCombine(1,a,1,this.m_rB),this.m_u.subCombine(1,i,1,this.m_rA),this.m_length=this.m_u.length();var p=this.m_length-this.m_maxLength;if(this.m_state=p>0?2:0,!(this.m_length>o.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var y=r.cross(this.m_rA,this.m_u),d=r.cross(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*d*d;if(this.m_mass=0!=f?1/f:0,t.warmStarting){this.m_impulse*=t.dtRatio;var v=r.mul(this.m_impulse,this.m_u);s.subMul(this.m_invMassA,v),n-=this.m_invIA*r.cross(this.m_rA,v),_.addMul(this.m_invMassB,v),c+=this.m_invIB*r.cross(this.m_rB,v)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(s),this.m_bodyA.c_velocity.w=n,this.m_bodyB.c_velocity.v.set(_),this.m_bodyB.c_velocity.w=c},c.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,m=r.addCross(i,e,this.m_rA),a=r.addCross(s,o,this.m_rB),h=this.m_length-this.m_maxLength,_=r.dot(this.m_u,r.sub(a,m));h<0&&(_+=t.inv_dt*h);var c=-this.m_mass*_,l=this.m_impulse;this.m_impulse=n.min(0,this.m_impulse+c),c=this.m_impulse-l;var u=r.mul(c,this.m_u);i.subMul(this.m_invMassA,u),e-=this.m_invIA*r.cross(this.m_rA,u),s.addMul(this.m_invMassB,u),o+=this.m_invIB*r.cross(this.m_rB,u),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=o},c.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,a=this.m_bodyB.c_position.a,h=m.neo(e),_=m.neo(a),c=m.mulSub(h,this.m_localAnchorA,this.m_localCenterA),l=m.mulSub(_,this.m_localAnchorB,this.m_localCenterB),u=r.zero();u.addCombine(1,s,1,l),u.subCombine(1,i,1,c);var p=u.normalize(),y=p-this.m_maxLength;y=n.clamp(y,0,o.maxLinearCorrection);var d=-this.m_mass*y,f=r.mul(d,u);return i.subMul(this.m_invMassA,f),e-=this.m_invIA*r.cross(c,f),s.addMul(this.m_invMassB,f),a+=this.m_invIB*r.cross(l,f),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(s),this.m_bodyB.c_position.a=a,p-this.m_maxLength<o.linearSlop}},function(t,i,e){t.exports=u;var s=e(6),o=e(4),n=e(1),r=e(0),m=e(7),a=(e(10),e(14)),h=e(3),_=(e(9),e(5),e(12),e(13),e(11)),c=e(8);u.TYPE="weld-joint",_.TYPES[u.TYPE]=u,u._super=_,u.prototype=Object.create(u._super.prototype);var l={frequencyHz:0,dampingRatio:0};function u(t,i,e,o){if(!(this instanceof u))return new u(t,i,e,o);t=s(t,l),_.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=u.TYPE,this.m_localAnchorA=r.clone(o?i.getLocalPoint(o):t.localAnchorA||r.zero()),this.m_localAnchorB=r.clone(o?e.getLocalPoint(o):t.localAnchorB||r.zero()),this.m_referenceAngle=n.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=m(),this.m_bias=0,this.m_gamma=0,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new a}u.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,referenceAngle:this.m_referenceAngle}},u._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(c,t.bodyA,i),t.bodyB=e(c,t.bodyB,i),new u(t)},u.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB)},u.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},u.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},u.prototype.getReferenceAngle=function(){return this.m_referenceAngle},u.prototype.setFrequency=function(t){this.m_frequencyHz=t},u.prototype.getFrequency=function(){return this.m_frequencyHz},u.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},u.prototype.getDampingRatio=function(){return this.m_dampingRatio},u.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},u.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},u.prototype.getReactionForce=function(t){return r.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},u.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},u.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,c=h.neo(i),l=h.neo(o);this.m_rA=h.mulVec2(c,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=h.mulVec2(l,r.sub(this.m_localAnchorB,this.m_localCenterB));var u=this.m_invMassA,p=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,f=new a;if(f.ex.x=u+p+this.m_rA.y*this.m_rA.y*y+this.m_rB.y*this.m_rB.y*d,f.ey.x=-this.m_rA.y*this.m_rA.x*y-this.m_rB.y*this.m_rB.x*d,f.ez.x=-this.m_rA.y*y-this.m_rB.y*d,f.ex.y=f.ey.x,f.ey.y=u+p+this.m_rA.x*this.m_rA.x*y+this.m_rB.x*this.m_rB.x*d,f.ez.y=this.m_rA.x*y+this.m_rB.x*d,f.ex.z=f.ez.x,f.ey.z=f.ez.y,f.ez.z=y+d,this.m_frequencyHz>0){f.getInverse22(this.m_mass);var v=y+d,x=v>0?1/v:0,A=o-i-this.m_referenceAngle,b=2*n.PI*this.m_frequencyHz,g=2*x*this.m_dampingRatio*b,B=x*b*b,w=t.dt;this.m_gamma=w*(g+w*B),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=A*w*B*this.m_gamma,v+=this.m_gamma,this.m_mass.ez.z=0!=v?1/v:0}else 0==f.ez.z?(f.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(f.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var C=r.neo(this.m_impulse.x,this.m_impulse.y);e.subMul(u,C),s-=y*(r.cross(this.m_rA,C)+this.m_impulse.z),m.addMul(p,C),_+=d*(r.cross(this.m_rB,C)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=_},u.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_velocity.v,o=this.m_bodyB.c_velocity.w,n=this.m_invMassA,h=this.m_invMassB,_=this.m_invIA,c=this.m_invIB;if(this.m_frequencyHz>0){var l=o-e,u=-this.m_mass.ez.z*(l+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=u,e-=_*u,o+=c*u,(d=r.zero()).addCombine(1,s,1,r.cross(o,this.m_rB)),d.subCombine(1,i,1,r.cross(e,this.m_rA));var p=r.neg(a.mulVec2(this.m_mass,d));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y;var y=r.clone(p);i.subMul(n,y),e-=_*r.cross(this.m_rA,y),s.addMul(h,y),o+=c*r.cross(this.m_rB,y)}else{var d;(d=r.zero()).addCombine(1,s,1,r.cross(o,this.m_rB)),d.subCombine(1,i,1,r.cross(e,this.m_rA));l=o-e;var f=m(d.x,d.y,l),v=m.neg(a.mulVec3(this.m_mass,f));this.m_impulse.add(v);y=r.neo(v.x,v.y);i.subMul(n,y),e-=_*(r.cross(this.m_rA,y)+v.z),s.addMul(h,y),o+=c*(r.cross(this.m_rB,y)+v.z)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=s,this.m_bodyB.c_velocity.w=o},u.prototype.solvePositionConstraints=function(t){var i,e,s=this.m_bodyA.c_position.c,_=this.m_bodyA.c_position.a,c=this.m_bodyB.c_position.c,l=this.m_bodyB.c_position.a,u=h.neo(_),p=h.neo(l),y=this.m_invMassA,d=this.m_invMassB,f=this.m_invIA,v=this.m_invIB,x=h.mulVec2(u,r.sub(this.m_localAnchorA,this.m_localCenterA)),A=h.mulVec2(p,r.sub(this.m_localAnchorB,this.m_localCenterB)),b=new a;if(b.ex.x=y+d+x.y*x.y*f+A.y*A.y*v,b.ey.x=-x.y*x.x*f-A.y*A.x*v,b.ez.x=-x.y*f-A.y*v,b.ex.y=b.ey.x,b.ey.y=y+d+x.x*x.x*f+A.x*A.x*v,b.ez.y=x.x*f+A.x*v,b.ex.z=b.ez.x,b.ey.z=b.ez.y,b.ez.z=f+v,this.m_frequencyHz>0){(B=r.zero()).addCombine(1,c,1,A),B.subCombine(1,s,1,x),i=B.length(),e=0;var g=r.neg(b.solve22(B));s.subMul(y,g),_-=f*r.cross(x,g),c.addMul(d,g),l+=v*r.cross(A,g)}else{var B;(B=r.zero()).addCombine(1,c,1,A),B.subCombine(1,s,1,x);var w=l-_-this.m_referenceAngle;i=B.length(),e=n.abs(w);var C=m(B.x,B.y,w),M=m();if(b.ez.z>0)M=m.neg(b.solve33(C));else{var I=r.neg(b.solve22(B));M.set(I.x,I.y,0)}g=r.neo(M.x,M.y);s.subMul(y,g),_-=f*(r.cross(x,g)+M.z),c.addMul(d,g),l+=v*(r.cross(A,g)+M.z)}return this.m_bodyA.c_position.c=s,this.m_bodyA.c_position.a=_,this.m_bodyB.c_position.c=c,this.m_bodyB.c_position.a=l,i<=o.linearSlop&&e<=o.angularSlop}},function(t,i,e){t.exports=c;var s=e(6),o=e(4),n=e(1),r=e(0),m=(e(7),e(10),e(14),e(3)),a=(e(9),e(5),e(12),e(13),e(11)),h=e(8);c.TYPE="wheel-joint",a.TYPES[c.TYPE]=c,c._super=a,c.prototype=Object.create(c._super.prototype);var _={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7};function c(t,i,e,o,n){if(!(this instanceof c))return new c(t,i,e,o,n);t=s(t,_),a.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=c.TYPE,this.m_localAnchorA=r.clone(o?i.getLocalPoint(o):t.localAnchorA||r.zero()),this.m_localAnchorB=r.clone(o?e.getLocalPoint(o):t.localAnchorB||r.zero()),this.m_localXAxisA=r.clone(n?i.getLocalVector(n):t.localAxisA||t.localAxis||r.neo(1,0)),this.m_localYAxisA=r.cross(1,this.m_localXAxisA),this.m_mass=0,this.m_impulse=0,this.m_motorMass=0,this.m_motorImpulse=0,this.m_springMass=0,this.m_springImpulse=0,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableMotor=t.enableMotor,this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_bias=0,this.m_gamma=0,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_ax=r.zero(),this.m_ay=r.zero(),this.m_sAx,this.m_sBx,this.m_sAy,this.m_sBy}c.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,enableMotor:this.m_enableMotor,maxMotorTorque:this.m_maxMotorTorque,motorSpeed:this.m_motorSpeed,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,localAxisA:this.m_localXAxisA}},c._deserialize=function(t,i,e){return(t=Object.assign({},t)).bodyA=e(h,t.bodyA,i),t.bodyB=e(h,t.bodyB,i),new c(t)},c.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.set(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.set(t.localAnchorA),t.anchorB?this.m_localAnchorB.set(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.set(t.localAnchorB),t.localAxisA&&(this.m_localXAxisA.set(t.localAxisA),this.m_localYAxisA.set(r.cross(1,t.localAxisA)))},c.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},c.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},c.prototype.getLocalAxisA=function(){return this.m_localXAxisA},c.prototype.getJointTranslation=function(){var t=this.m_bodyA,i=this.m_bodyB,e=t.getWorldPoint(this.m_localAnchorA),s=i.getWorldPoint(this.m_localAnchorB),o=r.sub(s,e),n=t.getWorldVector(this.m_localXAxisA);return r.dot(o,n)},c.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},c.prototype.isMotorEnabled=function(){return this.m_enableMotor},c.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},c.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},c.prototype.getMotorSpeed=function(){return this.m_motorSpeed},c.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},c.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},c.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},c.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},c.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},c.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},c.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},c.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},c.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},c.prototype.getReactionForce=function(t){return r.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax).mul(t)},c.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},c.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_invMassA,e=this.m_invMassB,s=this.m_invIA,o=this.m_invIB,a=this.m_bodyA.c_position.c,h=this.m_bodyA.c_position.a,_=this.m_bodyA.c_velocity.v,c=this.m_bodyA.c_velocity.w,l=this.m_bodyB.c_position.c,u=this.m_bodyB.c_position.a,p=this.m_bodyB.c_velocity.v,y=this.m_bodyB.c_velocity.w,d=m.neo(h),f=m.neo(u),v=m.mulVec2(d,r.sub(this.m_localAnchorA,this.m_localCenterA)),x=m.mulVec2(f,r.sub(this.m_localAnchorB,this.m_localCenterB));if((B=r.zero()).addCombine(1,l,1,x),B.subCombine(1,a,1,v),this.m_ay=m.mulVec2(d,this.m_localYAxisA),this.m_sAy=r.cross(r.add(B,v),this.m_ay),this.m_sBy=r.cross(x,this.m_ay),this.m_mass=i+e+s*this.m_sAy*this.m_sAy+o*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=m.mulVec2(d,this.m_localXAxisA),this.m_sAx=r.cross(r.add(B,v),this.m_ax),this.m_sBx=r.cross(x,this.m_ax);var A=i+e+s*this.m_sAx*this.m_sAx+o*this.m_sBx*this.m_sBx;if(A>0){this.m_springMass=1/A;var b=r.dot(B,this.m_ax),g=2*n.PI*this.m_frequencyHz,B=2*this.m_springMass*this.m_dampingRatio*g,w=this.m_springMass*g*g,C=t.dt;this.m_gamma=C*(B+C*w),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=b*C*w*this.m_gamma,this.m_springMass=A+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=s+o,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var M=r.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),I=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,z=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;_.subMul(this.m_invMassA,M),c-=this.m_invIA*I,p.addMul(this.m_invMassB,M),y+=this.m_invIB*z}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(_),this.m_bodyA.c_velocity.w=c,this.m_bodyB.c_velocity.v.set(p),this.m_bodyB.c_velocity.w=y},c.prototype.solveVelocityConstraints=function(t){var i=this.m_invMassA,e=this.m_invMassB,s=this.m_invIA,o=this.m_invIB,m=this.m_bodyA.c_velocity.v,a=this.m_bodyA.c_velocity.w,h=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,c=r.dot(this.m_ax,h)-r.dot(this.m_ax,m)+this.m_sBx*_-this.m_sAx*a,l=-this.m_springMass*(c+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=l;var u=r.mul(l,this.m_ax),p=l*this.m_sAx,y=l*this.m_sBx;m.subMul(i,u),a-=s*p,h.addMul(e,u);c=(_+=o*y)-a-this.m_motorSpeed,l=-this.m_motorMass*c;var d=this.m_motorImpulse,f=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=n.clamp(this.m_motorImpulse+l,-f,f),a-=s*(l=this.m_motorImpulse-d),_+=o*l;c=r.dot(this.m_ay,h)-r.dot(this.m_ay,m)+this.m_sBy*_-this.m_sAy*a,l=-this.m_mass*c;this.m_impulse+=l;u=r.mul(l,this.m_ay),p=l*this.m_sAy,y=l*this.m_sBy;m.subMul(i,u),a-=s*p,h.addMul(e,u),_+=o*y,this.m_bodyA.c_velocity.v.set(m),this.m_bodyA.c_velocity.w=a,this.m_bodyB.c_velocity.v.set(h),this.m_bodyB.c_velocity.w=_},c.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,a=this.m_bodyB.c_position.a,h=m.neo(e),_=m.neo(a),c=m.mulVec2(h,r.sub(this.m_localAnchorA,this.m_localCenterA)),l=m.mulVec2(_,r.sub(this.m_localAnchorB,this.m_localCenterB)),u=r.zero();u.addCombine(1,s,1,l),u.subCombine(1,i,1,c);var p,y=m.mulVec2(h,this.m_localYAxisA),d=r.cross(r.add(u,c),y),f=r.cross(l,y),v=r.dot(u,y),x=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;p=0!=x?-v/x:0;var A=r.mul(p,y),b=p*d,g=p*f;return i.subMul(this.m_invMassA,A),e-=this.m_invIA*b,s.addMul(this.m_invMassB,A),a+=this.m_invIB*g,this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(s),this.m_bodyB.c_position.a=a,n.abs(v)<=o.linearSlop}}])}));
//# sourceMappingURL=planck.min.js.map